/**
 * Speech API
 * The OCI Speech Service harnesses the power of spoken language by allowing developers to easily convert file-based data containing human speech into highly accurate text transcriptions.
 * OpenAPI spec version: 20220101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The information about new Transcription Job.
 */
export interface CreateTranscriptionJobDetails {
    /**
     * Transcription job name.
     */
    "displayName"?: string;
    /**
     * The OCID of the compartment that contains the transcriptionJob.
     */
    "compartmentId": string;
    /**
     * Transcription job description.
     */
    "description"?: string;
    "modelDetails"?: model.TranscriptionModelDetails;
    "normalization"?: model.TranscriptionNormalization;
    "inputLocation": model.ObjectListFileInputLocation | model.ObjectListInlineInputLocation;
    "outputLocation": model.OutputLocation;
    /**
     * Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
     * Example: `{\"bar-key\": \"value\"}`
     *
     */
    "freeformTags"?: {
        [key: string]: string;
    };
    /**
     * Defined tags for this resource. Each key is predefined and scoped to a namespace.
     * Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`
     *
     */
    "definedTags"?: {
        [key: string]: {
            [key: string]: any;
        };
    };
}
export declare namespace CreateTranscriptionJobDetails {
    function getJsonObj(obj: CreateTranscriptionJobDetails): object;
    function getDeserializedJsonObj(obj: CreateTranscriptionJobDetails): object;
}
