/**
 * VisionService API
 * A description of the VisionService API.
 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about how to analyze a document.
 */
export interface AnalyzeDocumentDetails {
    /**
     * Types of document analysis requested.
     */
    "features": Array<model.DocumentFeature>;
    "document": model.ObjectStorageDocumentDetails | model.InlineDocumentDetails;
    /**
     * The OCID of the compartment that calls the API.
     */
    "compartmentId"?: string;
    "outputLocation"?: model.OutputLocation;
    /**
     * Language of the document, abbreviated according to ISO 639-2.
     */
    "language"?: model.DocumentLanguage;
    /**
     * The type of document.
     */
    "documentType"?: model.DocumentType;
}
export declare namespace AnalyzeDocumentDetails {
    function getJsonObj(obj: AnalyzeDocumentDetails): object;
    function getDeserializedJsonObj(obj: AnalyzeDocumentDetails): object;
}
