/**
 * VisionService API
 * A description of the VisionService API.
 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Image analysis results.
 */
export interface AnalyzeImageResult {
    /**
     * Detected objects.
     */
    "imageObjects"?: Array<model.ImageObject>;
    /**
     * Image classification labels.
     */
    "labels"?: Array<model.Label>;
    /**
     * ontologyClasses of image labels.
     */
    "ontologyClasses"?: Array<model.OntologyClass>;
    "imageText"?: model.ImageText;
    /**
     * Image classification model version.
     */
    "imageClassificationModelVersion"?: string;
    /**
     * Object detection model version.
     */
    "objectDetectionModelVersion"?: string;
    /**
     * Text detection model version.
     */
    "textDetectionModelVersion"?: string;
    /**
     * Errors encountered during image analysis.
     */
    "errors"?: Array<model.ProcessingError>;
}
export declare namespace AnalyzeImageResult {
    function getJsonObj(obj: AnalyzeImageResult): object;
    function getDeserializedJsonObj(obj: AnalyzeImageResult): object;
}
