/**
 * VisionService API
 * A description of the VisionService API.
 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A single cell in a table.
 */
export interface Cell {
    /**
     * Text recognized in the cell.
     */
    "text": string;
    /**
     * Index of the cell inside the row. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "rowIndex": number;
    /**
     * Index of the cell inside the column. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "columnIndex": number;
    /**
     * Confidence score between 0 to 1. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "confidence": number;
    "boundingPolygon": model.BoundingPolygon;
    /**
     * Words detected in the cell.
     */
    "wordIndexes": Array<number>;
}
export declare namespace Cell {
    function getJsonObj(obj: Cell): object;
    function getDeserializedJsonObj(obj: Cell): object;
}
