/**
 * VisionService API
 * A description of the VisionService API.
 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Details about the batch document analysis.
 */
export interface CreateDocumentJobDetails {
    "inputLocation": model.ObjectListInlineInputLocation;
    /**
     * List of document analysis types requested.
     */
    "features": Array<model.DocumentFeature>;
    "outputLocation": model.OutputLocation;
    /**
     * Compartment identifier from the requester.
     */
    "compartmentId"?: string;
    /**
     * Document job display name.
     */
    "displayName"?: string;
    /**
     * Language of the document, abbreviated according to ISO 639-2.
     */
    "language"?: model.DocumentLanguage;
    /**
     * The type of documents.
     */
    "documentType"?: model.DocumentType;
    /**
     * Whether to generate a Zip file containing the results.
     */
    "isZipOutputEnabled"?: boolean;
}
export declare namespace CreateDocumentJobDetails {
    function getJsonObj(obj: CreateDocumentJobDetails): object;
    function getDeserializedJsonObj(obj: CreateDocumentJobDetails): object;
}
