/**
 * VisionService API
 * A description of the VisionService API.
 * OpenAPI spec version: 20220125
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * One page document analysis result.
 */
export interface Page {
    /**
     * Document page number. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "pageNumber": number;
    "dimensions"?: model.Dimensions;
    /**
     * An array of detected document types.
     */
    "detectedDocumentTypes"?: Array<model.DetectedDocumentType>;
    /**
     * An array of detected languages.
     */
    "detectedLanguages"?: Array<model.DetectedLanguage>;
    /**
     * Words detected on the page.
     */
    "words"?: Array<model.Word>;
    /**
     * Text lines detected on the page.
     */
    "lines"?: Array<model.Line>;
    /**
     * Tables detected on the page.
     */
    "tables"?: Array<model.Table>;
    /**
     * Form fields detected on the page.
     */
    "documentFields"?: Array<model.DocumentField>;
}
export declare namespace Page {
    function getJsonObj(obj: Page): object;
    function getDeserializedJsonObj(obj: Page): object;
}
