/**
 * Cloud Guard API
 * Use the Cloud Guard API to automate processes that you would otherwise perform through the Cloud Guard Console.

**Note:** You can perform Create, Update, and Delete operations only from the reporting region of your Cloud Guard tenancy. You can perform Read operations from any region.

 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Composite Condition object with nested Condition
 */
export interface CompositeCondition extends model.Condition {
    "leftOperand"?: model.SimpleCondition | model.CompositeCondition;
    "compositeOperator"?: CompositeCondition.CompositeOperator;
    "rightOperand"?: model.SimpleCondition | model.CompositeCondition;
    "kind": string;
}
export declare namespace CompositeCondition {
    enum CompositeOperator {
        And = "AND",
        Or = "OR",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: CompositeCondition, isParentJsonObj?: boolean): object;
    const kind = "COMPOSITE";
    function getDeserializedJsonObj(obj: CompositeCondition, isParentJsonObj?: boolean): object;
}
