/**
 * Cloud Guard API
 * Use the Cloud Guard API to automate processes that you would otherwise perform through the Cloud Guard Console.

**Note:** You can perform Create, Update, and Delete operations only from the reporting region of your Cloud Guard tenancy. You can perform Read operations from any region.

 * OpenAPI spec version: 20200131
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Summary of DetectorRecipe
 */
export interface TargetDetectorRecipeSummary {
    /**
     * Unique identifier that is immutable on creation
     */
    "id": string;
    /**
     * Compartment Identifier
     */
    "compartmentId": string;
    /**
     * DetectorRecipe Identifier Name
     */
    "displayName": string;
    /**
     * DetectorRecipe Description
     */
    "description": string;
    /**
     * Owner of DetectorRecipe
     */
    "owner": model.OwnerType;
    /**
     * Unique identifier for Detector Recipe of which this is an extension
     */
    "detectorRecipeId": string;
    /**
     * Type of detector
     */
    "detector"?: model.DetectorEnum;
    /**
     * The current state of the resource.
     */
    "lifecycleState"?: model.LifecycleState;
    /**
     * The date and time the target detector recipe was created. Format defined by RFC3339.
     */
    "timeCreated"?: Date;
    /**
     * The date and time the target detector recipe was updated. Format defined by RFC3339.
     */
    "timeUpdated"?: Date;
    /**
     * A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in Failed state.
     */
    "lifecycleDetails"?: string;
    /**
     * The number of days for which source data is retained Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "sourceDataRetention"?: number;
}
export declare namespace TargetDetectorRecipeSummary {
    function getJsonObj(obj: TargetDetectorRecipeSummary): object;
    function getDeserializedJsonObj(obj: TargetDetectorRecipeSummary): object;
}
