"use strict";
/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateEntityShapeDetails = void 0;
const model = __importStar(require("../model"));
var CreateEntityShapeDetails;
(function (CreateEntityShapeDetails) {
    let EntityType;
    (function (EntityType) {
        EntityType["Table"] = "TABLE";
        EntityType["View"] = "VIEW";
        EntityType["File"] = "FILE";
        EntityType["Sql"] = "SQL";
    })(EntityType = CreateEntityShapeDetails.EntityType || (CreateEntityShapeDetails.EntityType = {}));
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "shape": obj.shape ? model.Shape.getJsonObj(obj.shape) : undefined,
            "uniqueKeys": obj.uniqueKeys
                ? obj.uniqueKeys.map(item => {
                    return model.UniqueKey.getJsonObj(item);
                })
                : undefined,
            "foreignKeys": obj.foreignKeys
                ? obj.foreignKeys.map(item => {
                    return model.ForeignKey.getJsonObj(item);
                })
                : undefined,
            "types": obj.types ? model.TypeLibrary.getJsonObj(obj.types) : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "DATA_STORE_ENTITY":
                    return model.CreateEntityShapeFromDataStore.getJsonObj(jsonObj, true);
                case "TABLE_ENTITY":
                    return model.CreateEntityShapeFromTable.getJsonObj(jsonObj, true);
                case "SQL_ENTITY":
                    return model.CreateEntityShapeFromSQL.getJsonObj(jsonObj, true);
                case "FILE_ENTITY":
                    return model.CreateEntityShapeFromFile.getJsonObj(jsonObj, true);
                case "VIEW_ENTITY":
                    return model.CreateEntityShapeFromView.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    CreateEntityShapeDetails.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef
                ? model.ParentReference.getDeserializedJsonObj(obj.parentRef)
                : undefined,
            "shape": obj.shape ? model.Shape.getDeserializedJsonObj(obj.shape) : undefined,
            "uniqueKeys": obj.uniqueKeys
                ? obj.uniqueKeys.map(item => {
                    return model.UniqueKey.getDeserializedJsonObj(item);
                })
                : undefined,
            "foreignKeys": obj.foreignKeys
                ? obj.foreignKeys.map(item => {
                    return model.ForeignKey.getDeserializedJsonObj(item);
                })
                : undefined,
            "types": obj.types ? model.TypeLibrary.getDeserializedJsonObj(obj.types) : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "DATA_STORE_ENTITY":
                    return model.CreateEntityShapeFromDataStore.getDeserializedJsonObj(jsonObj, true);
                case "TABLE_ENTITY":
                    return model.CreateEntityShapeFromTable.getDeserializedJsonObj(jsonObj, true);
                case "SQL_ENTITY":
                    return model.CreateEntityShapeFromSQL.getDeserializedJsonObj(jsonObj, true);
                case "FILE_ENTITY":
                    return model.CreateEntityShapeFromFile.getDeserializedJsonObj(jsonObj, true);
                case "VIEW_ENTITY":
                    return model.CreateEntityShapeFromView.getDeserializedJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    CreateEntityShapeDetails.getDeserializedJsonObj = getDeserializedJsonObj;
})(CreateEntityShapeDetails = exports.CreateEntityShapeDetails || (exports.CreateEntityShapeDetails = {}));
//# sourceMappingURL=create-entity-shape-details.js.map