"use strict";
/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataEntitySummaryFromFile = void 0;
const model = __importStar(require("../model"));
var DataEntitySummaryFromFile;
(function (DataEntitySummaryFromFile) {
    let EntityType;
    (function (EntityType) {
        EntityType["Table"] = "TABLE";
        EntityType["View"] = "VIEW";
        EntityType["File"] = "FILE";
        EntityType["Sql"] = "SQL";
        EntityType["DataStore"] = "DATA_STORE";
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        EntityType["UnknownValue"] = "UNKNOWN_VALUE";
    })(EntityType = DataEntitySummaryFromFile.EntityType || (DataEntitySummaryFromFile.EntityType = {}));
    function getJsonObj(obj, isParentJsonObj) {
        const jsonObj = Object.assign(Object.assign({}, (isParentJsonObj
            ? obj
            : model.DataEntitySummary.getJsonObj(obj))), {
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "shape": obj.shape ? model.Shape.getJsonObj(obj.shape) : undefined,
            "uniqueKeys": obj.uniqueKeys
                ? obj.uniqueKeys.map(item => {
                    return model.UniqueKey.getJsonObj(item);
                })
                : undefined,
            "foreignKeys": obj.foreignKeys
                ? obj.foreignKeys.map(item => {
                    return model.ForeignKey.getJsonObj(item);
                })
                : undefined,
            "dataFormat": obj.dataFormat ? model.DataFormat.getJsonObj(obj.dataFormat) : undefined
        });
        return jsonObj;
    }
    DataEntitySummaryFromFile.getJsonObj = getJsonObj;
    DataEntitySummaryFromFile.modelType = "FILE_ENTITY";
    function getDeserializedJsonObj(obj, isParentJsonObj) {
        const jsonObj = Object.assign(Object.assign({}, (isParentJsonObj
            ? obj
            : model.DataEntitySummary.getDeserializedJsonObj(obj))), {
            "parentRef": obj.parentRef
                ? model.ParentReference.getDeserializedJsonObj(obj.parentRef)
                : undefined,
            "shape": obj.shape ? model.Shape.getDeserializedJsonObj(obj.shape) : undefined,
            "uniqueKeys": obj.uniqueKeys
                ? obj.uniqueKeys.map(item => {
                    return model.UniqueKey.getDeserializedJsonObj(item);
                })
                : undefined,
            "foreignKeys": obj.foreignKeys
                ? obj.foreignKeys.map(item => {
                    return model.ForeignKey.getDeserializedJsonObj(item);
                })
                : undefined,
            "dataFormat": obj.dataFormat
                ? model.DataFormat.getDeserializedJsonObj(obj.dataFormat)
                : undefined
        });
        return jsonObj;
    }
    DataEntitySummaryFromFile.getDeserializedJsonObj = getDeserializedJsonObj;
})(DataEntitySummaryFromFile = exports.DataEntitySummaryFromFile || (exports.DataEntitySummaryFromFile = {}));
//# sourceMappingURL=data-entity-summary-from-file.js.map