"use strict";
/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DpEndpointDetails = void 0;
const model = __importStar(require("../model"));
var DpEndpointDetails;
(function (DpEndpointDetails) {
    function getJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef ? model.ParentReference.getJsonObj(obj.parentRef) : undefined,
            "dataAssets": obj.dataAssets
                ? obj.dataAssets.map(item => {
                    return model.DataAsset.getJsonObj(item);
                })
                : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "PRIVATE_END_POINT":
                    return model.DpEndpointFromPrivateDetails.getJsonObj(jsonObj, true);
                case "PUBLIC_END_POINT":
                    return model.DpEndpointFromPublicDetails.getJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    DpEndpointDetails.getJsonObj = getJsonObj;
    function getDeserializedJsonObj(obj) {
        const jsonObj = Object.assign(Object.assign({}, obj), {
            "parentRef": obj.parentRef
                ? model.ParentReference.getDeserializedJsonObj(obj.parentRef)
                : undefined,
            "dataAssets": obj.dataAssets
                ? obj.dataAssets.map(item => {
                    return model.DataAsset.getDeserializedJsonObj(item);
                })
                : undefined
        });
        if ("modelType" in obj && obj.modelType) {
            switch (obj.modelType) {
                case "PRIVATE_END_POINT":
                    return model.DpEndpointFromPrivateDetails.getDeserializedJsonObj(jsonObj, true);
                case "PUBLIC_END_POINT":
                    return model.DpEndpointFromPublicDetails.getDeserializedJsonObj(jsonObj, true);
                default:
                    throw Error("Unknown value for: " + obj.modelType);
            }
        }
        return jsonObj;
    }
    DpEndpointDetails.getDeserializedJsonObj = getDeserializedJsonObj;
})(DpEndpointDetails = exports.DpEndpointDetails || (exports.DpEndpointDetails = {}));
//# sourceMappingURL=dp-endpoint-details.js.map