/**
 * Data Connectivity Management API
 * Use the DCMS APIs to perform Metadata/Data operations.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * A summary of profiling results of a specefic attribute.
 */
export interface StringAttribute extends model.AttributeProfileResult {
    "minLength"?: model.ProfileStat;
    "maxLength"?: model.ProfileStat;
    "meanLength"?: model.ProfileStat;
    /**
     * Pattern frequencies for the column as described already in profile config.
     */
    "patternFrequencies"?: Array<model.ObjectFreqStat>;
    /**
     * Inferred DataType for the column.
     */
    "inferredDataTypes"?: Array<model.DataTypeStat>;
    "type": string;
}
export declare namespace StringAttribute {
    function getJsonObj(obj: StringAttribute, isParentJsonObj?: boolean): object;
    const type = "STRING";
    function getDeserializedJsonObj(obj: StringAttribute, isParentJsonObj?: boolean): object;
}
