/**
 * OneSubscription API Billing Schedule
 * OneSubscription API for Billing Schedule information

 * OpenAPI spec version: 20210501
 * Contact: kuaskum_org_ww@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import common = require("oci-common");
import * as requests from "./request";
import * as model from "./model";
import * as responses from "./response";
export declare enum BillingScheduleApiKeys {
}
/**
 * This service client uses {@link common.CircuitBreaker.DefaultConfiguration} for all the operations by default if no circuit breaker configuration is defined by the user.
 */
export declare class BillingScheduleClient {
    protected static serviceEndpointTemplate: string;
    protected static endpointServiceName: string;
    protected "_endpoint": string;
    protected "_defaultHeaders": any;
    protected "_clientConfiguration": common.ClientConfiguration;
    protected _circuitBreaker: null;
    protected _httpClient: common.HttpClient;
    constructor(params: common.AuthParams, clientConfiguration?: common.ClientConfiguration);
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    get endpoint(): string;
    /**
     * Sets the endpoint to call (ex, https://www.example.com).
     * @param endpoint The endpoint of the service.
     */
    set endpoint(endpoint: string);
    get logger(): import("oci-common/lib/log").Logger;
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    set region(region: common.Region);
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    set regionId(regionId: string);
    /**
     * This list API returns all billing schedules for given subscription id and
     * for a particular Subscribed Service if provided
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListBillingSchedulesRequest
     * @return ListBillingSchedulesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/osubbillingschedule/ListBillingSchedules.ts.html |here} to see how to use ListBillingSchedules API.
     */
    listBillingSchedules(listBillingSchedulesRequest: requests.ListBillingSchedulesRequest): Promise<responses.ListBillingSchedulesResponse>;
    /**
     * NOTE: This function is deprecated in favor of listBillingSchedulesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.BillingScheduleSummary objects
     * contained in responses from the listBillingSchedules operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBillingSchedules(request: requests.ListBillingSchedulesRequest): AsyncIterableIterator<model.BillingScheduleSummary>;
    /**
     * NOTE: This function is deprecated in favor of listBillingSchedulesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listBillingSchedules operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBillingSchedulesResponses(request: requests.ListBillingSchedulesRequest): AsyncIterableIterator<responses.ListBillingSchedulesResponse>;
    /**
     * Creates a new async iterator which will iterate over the models.BillingScheduleSummary objects
     * contained in responses from the listBillingSchedules operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBillingSchedulesRecordIterator(request: requests.ListBillingSchedulesRequest): AsyncIterableIterator<model.BillingScheduleSummary>;
    /**
     * Creates a new async iterator which will iterate over the responses received from the listBillingSchedules operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBillingSchedulesResponseIterator(request: requests.ListBillingSchedulesRequest): AsyncIterableIterator<responses.ListBillingSchedulesResponse>;
}
