"use strict";
/**
 * Database Service API
 * The API for the Database Service. Use this API to manage resources such as databases and DB Systems. For more information, see [Overview of the Database Service](/iaas/Content/Database/Concepts/databaseoverview.htm).

 * OpenAPI spec version: 20160918
 * Contact: sic_dbaas_cp_us_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseClient = exports.DatabaseApiKeys = void 0;
const common = require("oci-common");
const model = __importStar(require("./model"));
const oci_common_1 = require("oci-common");
const database_waiter_1 = require("./database-waiter");
const oci_common_2 = require("oci-common");
// ===============================================
// This file is autogenerated - Please do not edit
// ===============================================
var DatabaseApiKeys;
(function (DatabaseApiKeys) {
})(DatabaseApiKeys = exports.DatabaseApiKeys || (exports.DatabaseApiKeys = {}));
/**
 * This service client uses {@link common.CircuitBreaker.DefaultConfiguration} for all the operations by default if no circuit breaker configuration is defined by the user.
 */
class DatabaseClient {
    constructor(params, clientConfiguration) {
        this["_endpoint"] = "";
        this["_defaultHeaders"] = {};
        this._circuitBreaker = null;
        const requestSigner = params.authenticationDetailsProvider
            ? new common.DefaultRequestSigner(params.authenticationDetailsProvider)
            : null;
        if (clientConfiguration) {
            this._clientConfiguration = clientConfiguration;
            this._circuitBreaker = clientConfiguration.circuitBreaker
                ? clientConfiguration.circuitBreaker.circuit
                : null;
        }
        // if circuit breaker is not created, check if circuit breaker system is enabled to use default circuit breaker
        const specCircuitBreakerEnabled = true;
        if (!this._circuitBreaker &&
            common.utils.isCircuitBreakerSystemEnabled(clientConfiguration) &&
            (specCircuitBreakerEnabled || common.CircuitBreaker.DefaultCircuitBreakerOverriden)) {
            this._circuitBreaker = new common.CircuitBreaker().circuit;
        }
        this._httpClient =
            params.httpClient || new common.FetchHttpClient(requestSigner, this._circuitBreaker);
        if (params.authenticationDetailsProvider &&
            common.isRegionProvider(params.authenticationDetailsProvider)) {
            const provider = params.authenticationDetailsProvider;
            if (provider.getRegion()) {
                this.region = provider.getRegion();
            }
        }
    }
    /**
     * Get the endpoint that is being used to call (ex, https://www.example.com).
     */
    get endpoint() {
        return this._endpoint;
    }
    /**
     * Sets the endpoint to call (ex, https://www.example.com).
     * @param endpoint The endpoint of the service.
     */
    set endpoint(endpoint) {
        this._endpoint = endpoint;
        this._endpoint = this._endpoint + "/20160918";
        if (this.logger)
            this.logger.info(`DatabaseClient endpoint set to ${this._endpoint}`);
    }
    get logger() {
        return common.LOG.logger;
    }
    /**
     * Sets the region to call (ex, Region.US_PHOENIX_1).
     * Note, this will call {@link #endpoint(String) endpoint} after resolving the endpoint.
     * @param region The region of the service.
     */
    set region(region) {
        this.endpoint = common.EndpointBuilder.createEndpointFromRegion(DatabaseClient.serviceEndpointTemplate, region, DatabaseClient.endpointServiceName);
    }
    /**
     * Sets the regionId to call (ex, 'us-phoenix-1').
     *
     * Note, this will first try to map the region ID to a known Region and call {@link #region(Region) region}.
     * If no known Region could be determined, it will create an endpoint assuming its in default Realm OC1
     * and then call {@link #endpoint(String) endpoint}.
     * @param regionId The public region ID.
     */
    set regionId(regionId) {
        this.endpoint = common.EndpointBuilder.createEndpointFromRegionId(DatabaseClient.serviceEndpointTemplate, regionId, DatabaseClient.endpointServiceName);
    }
    /**
     * Creates a new DatabaseWaiter for resources for this service.
     *
     * @param workRequestClient The work request service client used to query for work request status
     * @param config The waiter configuration for termination and delay strategy
     * @return The service waiters.
     */
    createWaiters(workRequestClient, config) {
        this._waiters = new database_waiter_1.DatabaseWaiter(this, workRequestClient, config);
        return this._waiters;
    }
    /**
     * Gets the waiters available for resources for this service.
     *
     * @return The service waiters.
     */
    getWaiters() {
        if (this._waiters) {
            return this._waiters;
        }
        throw Error("Waiters do not exist. Please create waiters.");
    }
    /**
     * Activates the specified Exadata infrastructure resource. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ActivateExadataInfrastructureRequest
     * @return ActivateExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ActivateExadataInfrastructure.ts.html |here} to see how to use ActivateExadataInfrastructure API.
     */
    activateExadataInfrastructure(activateExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#activateExadataInfrastructure.");
            const pathParams = {
                "{exadataInfrastructureId}": activateExadataInfrastructureRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": activateExadataInfrastructureRequest.opcRequestId,
                "opc-retry-token": activateExadataInfrastructureRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, activateExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/actions/activate",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(activateExadataInfrastructureRequest.activateExadataInfrastructureDetails, "ActivateExadataInfrastructureDetails", model.ActivateExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataInfrastructure",
                    bodyModel: model.ExadataInfrastructure,
                    type: "model.ExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Makes the storage capacity from additional storage servers available for VM Cluster consumption. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param AddStorageCapacityExadataInfrastructureRequest
     * @return AddStorageCapacityExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/AddStorageCapacityExadataInfrastructure.ts.html |here} to see how to use AddStorageCapacityExadataInfrastructure API.
     */
    addStorageCapacityExadataInfrastructure(addStorageCapacityExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#addStorageCapacityExadataInfrastructure.");
            const pathParams = {
                "{exadataInfrastructureId}": addStorageCapacityExadataInfrastructureRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": addStorageCapacityExadataInfrastructureRequest.ifMatch,
                "opc-request-id": addStorageCapacityExadataInfrastructureRequest.opcRequestId,
                "opc-retry-token": addStorageCapacityExadataInfrastructureRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, addStorageCapacityExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/actions/addStorageCapacity",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataInfrastructure",
                    bodyModel: model.ExadataInfrastructure,
                    type: "model.ExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Add Virtual Machines to the VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param AddVirtualMachineToVmClusterRequest
     * @return AddVirtualMachineToVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/AddVirtualMachineToVmCluster.ts.html |here} to see how to use AddVirtualMachineToVmCluster API.
     */
    addVirtualMachineToVmCluster(addVirtualMachineToVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#addVirtualMachineToVmCluster.");
            const pathParams = {
                "{vmClusterId}": addVirtualMachineToVmClusterRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": addVirtualMachineToVmClusterRequest.opcRetryToken,
                "opc-request-id": addVirtualMachineToVmClusterRequest.opcRequestId,
                "if-match": addVirtualMachineToVmClusterRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, addVirtualMachineToVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/actions/addVirtualMachine",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(addVirtualMachineToVmClusterRequest.addVirtualMachineToVmClusterDetails, "AddVirtualMachineToVmClusterDetails", model.AddVirtualMachineToVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmCluster",
                    bodyModel: model.VmCluster,
                    type: "model.VmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Initiates a data refresh for an Autonomous Database refreshable clone. Data is refreshed from the source database to the point of a specified timestamp.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param AutonomousDatabaseManualRefreshRequest
     * @return AutonomousDatabaseManualRefreshResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/AutonomousDatabaseManualRefresh.ts.html |here} to see how to use AutonomousDatabaseManualRefresh API.
     */
    autonomousDatabaseManualRefresh(autonomousDatabaseManualRefreshRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#autonomousDatabaseManualRefresh.");
            const pathParams = {
                "{autonomousDatabaseId}": autonomousDatabaseManualRefreshRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": autonomousDatabaseManualRefreshRequest.ifMatch,
                "opc-retry-token": autonomousDatabaseManualRefreshRequest.opcRetryToken,
                "opc-request-id": autonomousDatabaseManualRefreshRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, autonomousDatabaseManualRefreshRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/refresh",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(autonomousDatabaseManualRefreshRequest.autonomousDatabaseManualRefreshDetails, "AutonomousDatabaseManualRefreshDetails", model.AutonomousDatabaseManualRefreshDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the Autonomous Container Database and its dependent resources to the specified compartment.
     * For more information about moving Autonomous Container Databases, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeAutonomousContainerDatabaseCompartmentRequest
     * @return ChangeAutonomousContainerDatabaseCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeAutonomousContainerDatabaseCompartment.ts.html |here} to see how to use ChangeAutonomousContainerDatabaseCompartment API.
     */
    changeAutonomousContainerDatabaseCompartment(changeAutonomousContainerDatabaseCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeAutonomousContainerDatabaseCompartment.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": changeAutonomousContainerDatabaseCompartmentRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeAutonomousContainerDatabaseCompartmentRequest.opcRetryToken,
                "opc-request-id": changeAutonomousContainerDatabaseCompartmentRequest.opcRequestId,
                "if-match": changeAutonomousContainerDatabaseCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeAutonomousContainerDatabaseCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeAutonomousContainerDatabaseCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the Autonomous Database and its dependent resources to the specified compartment.
     * For more information about moving Autonomous Databases, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeAutonomousDatabaseCompartmentRequest
     * @return ChangeAutonomousDatabaseCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeAutonomousDatabaseCompartment.ts.html |here} to see how to use ChangeAutonomousDatabaseCompartment API.
     */
    changeAutonomousDatabaseCompartment(changeAutonomousDatabaseCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeAutonomousDatabaseCompartment.");
            const pathParams = {
                "{autonomousDatabaseId}": changeAutonomousDatabaseCompartmentRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeAutonomousDatabaseCompartmentRequest.opcRetryToken,
                "opc-request-id": changeAutonomousDatabaseCompartmentRequest.opcRequestId,
                "if-match": changeAutonomousDatabaseCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeAutonomousDatabaseCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeAutonomousDatabaseCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** Use the {@link #changeCloudExadataInfrastructureCompartment(ChangeCloudExadataInfrastructureCompartmentRequest) changeCloudExadataInfrastructureCompartment} operation to move an Exadata infrastructure resource to a different compartment and  {@link #changeCloudAutonomousVmClusterCompartment(ChangeCloudAutonomousVmClusterCompartmentRequest) changeCloudAutonomousVmClusterCompartment} operation to move an Autonomous Exadata VM cluster to a different compartment.
     * For more information, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeAutonomousExadataInfrastructureCompartmentRequest
     * @return ChangeAutonomousExadataInfrastructureCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeAutonomousExadataInfrastructureCompartment.ts.html |here} to see how to use ChangeAutonomousExadataInfrastructureCompartment API.
     */
    changeAutonomousExadataInfrastructureCompartment(changeAutonomousExadataInfrastructureCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeAutonomousExadataInfrastructureCompartment.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": changeAutonomousExadataInfrastructureCompartmentRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeAutonomousExadataInfrastructureCompartmentRequest.opcRetryToken,
                "opc-request-id": changeAutonomousExadataInfrastructureCompartmentRequest.opcRequestId,
                "if-match": changeAutonomousExadataInfrastructureCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeAutonomousExadataInfrastructureCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeAutonomousExadataInfrastructureCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves an Autonomous VM cluster and its dependent resources to another compartment. Applies to Exadata Cloud@Customer  only. For systems in the Oracle cloud, see {@link #changeAutonomousVmClusterCompartment(ChangeAutonomousVmClusterCompartmentRequest) changeAutonomousVmClusterCompartment}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeAutonomousVmClusterCompartmentRequest
     * @return ChangeAutonomousVmClusterCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeAutonomousVmClusterCompartment.ts.html |here} to see how to use ChangeAutonomousVmClusterCompartment API.
     */
    changeAutonomousVmClusterCompartment(changeAutonomousVmClusterCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeAutonomousVmClusterCompartment.");
            const pathParams = {
                "{autonomousVmClusterId}": changeAutonomousVmClusterCompartmentRequest.autonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeAutonomousVmClusterCompartmentRequest.opcRetryToken,
                "opc-request-id": changeAutonomousVmClusterCompartmentRequest.opcRequestId,
                "if-match": changeAutonomousVmClusterCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeAutonomousVmClusterCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters/{autonomousVmClusterId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeAutonomousVmClusterCompartmentRequest.changeAutonomousVmClusterCompartmentDetails, "ChangeAutonomousVmClusterCompartmentDetails", model.ChangeAutonomousVmClusterCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the backup destination and its dependent resources to the specified compartment.
     * For more information, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeBackupDestinationCompartmentRequest
     * @return ChangeBackupDestinationCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeBackupDestinationCompartment.ts.html |here} to see how to use ChangeBackupDestinationCompartment API.
     */
    changeBackupDestinationCompartment(changeBackupDestinationCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeBackupDestinationCompartment.");
            const pathParams = {
                "{backupDestinationId}": changeBackupDestinationCompartmentRequest.backupDestinationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeBackupDestinationCompartmentRequest.opcRetryToken,
                "opc-request-id": changeBackupDestinationCompartmentRequest.opcRequestId,
                "if-match": changeBackupDestinationCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeBackupDestinationCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations/{backupDestinationId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeBackupDestinationCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves an Autonomous Exadata VM cluster in the Oracle cloud and its dependent resources to another compartment. For Exadata Cloud@Customer systems, see {@link #changeAutonomousVmClusterCompartment(ChangeAutonomousVmClusterCompartmentRequest) changeAutonomousVmClusterCompartment}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeCloudAutonomousVmClusterCompartmentRequest
     * @return ChangeCloudAutonomousVmClusterCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeCloudAutonomousVmClusterCompartment.ts.html |here} to see how to use ChangeCloudAutonomousVmClusterCompartment API.
     */
    changeCloudAutonomousVmClusterCompartment(changeCloudAutonomousVmClusterCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeCloudAutonomousVmClusterCompartment.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": changeCloudAutonomousVmClusterCompartmentRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeCloudAutonomousVmClusterCompartmentRequest.opcRetryToken,
                "opc-request-id": changeCloudAutonomousVmClusterCompartmentRequest.opcRequestId,
                "if-match": changeCloudAutonomousVmClusterCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeCloudAutonomousVmClusterCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeCloudAutonomousVmClusterCompartmentRequest.changeCloudAutonomousVmClusterCompartmentDetails, "ChangeCloudAutonomousVmClusterCompartmentDetails", model.ChangeCloudAutonomousVmClusterCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves a cloud Exadata infrastructure resource and its dependent resources to another compartment. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.For more information about moving resources to a different compartment, see [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeCloudExadataInfrastructureCompartmentRequest
     * @return ChangeCloudExadataInfrastructureCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeCloudExadataInfrastructureCompartment.ts.html |here} to see how to use ChangeCloudExadataInfrastructureCompartment API.
     */
    changeCloudExadataInfrastructureCompartment(changeCloudExadataInfrastructureCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeCloudExadataInfrastructureCompartment.");
            const pathParams = {
                "{cloudExadataInfrastructureId}": changeCloudExadataInfrastructureCompartmentRequest.cloudExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeCloudExadataInfrastructureCompartmentRequest.opcRetryToken,
                "opc-request-id": changeCloudExadataInfrastructureCompartmentRequest.opcRequestId,
                "if-match": changeCloudExadataInfrastructureCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeCloudExadataInfrastructureCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures/{cloudExadataInfrastructureId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeCloudExadataInfrastructureCompartmentRequest.changeCloudExadataInfrastructureCompartmentDetails, "ChangeCloudExadataInfrastructureCompartmentDetails", model.ChangeCloudExadataInfrastructureCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves a cloud VM cluster and its dependent resources to another compartment. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeCloudVmClusterCompartmentRequest
     * @return ChangeCloudVmClusterCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeCloudVmClusterCompartment.ts.html |here} to see how to use ChangeCloudVmClusterCompartment API.
     */
    changeCloudVmClusterCompartment(changeCloudVmClusterCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeCloudVmClusterCompartment.");
            const pathParams = {
                "{cloudVmClusterId}": changeCloudVmClusterCompartmentRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeCloudVmClusterCompartmentRequest.opcRetryToken,
                "opc-request-id": changeCloudVmClusterCompartmentRequest.opcRequestId,
                "if-match": changeCloudVmClusterCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeCloudVmClusterCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeCloudVmClusterCompartmentRequest.changeCloudVmClusterCompartmentDetails, "ChangeCloudVmClusterCompartmentDetails", model.ChangeCloudVmClusterCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the Database Software Image and its dependent resources to the specified compartment.
     * For more information about moving Databse Software Images, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeDatabaseSoftwareImageCompartmentRequest
     * @return ChangeDatabaseSoftwareImageCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeDatabaseSoftwareImageCompartment.ts.html |here} to see how to use ChangeDatabaseSoftwareImageCompartment API.
     */
    changeDatabaseSoftwareImageCompartment(changeDatabaseSoftwareImageCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeDatabaseSoftwareImageCompartment.");
            const pathParams = {
                "{databaseSoftwareImageId}": changeDatabaseSoftwareImageCompartmentRequest.databaseSoftwareImageId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeDatabaseSoftwareImageCompartmentRequest.opcRetryToken,
                "opc-request-id": changeDatabaseSoftwareImageCompartmentRequest.opcRequestId,
                "if-match": changeDatabaseSoftwareImageCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeDatabaseSoftwareImageCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages/{databaseSoftwareImageId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeDatabaseSoftwareImageCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves the DB system and its dependent resources to the specified compartment.
     * For more information about moving DB systems, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeDbSystemCompartmentRequest
     * @return ChangeDbSystemCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeDbSystemCompartment.ts.html |here} to see how to use ChangeDbSystemCompartment API.
     */
    changeDbSystemCompartment(changeDbSystemCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeDbSystemCompartment.");
            const pathParams = {
                "{dbSystemId}": changeDbSystemCompartmentRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeDbSystemCompartmentRequest.opcRetryToken,
                "opc-request-id": changeDbSystemCompartmentRequest.opcRequestId,
                "if-match": changeDbSystemCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeDbSystemCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeDbSystemCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves an Exadata infrastructure resource and its dependent resources to another compartment. Applies to Exadata Cloud@Customer instances only.
     * To move an Exadata Cloud Service infrastructure resource to another compartment, use the  {@link #changeCloudExadataInfrastructureCompartment(ChangeCloudExadataInfrastructureCompartmentRequest) changeCloudExadataInfrastructureCompartment} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeExadataInfrastructureCompartmentRequest
     * @return ChangeExadataInfrastructureCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeExadataInfrastructureCompartment.ts.html |here} to see how to use ChangeExadataInfrastructureCompartment API.
     */
    changeExadataInfrastructureCompartment(changeExadataInfrastructureCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeExadataInfrastructureCompartment.");
            const pathParams = {
                "{exadataInfrastructureId}": changeExadataInfrastructureCompartmentRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeExadataInfrastructureCompartmentRequest.opcRetryToken,
                "opc-request-id": changeExadataInfrastructureCompartmentRequest.opcRequestId,
                "if-match": changeExadataInfrastructureCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeExadataInfrastructureCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeExadataInfrastructureCompartmentRequest.changeExadataInfrastructureCompartmentDetails, "ChangeExadataInfrastructureCompartmentDetails", model.ChangeExadataInfrastructureCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the {@link #createExternalContainerDatabaseDetails(CreateExternalContainerDatabaseDetailsRequest) createExternalContainerDatabaseDetails}
     * and its dependent resources to the specified compartment.
     * For more information about moving external container databases, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeExternalContainerDatabaseCompartmentRequest
     * @return ChangeExternalContainerDatabaseCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeExternalContainerDatabaseCompartment.ts.html |here} to see how to use ChangeExternalContainerDatabaseCompartment API.
     */
    changeExternalContainerDatabaseCompartment(changeExternalContainerDatabaseCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeExternalContainerDatabaseCompartment.");
            const pathParams = {
                "{externalContainerDatabaseId}": changeExternalContainerDatabaseCompartmentRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeExternalContainerDatabaseCompartmentRequest.opcRetryToken,
                "opc-request-id": changeExternalContainerDatabaseCompartmentRequest.opcRequestId,
                "if-match": changeExternalContainerDatabaseCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeExternalContainerDatabaseCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeExternalContainerDatabaseCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the external non-container database and its dependent resources to the specified compartment.
     * For more information about moving external non-container databases, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeExternalNonContainerDatabaseCompartmentRequest
     * @return ChangeExternalNonContainerDatabaseCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeExternalNonContainerDatabaseCompartment.ts.html |here} to see how to use ChangeExternalNonContainerDatabaseCompartment API.
     */
    changeExternalNonContainerDatabaseCompartment(changeExternalNonContainerDatabaseCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeExternalNonContainerDatabaseCompartment.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": changeExternalNonContainerDatabaseCompartmentRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeExternalNonContainerDatabaseCompartmentRequest.opcRetryToken,
                "opc-request-id": changeExternalNonContainerDatabaseCompartmentRequest.opcRequestId,
                "if-match": changeExternalNonContainerDatabaseCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeExternalNonContainerDatabaseCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeExternalNonContainerDatabaseCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails} and
     * its dependent resources to the specified compartment.
     * For more information about moving external pluggable databases, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeExternalPluggableDatabaseCompartmentRequest
     * @return ChangeExternalPluggableDatabaseCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeExternalPluggableDatabaseCompartment.ts.html |here} to see how to use ChangeExternalPluggableDatabaseCompartment API.
     */
    changeExternalPluggableDatabaseCompartment(changeExternalPluggableDatabaseCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeExternalPluggableDatabaseCompartment.");
            const pathParams = {
                "{externalPluggableDatabaseId}": changeExternalPluggableDatabaseCompartmentRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeExternalPluggableDatabaseCompartmentRequest.opcRetryToken,
                "opc-request-id": changeExternalPluggableDatabaseCompartmentRequest.opcRequestId,
                "if-match": changeExternalPluggableDatabaseCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeExternalPluggableDatabaseCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeExternalPluggableDatabaseCompartmentRequest.changeCompartmentDetails, "ChangeCompartmentDetails", model.ChangeCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Move the key store resource to the specified compartment.
     * For more information about moving key stores, see
     * [Moving Database Resources to a Different Compartment](https://docs.cloud.oracle.com/Content/Database/Concepts/databaseoverview.htm#moveRes).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeKeyStoreCompartmentRequest
     * @return ChangeKeyStoreCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeKeyStoreCompartment.ts.html |here} to see how to use ChangeKeyStoreCompartment API.
     */
    changeKeyStoreCompartment(changeKeyStoreCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeKeyStoreCompartment.");
            const pathParams = {
                "{keyStoreId}": changeKeyStoreCompartmentRequest.keyStoreId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeKeyStoreCompartmentRequest.opcRetryToken,
                "opc-request-id": changeKeyStoreCompartmentRequest.opcRequestId,
                "if-match": changeKeyStoreCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeKeyStoreCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores/{keyStoreId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeKeyStoreCompartmentRequest.changeKeyStoreCompartmentDetails, "ChangeKeyStoreCompartmentDetails", model.ChangeKeyStoreCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Moves a VM cluster and its dependent resources to another compartment. Applies to Exadata Cloud@Customer instances only.
     * To move a cloud VM cluster in an Exadata Cloud Service instance to another compartment, use the {@link #changeCloudVmClusterCompartment(ChangeCloudVmClusterCompartmentRequest) changeCloudVmClusterCompartment} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ChangeVmClusterCompartmentRequest
     * @return ChangeVmClusterCompartmentResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ChangeVmClusterCompartment.ts.html |here} to see how to use ChangeVmClusterCompartment API.
     */
    changeVmClusterCompartment(changeVmClusterCompartmentRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#changeVmClusterCompartment.");
            const pathParams = {
                "{vmClusterId}": changeVmClusterCompartmentRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": changeVmClusterCompartmentRequest.opcRetryToken,
                "opc-request-id": changeVmClusterCompartmentRequest.opcRequestId,
                "if-match": changeVmClusterCompartmentRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, changeVmClusterCompartmentRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/actions/changeCompartment",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(changeVmClusterCompartmentRequest.changeVmClusterCompartmentDetails, "ChangeVmClusterCompartmentDetails", model.ChangeVmClusterCompartmentDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Check the status of the external database connection specified in this connector.
     * This operation will refresh the connectionStatus and timeConnectionStatusLastUpdated fields.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CheckExternalDatabaseConnectorConnectionStatusRequest
     * @return CheckExternalDatabaseConnectorConnectionStatusResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CheckExternalDatabaseConnectorConnectionStatus.ts.html |here} to see how to use CheckExternalDatabaseConnectorConnectionStatus API.
     */
    checkExternalDatabaseConnectorConnectionStatus(checkExternalDatabaseConnectorConnectionStatusRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#checkExternalDatabaseConnectorConnectionStatus.");
            const pathParams = {
                "{externalDatabaseConnectorId}": checkExternalDatabaseConnectorConnectionStatusRequest.externalDatabaseConnectorId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": checkExternalDatabaseConnectorConnectionStatusRequest.opcRetryToken,
                "opc-request-id": checkExternalDatabaseConnectorConnectionStatusRequest.opcRequestId,
                "if-match": checkExternalDatabaseConnectorConnectionStatusRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, checkExternalDatabaseConnectorConnectionStatusRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors/{externalDatabaseConnectorId}/actions/checkConnectionStatus",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Changes the status of the standalone backup resource to `ACTIVE` after the backup is created from the on-premises database and placed in Oracle Cloud Infrastructure Object Storage.
     * <p>
     **Note:** This API is used by an Oracle Cloud Infrastructure Python script that is packaged with the Oracle Cloud Infrastructure CLI. Oracle recommends that you use the script instead using the API directly. See [Migrating an On-Premises Database to Oracle Cloud Infrastructure by Creating a Backup in the Cloud](https://docs.cloud.oracle.com/Content/Database/Tasks/mig-onprembackup.htm) for more information.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CompleteExternalBackupJobRequest
     * @return CompleteExternalBackupJobResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CompleteExternalBackupJob.ts.html |here} to see how to use CompleteExternalBackupJob API.
     */
    completeExternalBackupJob(completeExternalBackupJobRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#completeExternalBackupJob.");
            const pathParams = {
                "{backupId}": completeExternalBackupJobRequest.backupId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": completeExternalBackupJobRequest.ifMatch,
                "opc-retry-token": completeExternalBackupJobRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, completeExternalBackupJobRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalBackupJobs/{backupId}/actions/complete",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(completeExternalBackupJobRequest.completeExternalBackupJobDetails, "CompleteExternalBackupJobDetails", model.CompleteExternalBackupJobDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalBackupJob",
                    bodyModel: model.ExternalBackupJob,
                    type: "model.ExternalBackupJob",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Configures the Autonomous Database Vault service [key](https://docs.cloud.oracle.com/Content/KeyManagement/Concepts/keyoverview.htm#concepts).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ConfigureAutonomousDatabaseVaultKeyRequest
     * @return ConfigureAutonomousDatabaseVaultKeyResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ConfigureAutonomousDatabaseVaultKey.ts.html |here} to see how to use ConfigureAutonomousDatabaseVaultKey API.
     */
    configureAutonomousDatabaseVaultKey(configureAutonomousDatabaseVaultKeyRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#configureAutonomousDatabaseVaultKey.");
            const pathParams = {
                "{autonomousDatabaseId}": configureAutonomousDatabaseVaultKeyRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": configureAutonomousDatabaseVaultKeyRequest.ifMatch,
                "opc-request-id": configureAutonomousDatabaseVaultKeyRequest.opcRequestId,
                "opc-retry-token": configureAutonomousDatabaseVaultKeyRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, configureAutonomousDatabaseVaultKeyRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/configureAutonomousDatabaseVaultKey",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(configureAutonomousDatabaseVaultKeyRequest.configureAutonomousDatabaseVaultKeyDetails, "ConfigureAutonomousDatabaseVaultKeyDetails", model.ConfigureAutonomousDatabaseVaultKeyDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Converts a non-container database to a pluggable database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ConvertToPdbRequest
     * @return ConvertToPdbResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ConvertToPdb.ts.html |here} to see how to use ConvertToPdb API.
     */
    convertToPdb(convertToPdbRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#convertToPdb.");
            const pathParams = {
                "{databaseId}": convertToPdbRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": convertToPdbRequest.ifMatch,
                "opc-request-id": convertToPdbRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, convertToPdbRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/convertToPdb",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(convertToPdbRequest.convertToPdbDetails, "ConvertToPdbDetails", model.ConvertToPdbDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates an Autonomous Container Database in the specified Autonomous Exadata Infrastructure.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateAutonomousContainerDatabaseRequest
     * @return CreateAutonomousContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateAutonomousContainerDatabase.ts.html |here} to see how to use CreateAutonomousContainerDatabase API.
     */
    createAutonomousContainerDatabase(createAutonomousContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createAutonomousContainerDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createAutonomousContainerDatabaseRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createAutonomousContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createAutonomousContainerDatabaseRequest.createAutonomousContainerDatabaseDetails, "CreateAutonomousContainerDatabaseDetails", model.CreateAutonomousContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabase",
                    bodyModel: model.AutonomousContainerDatabase,
                    type: "model.AutonomousContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateAutonomousDatabaseRequest
     * @return CreateAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateAutonomousDatabase.ts.html |here} to see how to use CreateAutonomousDatabase API.
     */
    createAutonomousDatabase(createAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createAutonomousDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createAutonomousDatabaseRequest.opcRetryToken,
                "opc-request-id": createAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createAutonomousDatabaseRequest.createAutonomousDatabaseDetails, "CreateAutonomousDatabaseBase", model.CreateAutonomousDatabaseBase.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new Autonomous Database backup for the specified database based on the provided request parameters.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateAutonomousDatabaseBackupRequest
     * @return CreateAutonomousDatabaseBackupResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateAutonomousDatabaseBackup.ts.html |here} to see how to use CreateAutonomousDatabaseBackup API.
     */
    createAutonomousDatabaseBackup(createAutonomousDatabaseBackupRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createAutonomousDatabaseBackup.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createAutonomousDatabaseBackupRequest.opcRetryToken,
                "opc-request-id": createAutonomousDatabaseBackupRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createAutonomousDatabaseBackupRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabaseBackups",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createAutonomousDatabaseBackupRequest.createAutonomousDatabaseBackupDetails, "CreateAutonomousDatabaseBackupDetails", model.CreateAutonomousDatabaseBackupDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabaseBackup",
                    bodyModel: model.AutonomousDatabaseBackup,
                    type: "model.AutonomousDatabaseBackup",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates an Autonomous VM cluster for Exadata Cloud@Customer. To create an Autonomous VM Cluster in the Oracle cloud, see {@link #createCloudAutonomousVmCluster(CreateCloudAutonomousVmClusterRequest) createCloudAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateAutonomousVmClusterRequest
     * @return CreateAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateAutonomousVmCluster.ts.html |here} to see how to use CreateAutonomousVmCluster API.
     */
    createAutonomousVmCluster(createAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createAutonomousVmCluster.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createAutonomousVmClusterRequest.opcRetryToken,
                "opc-request-id": createAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createAutonomousVmClusterRequest.createAutonomousVmClusterDetails, "CreateAutonomousVmClusterDetails", model.CreateAutonomousVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousVmCluster",
                    bodyModel: model.AutonomousVmCluster,
                    type: "model.AutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new backup in the specified database based on the request parameters you provide. If you previously used RMAN or dbcli to configure backups and then you switch to using the Console or the API for backups, a new backup configuration is created and associated with your database. This means that you can no longer rely on your previously configured unmanaged backups to work.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateBackupRequest
     * @return CreateBackupResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateBackup.ts.html |here} to see how to use CreateBackup API.
     */
    createBackup(createBackupRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createBackup.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createBackupRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createBackupRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backups",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createBackupRequest.createBackupDetails, "CreateBackupDetails", model.CreateBackupDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "backup",
                    bodyModel: model.Backup,
                    type: "model.Backup",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a backup destination in an Exadata Cloud@Customer system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateBackupDestinationRequest
     * @return CreateBackupDestinationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateBackupDestination.ts.html |here} to see how to use CreateBackupDestination API.
     */
    createBackupDestination(createBackupDestinationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createBackupDestination.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createBackupDestinationRequest.opcRetryToken,
                "opc-request-id": createBackupDestinationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createBackupDestinationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createBackupDestinationRequest.createBackupDestinationDetails, "CreateBackupDestinationDetails", model.CreateBackupDestinationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "backupDestination",
                    bodyModel: model.BackupDestination,
                    type: "model.BackupDestination",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates an Autonomous Exadata VM cluster in the Oracle cloud. For Exadata Cloud@Customer systems, see {@link #createAutonomousVmCluster(CreateAutonomousVmClusterRequest) createAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateCloudAutonomousVmClusterRequest
     * @return CreateCloudAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateCloudAutonomousVmCluster.ts.html |here} to see how to use CreateCloudAutonomousVmCluster API.
     */
    createCloudAutonomousVmCluster(createCloudAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createCloudAutonomousVmCluster.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createCloudAutonomousVmClusterRequest.opcRetryToken,
                "opc-request-id": createCloudAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createCloudAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createCloudAutonomousVmClusterRequest.createCloudAutonomousVmClusterDetails, "CreateCloudAutonomousVmClusterDetails", model.CreateCloudAutonomousVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudAutonomousVmCluster",
                    bodyModel: model.CloudAutonomousVmCluster,
                    type: "model.CloudAutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a cloud Exadata infrastructure resource. This resource is used to create either an [Exadata Cloud Service](https://docs.cloud.oracle.com/Content/Database/Concepts/exaoverview.htm) instance or an Autonomous Database on dedicated Exadata infrastructure.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateCloudExadataInfrastructureRequest
     * @return CreateCloudExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateCloudExadataInfrastructure.ts.html |here} to see how to use CreateCloudExadataInfrastructure API.
     */
    createCloudExadataInfrastructure(createCloudExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createCloudExadataInfrastructure.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createCloudExadataInfrastructureRequest.opcRetryToken,
                "opc-request-id": createCloudExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createCloudExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createCloudExadataInfrastructureRequest.createCloudExadataInfrastructureDetails, "CreateCloudExadataInfrastructureDetails", model.CreateCloudExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudExadataInfrastructure",
                    bodyModel: model.CloudExadataInfrastructure,
                    type: "model.CloudExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a cloud VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateCloudVmClusterRequest
     * @return CreateCloudVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateCloudVmCluster.ts.html |here} to see how to use CreateCloudVmCluster API.
     */
    createCloudVmCluster(createCloudVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createCloudVmCluster.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createCloudVmClusterRequest.opcRetryToken,
                "opc-request-id": createCloudVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createCloudVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createCloudVmClusterRequest.createCloudVmClusterDetails, "CreateCloudVmClusterDetails", model.CreateCloudVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudVmCluster",
                    bodyModel: model.CloudVmCluster,
                    type: "model.CloudVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new console connection to the specified database node.
     * After the console connection has been created and is available,
     * you connect to the console using SSH.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateConsoleConnectionRequest
     * @return CreateConsoleConnectionResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateConsoleConnection.ts.html |here} to see how to use CreateConsoleConnection API.
     */
    createConsoleConnection(createConsoleConnectionRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createConsoleConnection.");
            const pathParams = {
                "{dbNodeId}": createConsoleConnectionRequest.dbNodeId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createConsoleConnectionRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createConsoleConnectionRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}/consoleConnections",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createConsoleConnectionRequest.createConsoleConnectionDetails, "CreateConsoleConnectionDetails", model.CreateConsoleConnectionDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "consoleConnection",
                    bodyModel: model.ConsoleConnection,
                    type: "model.ConsoleConnection",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Creates a new Data Guard association.  A Data Guard association represents the replication relationship between the
  * specified database and a peer database. For more information, see [Using Oracle Data Guard](https://docs.cloud.oracle.com/Content/Database/Tasks/usingdataguard.htm).
  * <p>
  All Oracle Cloud Infrastructure resources, including Data Guard associations, get an Oracle-assigned, unique ID
  * called an Oracle Cloud Identifier (OCID). When you create a resource, you can find its OCID in the response.
  * You can also retrieve a resource's OCID by using a List API operation on that resource type, or by viewing the
  * resource in the Console. For more information, see
  * [Resource Identifiers](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm).
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param CreateDataGuardAssociationRequest
       * @return CreateDataGuardAssociationResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateDataGuardAssociation.ts.html |here} to see how to use CreateDataGuardAssociation API.
       */
    createDataGuardAssociation(createDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": createDataGuardAssociationRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createDataGuardAssociationRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createDataGuardAssociationRequest.createDataGuardAssociationDetails, "CreateDataGuardAssociationDetails", model.CreateDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new database in the specified Database Home. If the database version is provided, it must match the version of the Database Home. Applies to Exadata and Exadata Cloud@Customer systems.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateDatabaseRequest
     * @return CreateDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateDatabase.ts.html |here} to see how to use CreateDatabase API.
     */
    createDatabase(createDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createDatabaseRequest.opcRetryToken,
                "opc-request-id": createDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createDatabaseRequest.createNewDatabaseDetails, "CreateDatabaseBase", model.CreateDatabaseBase.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * create database software image in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateDatabaseSoftwareImageRequest
     * @return CreateDatabaseSoftwareImageResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateDatabaseSoftwareImage.ts.html |here} to see how to use CreateDatabaseSoftwareImage API.
     */
    createDatabaseSoftwareImage(createDatabaseSoftwareImageRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createDatabaseSoftwareImage.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createDatabaseSoftwareImageRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createDatabaseSoftwareImageRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createDatabaseSoftwareImageRequest.createDatabaseSoftwareImageDetails, "CreateDatabaseSoftwareImageDetails", model.CreateDatabaseSoftwareImageDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "databaseSoftwareImage",
                    bodyModel: model.DatabaseSoftwareImage,
                    type: "model.DatabaseSoftwareImage",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new Database Home in the specified database system based on the request parameters you provide. Applies to bare metal DB systems, Exadata systems, and Exadata Cloud@Customer systems.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateDbHomeRequest
     * @return CreateDbHomeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateDbHome.ts.html |here} to see how to use CreateDbHome API.
     */
    createDbHome(createDbHomeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createDbHome.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createDbHomeRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createDbHomeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createDbHomeRequest.createDbHomeWithDbSystemIdDetails, "CreateDbHomeBase", model.CreateDbHomeBase.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbHome",
                    bodyModel: model.DbHome,
                    type: "model.DbHome",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates an Exadata infrastructure resource. Applies to Exadata Cloud@Customer instances only.
     * To create an Exadata Cloud Service infrastructure resource, use the  {@link #createCloudExadataInfrastructure(CreateCloudExadataInfrastructureRequest) createCloudExadataInfrastructure} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExadataInfrastructureRequest
     * @return CreateExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExadataInfrastructure.ts.html |here} to see how to use CreateExadataInfrastructure API.
     */
    createExadataInfrastructure(createExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExadataInfrastructure.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExadataInfrastructureRequest.opcRetryToken,
                "opc-request-id": createExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExadataInfrastructureRequest.createExadataInfrastructureDetails, "CreateExadataInfrastructureDetails", model.CreateExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataInfrastructure",
                    bodyModel: model.ExadataInfrastructure,
                    type: "model.ExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new backup resource and returns the information the caller needs to back up an on-premises Oracle Database to Oracle Cloud Infrastructure.
     * <p>
     **Note:** This API is used by an Oracle Cloud Infrastructure Python script that is packaged with the Oracle Cloud Infrastructure CLI. Oracle recommends that you use the script instead using the API directly. See [Migrating an On-Premises Database to Oracle Cloud Infrastructure by Creating a Backup in the Cloud](https://docs.cloud.oracle.com/Content/Database/Tasks/mig-onprembackup.htm) for more information.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExternalBackupJobRequest
     * @return CreateExternalBackupJobResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExternalBackupJob.ts.html |here} to see how to use CreateExternalBackupJob API.
     */
    createExternalBackupJob(createExternalBackupJobRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExternalBackupJob.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExternalBackupJobRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExternalBackupJobRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalBackupJobs",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExternalBackupJobRequest.createExternalBackupJobDetails, "CreateExternalBackupJobDetails", model.CreateExternalBackupJobDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalBackupJob",
                    bodyModel: model.ExternalBackupJob,
                    type: "model.ExternalBackupJob",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new external container database resource.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExternalContainerDatabaseRequest
     * @return CreateExternalContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExternalContainerDatabase.ts.html |here} to see how to use CreateExternalContainerDatabase API.
     */
    createExternalContainerDatabase(createExternalContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExternalContainerDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExternalContainerDatabaseRequest.opcRetryToken,
                "opc-request-id": createExternalContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExternalContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExternalContainerDatabaseRequest.createExternalContainerDatabaseDetails, "CreateExternalContainerDatabaseDetails", model.CreateExternalContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalContainerDatabase",
                    bodyModel: model.ExternalContainerDatabase,
                    type: "model.ExternalContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new external database connector.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExternalDatabaseConnectorRequest
     * @return CreateExternalDatabaseConnectorResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExternalDatabaseConnector.ts.html |here} to see how to use CreateExternalDatabaseConnector API.
     */
    createExternalDatabaseConnector(createExternalDatabaseConnectorRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExternalDatabaseConnector.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExternalDatabaseConnectorRequest.opcRetryToken,
                "opc-request-id": createExternalDatabaseConnectorRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExternalDatabaseConnectorRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExternalDatabaseConnectorRequest.createExternalDatabaseConnectorDetails, "CreateExternalDatabaseConnectorDetails", model.CreateExternalDatabaseConnectorDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalDatabaseConnector",
                    bodyModel: model.ExternalDatabaseConnector,
                    type: "model.ExternalDatabaseConnector",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new ExternalNonContainerDatabase resource
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExternalNonContainerDatabaseRequest
     * @return CreateExternalNonContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExternalNonContainerDatabase.ts.html |here} to see how to use CreateExternalNonContainerDatabase API.
     */
    createExternalNonContainerDatabase(createExternalNonContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExternalNonContainerDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExternalNonContainerDatabaseRequest.opcRetryToken,
                "opc-request-id": createExternalNonContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExternalNonContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExternalNonContainerDatabaseRequest.createExternalNonContainerDatabaseDetails, "CreateExternalNonContainerDatabaseDetails", model.CreateExternalNonContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalNonContainerDatabase",
                    bodyModel: model.ExternalNonContainerDatabase,
                    type: "model.ExternalNonContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Registers a new {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails}
     * resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateExternalPluggableDatabaseRequest
     * @return CreateExternalPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateExternalPluggableDatabase.ts.html |here} to see how to use CreateExternalPluggableDatabase API.
     */
    createExternalPluggableDatabase(createExternalPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createExternalPluggableDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createExternalPluggableDatabaseRequest.opcRetryToken,
                "opc-request-id": createExternalPluggableDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createExternalPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createExternalPluggableDatabaseRequest.createExternalPluggableDatabaseDetails, "CreateExternalPluggableDatabaseDetails", model.CreateExternalPluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalPluggableDatabase",
                    bodyModel: model.ExternalPluggableDatabase,
                    type: "model.ExternalPluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a Key Store.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateKeyStoreRequest
     * @return CreateKeyStoreResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateKeyStore.ts.html |here} to see how to use CreateKeyStore API.
     */
    createKeyStore(createKeyStoreRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createKeyStore.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createKeyStoreRequest.opcRetryToken,
                "opc-request-id": createKeyStoreRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createKeyStoreRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createKeyStoreRequest.createKeyStoreDetails, "CreateKeyStoreDetails", model.CreateKeyStoreDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "keyStore",
                    bodyModel: model.KeyStore,
                    type: "model.KeyStore",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates and starts a pluggable database in the specified container database.
     * Use the {@link #startPluggableDatabase(StartPluggableDatabaseRequest) startPluggableDatabase} and {@link #stopPluggableDatabase(StopPluggableDatabaseRequest) stopPluggableDatabase} APIs to start and stop the pluggable database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreatePluggableDatabaseRequest
     * @return CreatePluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreatePluggableDatabase.ts.html |here} to see how to use CreatePluggableDatabase API.
     */
    createPluggableDatabase(createPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createPluggableDatabase.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createPluggableDatabaseRequest.opcRetryToken,
                "opc-request-id": createPluggableDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createPluggableDatabaseRequest.createPluggableDatabaseDetails, "CreatePluggableDatabaseDetails", model.CreatePluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates an Exadata Cloud@Customer VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateVmClusterRequest
     * @return CreateVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateVmCluster.ts.html |here} to see how to use CreateVmCluster API.
     */
    createVmCluster(createVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createVmCluster.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createVmClusterRequest.opcRetryToken,
                "opc-request-id": createVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createVmClusterRequest.createVmClusterDetails, "CreateVmClusterDetails", model.CreateVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmCluster",
                    bodyModel: model.VmCluster,
                    type: "model.VmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates the VM cluster network. Applies to Exadata Cloud@Customer instances only.
     * To create a cloud VM cluster in an Exadata Cloud Service instance, use the {@link #createCloudVmCluster(CreateCloudVmClusterRequest) createCloudVmCluster} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param CreateVmClusterNetworkRequest
     * @return CreateVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/CreateVmClusterNetwork.ts.html |here} to see how to use CreateVmClusterNetwork API.
     */
    createVmClusterNetwork(createVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#createVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": createVmClusterNetworkRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": createVmClusterNetworkRequest.opcRetryToken,
                "opc-request-id": createVmClusterNetworkRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, createVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(createVmClusterNetworkRequest.vmClusterNetworkDetails, "VmClusterNetworkDetails", model.VmClusterNetworkDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterNetwork",
                    bodyModel: model.VmClusterNetwork,
                    type: "model.VmClusterNetwork",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Performs one of the following power actions on the specified DB node:
     * - start - power on
     * - stop - power off
     * - softreset - ACPI shutdown and power on
     * - reset - power off and power on
     * <p>
     **Note:** Stopping a node affects billing differently, depending on the type of DB system:
     * *Bare metal and Exadata systems* - The _stop_ state has no effect on the resources you consume.
     * Billing continues for DB nodes that you stop, and related resources continue
     * to apply against any relevant quotas. You must terminate the DB system
     * ({@link #terminateDbSystem(TerminateDbSystemRequest) terminateDbSystem})
     * to remove its resources from billing and quotas.
     * *Virtual machine DB systems* - Stopping a node stops billing for all OCPUs associated with that node, and billing resumes when you restart the node.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DbNodeActionRequest
     * @return DbNodeActionResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DbNodeAction.ts.html |here} to see how to use DbNodeAction API.
     */
    dbNodeAction(dbNodeActionRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#dbNodeAction.");
            const pathParams = {
                "{dbNodeId}": dbNodeActionRequest.dbNodeId
            };
            const queryParams = {
                "action": dbNodeActionRequest.action
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": dbNodeActionRequest.opcRetryToken,
                "if-match": dbNodeActionRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, dbNodeActionRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbNode",
                    bodyModel: model.DbNode,
                    type: "model.DbNode",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteAutonomousDatabaseRequest
     * @return DeleteAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteAutonomousDatabase.ts.html |here} to see how to use DeleteAutonomousDatabase API.
     */
    deleteAutonomousDatabase(deleteAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": deleteAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteAutonomousDatabaseRequest.ifMatch,
                "opc-request-id": deleteAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified Autonomous VM cluster in an Exadata Cloud@Customer system. To delete an Autonomous VM Cluster in the Oracle cloud, see {@link #deleteCloudAutonomousVmCluster(DeleteCloudAutonomousVmClusterRequest) deleteCloudAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteAutonomousVmClusterRequest
     * @return DeleteAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteAutonomousVmCluster.ts.html |here} to see how to use DeleteAutonomousVmCluster API.
     */
    deleteAutonomousVmCluster(deleteAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteAutonomousVmCluster.");
            const pathParams = {
                "{autonomousVmClusterId}": deleteAutonomousVmClusterRequest.autonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteAutonomousVmClusterRequest.ifMatch,
                "opc-request-id": deleteAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters/{autonomousVmClusterId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes a full backup. You cannot delete automatic backups using this API.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteBackupRequest
     * @return DeleteBackupResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteBackup.ts.html |here} to see how to use DeleteBackup API.
     */
    deleteBackup(deleteBackupRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteBackup.");
            const pathParams = {
                "{backupId}": deleteBackupRequest.backupId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteBackupRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteBackupRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backups/{backupId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes a backup destination in an Exadata Cloud@Customer system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteBackupDestinationRequest
     * @return DeleteBackupDestinationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteBackupDestination.ts.html |here} to see how to use DeleteBackupDestination API.
     */
    deleteBackupDestination(deleteBackupDestinationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteBackupDestination.");
            const pathParams = {
                "{backupDestinationId}": deleteBackupDestinationRequest.backupDestinationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteBackupDestinationRequest.ifMatch,
                "opc-request-id": deleteBackupDestinationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteBackupDestinationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations/{backupDestinationId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified Autonomous Exadata VM cluster in the Oracle cloud. For Exadata Cloud@Customer systems, see {@link #deleteAutonomousVmCluster(DeleteAutonomousVmClusterRequest) deleteAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteCloudAutonomousVmClusterRequest
     * @return DeleteCloudAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteCloudAutonomousVmCluster.ts.html |here} to see how to use DeleteCloudAutonomousVmCluster API.
     */
    deleteCloudAutonomousVmCluster(deleteCloudAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteCloudAutonomousVmCluster.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": deleteCloudAutonomousVmClusterRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteCloudAutonomousVmClusterRequest.ifMatch,
                "opc-request-id": deleteCloudAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteCloudAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the cloud Exadata infrastructure resource. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteCloudExadataInfrastructureRequest
     * @return DeleteCloudExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteCloudExadataInfrastructure.ts.html |here} to see how to use DeleteCloudExadataInfrastructure API.
     */
    deleteCloudExadataInfrastructure(deleteCloudExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteCloudExadataInfrastructure.");
            const pathParams = {
                "{cloudExadataInfrastructureId}": deleteCloudExadataInfrastructureRequest.cloudExadataInfrastructureId
            };
            const queryParams = {
                "isDeleteVmClusters": deleteCloudExadataInfrastructureRequest.isDeleteVmClusters
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteCloudExadataInfrastructureRequest.ifMatch,
                "opc-request-id": deleteCloudExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteCloudExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures/{cloudExadataInfrastructureId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified cloud VM cluster. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteCloudVmClusterRequest
     * @return DeleteCloudVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteCloudVmCluster.ts.html |here} to see how to use DeleteCloudVmCluster API.
     */
    deleteCloudVmCluster(deleteCloudVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteCloudVmCluster.");
            const pathParams = {
                "{cloudVmClusterId}": deleteCloudVmClusterRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteCloudVmClusterRequest.ifMatch,
                "opc-request-id": deleteCloudVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteCloudVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified database node console connection.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteConsoleConnectionRequest
     * @return DeleteConsoleConnectionResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteConsoleConnection.ts.html |here} to see how to use DeleteConsoleConnection API.
     */
    deleteConsoleConnection(deleteConsoleConnectionRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteConsoleConnection.");
            const pathParams = {
                "{dbNodeId}": deleteConsoleConnectionRequest.dbNodeId,
                "{consoleConnectionId}": deleteConsoleConnectionRequest.consoleConnectionId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteConsoleConnectionRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteConsoleConnectionRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}/consoleConnections/{consoleConnectionId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Deletes the specified database. Applies only to Exadata systems.
  * <p>
  The data in this database is local to the Exadata system and will be lost when the database is deleted. Oracle recommends that you back up any data in the Exadata system prior to deleting it. You can use the `performFinalBackup` parameter to have the Exadata system database backed up before it is deleted.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param DeleteDatabaseRequest
       * @return DeleteDatabaseResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteDatabase.ts.html |here} to see how to use DeleteDatabase API.
       */
    deleteDatabase(deleteDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteDatabase.");
            const pathParams = {
                "{databaseId}": deleteDatabaseRequest.databaseId
            };
            const queryParams = {
                "performFinalBackup": deleteDatabaseRequest.performFinalBackup
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteDatabaseRequest.ifMatch,
                "opc-request-id": deleteDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Delete a database software image
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteDatabaseSoftwareImageRequest
     * @return DeleteDatabaseSoftwareImageResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteDatabaseSoftwareImage.ts.html |here} to see how to use DeleteDatabaseSoftwareImage API.
     */
    deleteDatabaseSoftwareImage(deleteDatabaseSoftwareImageRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteDatabaseSoftwareImage.");
            const pathParams = {
                "{databaseSoftwareImageId}": deleteDatabaseSoftwareImageRequest.databaseSoftwareImageId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteDatabaseSoftwareImageRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteDatabaseSoftwareImageRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages/{databaseSoftwareImageId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Deletes a Database Home. Applies to bare metal DB systems, Exadata Cloud Service, and Exadata Cloud@Customer systems.
  * <p>
  Oracle recommends that you use the `performFinalBackup` parameter to back up any data on a bare metal DB system before you delete a Database Home. On an Exadata Cloud@Customer system or an Exadata Cloud Service system, you can delete a Database Home only when there are no databases in it and therefore you cannot use the `performFinalBackup` parameter to back up data.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param DeleteDbHomeRequest
       * @return DeleteDbHomeResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteDbHome.ts.html |here} to see how to use DeleteDbHome API.
       */
    deleteDbHome(deleteDbHomeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteDbHome.");
            const pathParams = {
                "{dbHomeId}": deleteDbHomeRequest.dbHomeId
            };
            const queryParams = {
                "performFinalBackup": deleteDbHomeRequest.performFinalBackup
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteDbHomeRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteDbHomeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the Exadata Cloud@Customer infrastructure.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteExadataInfrastructureRequest
     * @return DeleteExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteExadataInfrastructure.ts.html |here} to see how to use DeleteExadataInfrastructure API.
     */
    deleteExadataInfrastructure(deleteExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteExadataInfrastructure.");
            const pathParams = {
                "{exadataInfrastructureId}": deleteExadataInfrastructureRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteExadataInfrastructureRequest.ifMatch,
                "opc-request-id": deleteExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the {@link #createExternalContainerDatabaseDetails(CreateExternalContainerDatabaseDetailsRequest) createExternalContainerDatabaseDetails}
     * resource. Any external pluggable databases registered under this container database must be deleted in
     * your Oracle Cloud Infrastructure tenancy prior to this operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteExternalContainerDatabaseRequest
     * @return DeleteExternalContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteExternalContainerDatabase.ts.html |here} to see how to use DeleteExternalContainerDatabase API.
     */
    deleteExternalContainerDatabase(deleteExternalContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteExternalContainerDatabase.");
            const pathParams = {
                "{externalContainerDatabaseId}": deleteExternalContainerDatabaseRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": deleteExternalContainerDatabaseRequest.opcRequestId,
                "if-match": deleteExternalContainerDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteExternalContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes an external database connector.
     * Any services enabled using the external database connector must be
     * deleted prior to this operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteExternalDatabaseConnectorRequest
     * @return DeleteExternalDatabaseConnectorResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteExternalDatabaseConnector.ts.html |here} to see how to use DeleteExternalDatabaseConnector API.
     */
    deleteExternalDatabaseConnector(deleteExternalDatabaseConnectorRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteExternalDatabaseConnector.");
            const pathParams = {
                "{externalDatabaseConnectorId}": deleteExternalDatabaseConnectorRequest.externalDatabaseConnectorId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteExternalDatabaseConnectorRequest.ifMatch,
                "opc-request-id": deleteExternalDatabaseConnectorRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteExternalDatabaseConnectorRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors/{externalDatabaseConnectorId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the Oracle Cloud Infrastructure resource representing an external non-container database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteExternalNonContainerDatabaseRequest
     * @return DeleteExternalNonContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteExternalNonContainerDatabase.ts.html |here} to see how to use DeleteExternalNonContainerDatabase API.
     */
    deleteExternalNonContainerDatabase(deleteExternalNonContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteExternalNonContainerDatabase.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": deleteExternalNonContainerDatabaseRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteExternalNonContainerDatabaseRequest.ifMatch,
                "opc-request-id": deleteExternalNonContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteExternalNonContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails}.
     * resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteExternalPluggableDatabaseRequest
     * @return DeleteExternalPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteExternalPluggableDatabase.ts.html |here} to see how to use DeleteExternalPluggableDatabase API.
     */
    deleteExternalPluggableDatabase(deleteExternalPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteExternalPluggableDatabase.");
            const pathParams = {
                "{externalPluggableDatabaseId}": deleteExternalPluggableDatabaseRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": deleteExternalPluggableDatabaseRequest.opcRequestId,
                "if-match": deleteExternalPluggableDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteExternalPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes a key store.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteKeyStoreRequest
     * @return DeleteKeyStoreResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteKeyStore.ts.html |here} to see how to use DeleteKeyStore API.
     */
    deleteKeyStore(deleteKeyStoreRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteKeyStore.");
            const pathParams = {
                "{keyStoreId}": deleteKeyStoreRequest.keyStoreId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteKeyStoreRequest.ifMatch,
                "opc-request-id": deleteKeyStoreRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteKeyStoreRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores/{keyStoreId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified pluggable database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeletePluggableDatabaseRequest
     * @return DeletePluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeletePluggableDatabase.ts.html |here} to see how to use DeletePluggableDatabase API.
     */
    deletePluggableDatabase(deletePluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deletePluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": deletePluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deletePluggableDatabaseRequest.ifMatch,
                "opc-request-id": deletePluggableDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deletePluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteVmClusterRequest
     * @return DeleteVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteVmCluster.ts.html |here} to see how to use DeleteVmCluster API.
     */
    deleteVmCluster(deleteVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteVmCluster.");
            const pathParams = {
                "{vmClusterId}": deleteVmClusterRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteVmClusterRequest.ifMatch,
                "opc-request-id": deleteVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Deletes the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     * To delete a cloud VM cluster in an Exadata Cloud Service instance, use the {@link #deleteCloudVmCluster(DeleteCloudVmClusterRequest) deleteCloudVmCluster} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeleteVmClusterNetworkRequest
     * @return DeleteVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeleteVmClusterNetwork.ts.html |here} to see how to use DeleteVmClusterNetwork API.
     */
    deleteVmClusterNetwork(deleteVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deleteVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": deleteVmClusterNetworkRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": deleteVmClusterNetworkRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": deleteVmClusterNetworkRequest.ifMatch,
                "opc-request-id": deleteVmClusterNetworkRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deleteVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Asynchronously deregisters this Autonomous Database with Data Safe.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DeregisterAutonomousDatabaseDataSafeRequest
     * @return DeregisterAutonomousDatabaseDataSafeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DeregisterAutonomousDatabaseDataSafe.ts.html |here} to see how to use DeregisterAutonomousDatabaseDataSafe API.
     */
    deregisterAutonomousDatabaseDataSafe(deregisterAutonomousDatabaseDataSafeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#deregisterAutonomousDatabaseDataSafe.");
            const pathParams = {
                "{autonomousDatabaseId}": deregisterAutonomousDatabaseDataSafeRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": deregisterAutonomousDatabaseDataSafeRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, deregisterAutonomousDatabaseDataSafeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/deregisterDataSafe",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(deregisterAutonomousDatabaseDataSafeRequest.deregisterAutonomousDatabaseDataSafeDetails, "DeregisterAutonomousDatabaseDataSafeDetails", model.DeregisterAutonomousDatabaseDataSafeDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disables Database Management for the Autonomous Database resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableAutonomousDatabaseManagementRequest
     * @return DisableAutonomousDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableAutonomousDatabaseManagement.ts.html |here} to see how to use DisableAutonomousDatabaseManagement API.
     */
    disableAutonomousDatabaseManagement(disableAutonomousDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableAutonomousDatabaseManagement.");
            const pathParams = {
                "{autonomousDatabaseId}": disableAutonomousDatabaseManagementRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": disableAutonomousDatabaseManagementRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableAutonomousDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/disableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disables Operations Insights for the Autonomous Database resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableAutonomousDatabaseOperationsInsightsRequest
     * @return DisableAutonomousDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableAutonomousDatabaseOperationsInsights.ts.html |here} to see how to use DisableAutonomousDatabaseOperationsInsights API.
     */
    disableAutonomousDatabaseOperationsInsights(disableAutonomousDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableAutonomousDatabaseOperationsInsights.");
            const pathParams = {
                "{autonomousDatabaseId}": disableAutonomousDatabaseOperationsInsightsRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": disableAutonomousDatabaseOperationsInsightsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableAutonomousDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/disableOperationsInsights",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disables the Database Management service for the database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableDatabaseManagementRequest
     * @return DisableDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableDatabaseManagement.ts.html |here} to see how to use DisableDatabaseManagement API.
     */
    disableDatabaseManagement(disableDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableDatabaseManagement.");
            const pathParams = {
                "{databaseId}": disableDatabaseManagementRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": disableDatabaseManagementRequest.opcRequestId,
                "if-match": disableDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/disableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disable Database Management service for the external container database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableExternalContainerDatabaseDatabaseManagementRequest
     * @return DisableExternalContainerDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableExternalContainerDatabaseDatabaseManagement.ts.html |here} to see how to use DisableExternalContainerDatabaseDatabaseManagement API.
     */
    disableExternalContainerDatabaseDatabaseManagement(disableExternalContainerDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableExternalContainerDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalContainerDatabaseId}": disableExternalContainerDatabaseDatabaseManagementRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableExternalContainerDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": disableExternalContainerDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": disableExternalContainerDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableExternalContainerDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}/actions/disableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disable Database Management Service for the external non-container database.
     * For more information about the Database Management Service, see
     * [Database Management Service](https://docs.cloud.oracle.com/Content/ExternalDatabase/Concepts/databasemanagementservice.htm).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableExternalNonContainerDatabaseDatabaseManagementRequest
     * @return DisableExternalNonContainerDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableExternalNonContainerDatabaseDatabaseManagement.ts.html |here} to see how to use DisableExternalNonContainerDatabaseDatabaseManagement API.
     */
    disableExternalNonContainerDatabaseDatabaseManagement(disableExternalNonContainerDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableExternalNonContainerDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": disableExternalNonContainerDatabaseDatabaseManagementRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableExternalNonContainerDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": disableExternalNonContainerDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": disableExternalNonContainerDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableExternalNonContainerDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}/actions/disableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disable Operations Insights for the external non-container database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableExternalNonContainerDatabaseOperationsInsightsRequest
     * @return DisableExternalNonContainerDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableExternalNonContainerDatabaseOperationsInsights.ts.html |here} to see how to use DisableExternalNonContainerDatabaseOperationsInsights API.
     */
    disableExternalNonContainerDatabaseOperationsInsights(disableExternalNonContainerDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableExternalNonContainerDatabaseOperationsInsights.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": disableExternalNonContainerDatabaseOperationsInsightsRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableExternalNonContainerDatabaseOperationsInsightsRequest.opcRetryToken,
                "opc-request-id": disableExternalNonContainerDatabaseOperationsInsightsRequest.opcRequestId,
                "if-match": disableExternalNonContainerDatabaseOperationsInsightsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableExternalNonContainerDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}/actions/disableOperationsInsights",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disable Database Management Service for the external pluggable database.
     * For more information about the Database Management Service, see
     * [Database Management Service](https://docs.cloud.oracle.com/Content/ExternalDatabase/Concepts/databasemanagementservice.htm).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableExternalPluggableDatabaseDatabaseManagementRequest
     * @return DisableExternalPluggableDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableExternalPluggableDatabaseDatabaseManagement.ts.html |here} to see how to use DisableExternalPluggableDatabaseDatabaseManagement API.
     */
    disableExternalPluggableDatabaseDatabaseManagement(disableExternalPluggableDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableExternalPluggableDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalPluggableDatabaseId}": disableExternalPluggableDatabaseDatabaseManagementRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableExternalPluggableDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": disableExternalPluggableDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": disableExternalPluggableDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableExternalPluggableDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}/actions/disableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Disable Operations Insights for the external pluggable database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DisableExternalPluggableDatabaseOperationsInsightsRequest
     * @return DisableExternalPluggableDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DisableExternalPluggableDatabaseOperationsInsights.ts.html |here} to see how to use DisableExternalPluggableDatabaseOperationsInsights API.
     */
    disableExternalPluggableDatabaseOperationsInsights(disableExternalPluggableDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#disableExternalPluggableDatabaseOperationsInsights.");
            const pathParams = {
                "{externalPluggableDatabaseId}": disableExternalPluggableDatabaseOperationsInsightsRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": disableExternalPluggableDatabaseOperationsInsightsRequest.opcRetryToken,
                "opc-request-id": disableExternalPluggableDatabaseOperationsInsightsRequest.opcRequestId,
                "if-match": disableExternalPluggableDatabaseOperationsInsightsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, disableExternalPluggableDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}/actions/disableOperationsInsights",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Downloads the configuration file for the specified Exadata Cloud@Customer infrastructure.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DownloadExadataInfrastructureConfigFileRequest
     * @return DownloadExadataInfrastructureConfigFileResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DownloadExadataInfrastructureConfigFile.ts.html |here} to see how to use DownloadExadataInfrastructureConfigFile API.
     */
    downloadExadataInfrastructureConfigFile(downloadExadataInfrastructureConfigFileRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#downloadExadataInfrastructureConfigFile.");
            const pathParams = {
                "{exadataInfrastructureId}": downloadExadataInfrastructureConfigFileRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": downloadExadataInfrastructureConfigFileRequest.opcRequestId,
                "opc-retry-token": downloadExadataInfrastructureConfigFileRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, downloadExadataInfrastructureConfigFileRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/actions/downloadConfigFile",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: response.body,
                    bodyKey: "value",
                    bodyModel: "string",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("content-length"),
                            key: "contentLength",
                            dataType: "number"
                        },
                        {
                            value: response.headers.get("last-modified"),
                            key: "lastModified",
                            dataType: "Date"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Downloads the network validation report file for the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DownloadValidationReportRequest
     * @return DownloadValidationReportResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DownloadValidationReport.ts.html |here} to see how to use DownloadValidationReport API.
     */
    downloadValidationReport(downloadValidationReportRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#downloadValidationReport.");
            const pathParams = {
                "{exadataInfrastructureId}": downloadValidationReportRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": downloadValidationReportRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": downloadValidationReportRequest.opcRequestId,
                "opc-retry-token": downloadValidationReportRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, downloadValidationReportRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}/actions/downloadValidationReport",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: response.body,
                    bodyKey: "value",
                    bodyModel: "string",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("content-length"),
                            key: "contentLength",
                            dataType: "number"
                        },
                        {
                            value: response.headers.get("last-modified"),
                            key: "lastModified",
                            dataType: "Date"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Downloads the configuration file for the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param DownloadVmClusterNetworkConfigFileRequest
     * @return DownloadVmClusterNetworkConfigFileResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/DownloadVmClusterNetworkConfigFile.ts.html |here} to see how to use DownloadVmClusterNetworkConfigFile API.
     */
    downloadVmClusterNetworkConfigFile(downloadVmClusterNetworkConfigFileRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#downloadVmClusterNetworkConfigFile.");
            const pathParams = {
                "{exadataInfrastructureId}": downloadVmClusterNetworkConfigFileRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": downloadVmClusterNetworkConfigFileRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": downloadVmClusterNetworkConfigFileRequest.opcRequestId,
                "opc-retry-token": downloadVmClusterNetworkConfigFileRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, downloadVmClusterNetworkConfigFileRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}/actions/downloadConfigFile",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: response.body,
                    bodyKey: "value",
                    bodyModel: "string",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("content-length"),
                            key: "contentLength",
                            dataType: "number"
                        },
                        {
                            value: response.headers.get("last-modified"),
                            key: "lastModified",
                            dataType: "Date"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enables Database Management for Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableAutonomousDatabaseManagementRequest
     * @return EnableAutonomousDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableAutonomousDatabaseManagement.ts.html |here} to see how to use EnableAutonomousDatabaseManagement API.
     */
    enableAutonomousDatabaseManagement(enableAutonomousDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableAutonomousDatabaseManagement.");
            const pathParams = {
                "{autonomousDatabaseId}": enableAutonomousDatabaseManagementRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": enableAutonomousDatabaseManagementRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableAutonomousDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/enableDatabaseManagement",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enables the specified Autonomous Database with Operations Insights.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableAutonomousDatabaseOperationsInsightsRequest
     * @return EnableAutonomousDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableAutonomousDatabaseOperationsInsights.ts.html |here} to see how to use EnableAutonomousDatabaseOperationsInsights API.
     */
    enableAutonomousDatabaseOperationsInsights(enableAutonomousDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableAutonomousDatabaseOperationsInsights.");
            const pathParams = {
                "{autonomousDatabaseId}": enableAutonomousDatabaseOperationsInsightsRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": enableAutonomousDatabaseOperationsInsightsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableAutonomousDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/enableOperationsInsights",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enables the Database Management service for an Oracle Database located in Oracle Cloud Infrastructure. This service allows the database to access tools including Metrics and Performance hub. Database Management is enabled at the container database (CDB) level.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableDatabaseManagementRequest
     * @return EnableDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableDatabaseManagement.ts.html |here} to see how to use EnableDatabaseManagement API.
     */
    enableDatabaseManagement(enableDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableDatabaseManagement.");
            const pathParams = {
                "{databaseId}": enableDatabaseManagementRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": enableDatabaseManagementRequest.opcRequestId,
                "if-match": enableDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/enableDatabaseManagement",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableDatabaseManagementRequest.enableDatabaseManagementDetails, "EnableDatabaseManagementDetails", model.EnableDatabaseManagementDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enables Database Management Service for the external container database.
     * For more information about the Database Management Service, see
     * [Database Management Service](https://docs.cloud.oracle.com/Content/ExternalDatabase/Concepts/databasemanagementservice.htm).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableExternalContainerDatabaseDatabaseManagementRequest
     * @return EnableExternalContainerDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableExternalContainerDatabaseDatabaseManagement.ts.html |here} to see how to use EnableExternalContainerDatabaseDatabaseManagement API.
     */
    enableExternalContainerDatabaseDatabaseManagement(enableExternalContainerDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableExternalContainerDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalContainerDatabaseId}": enableExternalContainerDatabaseDatabaseManagementRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableExternalContainerDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": enableExternalContainerDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": enableExternalContainerDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableExternalContainerDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}/actions/enableDatabaseManagement",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableExternalContainerDatabaseDatabaseManagementRequest.enableExternalContainerDatabaseDatabaseManagementDetails, "EnableExternalContainerDatabaseDatabaseManagementDetails", model.EnableExternalContainerDatabaseDatabaseManagementDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enable Database Management Service for the external non-container database.
     * For more information about the Database Management Service, see
     * [Database Management Service](https://docs.cloud.oracle.com/Content/ExternalDatabase/Concepts/databasemanagementservice.htm).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableExternalNonContainerDatabaseDatabaseManagementRequest
     * @return EnableExternalNonContainerDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableExternalNonContainerDatabaseDatabaseManagement.ts.html |here} to see how to use EnableExternalNonContainerDatabaseDatabaseManagement API.
     */
    enableExternalNonContainerDatabaseDatabaseManagement(enableExternalNonContainerDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableExternalNonContainerDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": enableExternalNonContainerDatabaseDatabaseManagementRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableExternalNonContainerDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": enableExternalNonContainerDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": enableExternalNonContainerDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableExternalNonContainerDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}/actions/enableDatabaseManagement",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableExternalNonContainerDatabaseDatabaseManagementRequest.enableExternalNonContainerDatabaseDatabaseManagementDetails, "EnableExternalNonContainerDatabaseDatabaseManagementDetails", model.EnableExternalNonContainerDatabaseDatabaseManagementDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enable Operations Insights for the external non-container database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableExternalNonContainerDatabaseOperationsInsightsRequest
     * @return EnableExternalNonContainerDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableExternalNonContainerDatabaseOperationsInsights.ts.html |here} to see how to use EnableExternalNonContainerDatabaseOperationsInsights API.
     */
    enableExternalNonContainerDatabaseOperationsInsights(enableExternalNonContainerDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableExternalNonContainerDatabaseOperationsInsights.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": enableExternalNonContainerDatabaseOperationsInsightsRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableExternalNonContainerDatabaseOperationsInsightsRequest.opcRetryToken,
                "opc-request-id": enableExternalNonContainerDatabaseOperationsInsightsRequest.opcRequestId,
                "if-match": enableExternalNonContainerDatabaseOperationsInsightsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableExternalNonContainerDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}/actions/enableOperationsInsights",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableExternalNonContainerDatabaseOperationsInsightsRequest.enableExternalNonContainerDatabaseOperationsInsightsDetails, "EnableExternalNonContainerDatabaseOperationsInsightsDetails", model.EnableExternalNonContainerDatabaseOperationsInsightsDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enable Database Management Service for the external pluggable database.
     * For more information about the Database Management Service, see
     * [Database Management Service](https://docs.cloud.oracle.com/Content/ExternalDatabase/Concepts/databasemanagementservice.htm).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableExternalPluggableDatabaseDatabaseManagementRequest
     * @return EnableExternalPluggableDatabaseDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableExternalPluggableDatabaseDatabaseManagement.ts.html |here} to see how to use EnableExternalPluggableDatabaseDatabaseManagement API.
     */
    enableExternalPluggableDatabaseDatabaseManagement(enableExternalPluggableDatabaseDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableExternalPluggableDatabaseDatabaseManagement.");
            const pathParams = {
                "{externalPluggableDatabaseId}": enableExternalPluggableDatabaseDatabaseManagementRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableExternalPluggableDatabaseDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": enableExternalPluggableDatabaseDatabaseManagementRequest.opcRequestId,
                "if-match": enableExternalPluggableDatabaseDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableExternalPluggableDatabaseDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}/actions/enableDatabaseManagement",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableExternalPluggableDatabaseDatabaseManagementRequest.enableExternalPluggableDatabaseDatabaseManagementDetails, "EnableExternalPluggableDatabaseDatabaseManagementDetails", model.EnableExternalPluggableDatabaseDatabaseManagementDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Enable Operations Insights for the external pluggable database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param EnableExternalPluggableDatabaseOperationsInsightsRequest
     * @return EnableExternalPluggableDatabaseOperationsInsightsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/EnableExternalPluggableDatabaseOperationsInsights.ts.html |here} to see how to use EnableExternalPluggableDatabaseOperationsInsights API.
     */
    enableExternalPluggableDatabaseOperationsInsights(enableExternalPluggableDatabaseOperationsInsightsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#enableExternalPluggableDatabaseOperationsInsights.");
            const pathParams = {
                "{externalPluggableDatabaseId}": enableExternalPluggableDatabaseOperationsInsightsRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": enableExternalPluggableDatabaseOperationsInsightsRequest.opcRetryToken,
                "opc-request-id": enableExternalPluggableDatabaseOperationsInsightsRequest.opcRequestId,
                "if-match": enableExternalPluggableDatabaseOperationsInsightsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, enableExternalPluggableDatabaseOperationsInsightsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}/actions/enableOperationsInsights",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(enableExternalPluggableDatabaseOperationsInsightsRequest.enableExternalPluggableDatabaseOperationsInsightsDetails, "EnableExternalPluggableDatabaseOperationsInsightsDetails", model.EnableExternalPluggableDatabaseOperationsInsightsDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Initiates a failover the specified Autonomous Database to a standby. To perform a failover to a standby located in a remote region, specify the [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the remote standby using the `peerDbId` parameter.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param FailOverAutonomousDatabaseRequest
     * @return FailOverAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/FailOverAutonomousDatabase.ts.html |here} to see how to use FailOverAutonomousDatabase API.
     */
    failOverAutonomousDatabase(failOverAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#failOverAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": failOverAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {
                "peerDbId": failOverAutonomousDatabaseRequest.peerDbId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": failOverAutonomousDatabaseRequest.ifMatch,
                "opc-retry-token": failOverAutonomousDatabaseRequest.opcRetryToken,
                "opc-request-id": failOverAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, failOverAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/failover",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Fails over the standby Autonomous Container Database identified by the autonomousContainerDatabaseId parameter to the primary Autonomous Container Database after the existing primary Autonomous Container Database fails or becomes unreachable.
  * <p>
  A failover can result in data loss, depending on the protection mode in effect at the time the primary Autonomous Container Database fails.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param FailoverAutonomousContainerDatabaseDataguardAssociationRequest
       * @return FailoverAutonomousContainerDatabaseDataguardAssociationResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/FailoverAutonomousContainerDatabaseDataguardAssociation.ts.html |here} to see how to use FailoverAutonomousContainerDatabaseDataguardAssociation API.
       */
    failoverAutonomousContainerDatabaseDataguardAssociation(failoverAutonomousContainerDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#failoverAutonomousContainerDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": failoverAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseId,
                "{autonomousContainerDatabaseDataguardAssociationId}": failoverAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": failoverAutonomousContainerDatabaseDataguardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, failoverAutonomousContainerDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations/{autonomousContainerDatabaseDataguardAssociationId}/actions/failover",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "model.AutonomousContainerDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Performs a failover to transition the standby database identified by the `databaseId` parameter into the
  * specified Data Guard association's primary role after the existing primary database fails or becomes unreachable.
  * <p>
  A failover might result in data loss depending on the protection mode in effect at the time of the primary
  * database failure.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param FailoverDataGuardAssociationRequest
       * @return FailoverDataGuardAssociationResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/FailoverDataGuardAssociation.ts.html |here} to see how to use FailoverDataGuardAssociation API.
       */
    failoverDataGuardAssociation(failoverDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#failoverDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": failoverDataGuardAssociationRequest.databaseId,
                "{dataGuardAssociationId}": failoverDataGuardAssociationRequest.dataGuardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": failoverDataGuardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, failoverDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations/{dataGuardAssociationId}/actions/failover",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(failoverDataGuardAssociationRequest.failoverDataGuardAssociationDetails, "FailoverDataGuardAssociationDetails", model.FailoverDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates and downloads a wallet for the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GenerateAutonomousDatabaseWalletRequest
     * @return GenerateAutonomousDatabaseWalletResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GenerateAutonomousDatabaseWallet.ts.html |here} to see how to use GenerateAutonomousDatabaseWallet API.
     */
    generateAutonomousDatabaseWallet(generateAutonomousDatabaseWalletRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#generateAutonomousDatabaseWallet.");
            const pathParams = {
                "{autonomousDatabaseId}": generateAutonomousDatabaseWalletRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": generateAutonomousDatabaseWalletRequest.opcRequestId,
                "opc-retry-token": generateAutonomousDatabaseWalletRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, generateAutonomousDatabaseWalletRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/generateWallet",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(generateAutonomousDatabaseWalletRequest.generateAutonomousDatabaseWalletDetails, "GenerateAutonomousDatabaseWalletDetails", model.GenerateAutonomousDatabaseWalletDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: response.body,
                    bodyKey: "value",
                    bodyModel: "string",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("content-length"),
                            key: "contentLength",
                            dataType: "number"
                        },
                        {
                            value: response.headers.get("last-modified"),
                            key: "lastModified",
                            dataType: "Date"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Generates a recommended Cloud@Customer VM cluster network configuration.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GenerateRecommendedVmClusterNetworkRequest
     * @return GenerateRecommendedVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GenerateRecommendedVmClusterNetwork.ts.html |here} to see how to use GenerateRecommendedVmClusterNetwork API.
     */
    generateRecommendedVmClusterNetwork(generateRecommendedVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#generateRecommendedVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": generateRecommendedVmClusterNetworkRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": generateRecommendedVmClusterNetworkRequest.opcRequestId,
                "opc-retry-token": generateRecommendedVmClusterNetworkRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, generateRecommendedVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/actions/generateRecommendedNetwork",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(generateRecommendedVmClusterNetworkRequest.generateRecommendedNetworkDetails, "GenerateRecommendedNetworkDetails", model.GenerateRecommendedNetworkDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterNetworkDetails",
                    bodyModel: model.VmClusterNetworkDetails,
                    type: "model.VmClusterNetworkDetails",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Autonomous Container Database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousContainerDatabaseRequest
     * @return GetAutonomousContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousContainerDatabase.ts.html |here} to see how to use GetAutonomousContainerDatabase API.
     */
    getAutonomousContainerDatabase(getAutonomousContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousContainerDatabase.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": getAutonomousContainerDatabaseRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabase",
                    bodyModel: model.AutonomousContainerDatabase,
                    type: "model.AutonomousContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets an Autonomous Container Database enabled with Autonomous Data Guard associated with the specified Autonomous Container Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousContainerDatabaseDataguardAssociationRequest
     * @return GetAutonomousContainerDatabaseDataguardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousContainerDatabaseDataguardAssociation.ts.html |here} to see how to use GetAutonomousContainerDatabaseDataguardAssociation API.
     */
    getAutonomousContainerDatabaseDataguardAssociation(getAutonomousContainerDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousContainerDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": getAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseId,
                "{autonomousContainerDatabaseDataguardAssociationId}": getAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousContainerDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations/{autonomousContainerDatabaseDataguardAssociationId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "model.AutonomousContainerDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the details of the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousDatabaseRequest
     * @return GetAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousDatabase.ts.html |here} to see how to use GetAutonomousDatabase API.
     */
    getAutonomousDatabase(getAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": getAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Autonomous Database backup.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousDatabaseBackupRequest
     * @return GetAutonomousDatabaseBackupResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousDatabaseBackup.ts.html |here} to see how to use GetAutonomousDatabaseBackup API.
     */
    getAutonomousDatabaseBackup(getAutonomousDatabaseBackupRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousDatabaseBackup.");
            const pathParams = {
                "{autonomousDatabaseBackupId}": getAutonomousDatabaseBackupRequest.autonomousDatabaseBackupId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousDatabaseBackupRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousDatabaseBackupRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabaseBackups/{autonomousDatabaseBackupId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabaseBackup",
                    bodyModel: model.AutonomousDatabaseBackup,
                    type: "model.AutonomousDatabaseBackup",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets an Autonomous Data Guard-enabled database associated with the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousDatabaseDataguardAssociationRequest
     * @return GetAutonomousDatabaseDataguardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousDatabaseDataguardAssociation.ts.html |here} to see how to use GetAutonomousDatabaseDataguardAssociation API.
     */
    getAutonomousDatabaseDataguardAssociation(getAutonomousDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousDatabaseId}": getAutonomousDatabaseDataguardAssociationRequest.autonomousDatabaseId,
                "{autonomousDatabaseDataguardAssociationId}": getAutonomousDatabaseDataguardAssociationRequest.autonomousDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousDatabaseDataguardAssociationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/autonomousDatabaseDataguardAssociations/{autonomousDatabaseDataguardAssociationId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousDatabaseDataguardAssociation,
                    type: "model.AutonomousDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the Autonomous Database regional wallet details.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousDatabaseRegionalWalletRequest
     * @return GetAutonomousDatabaseRegionalWalletResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousDatabaseRegionalWallet.ts.html |here} to see how to use GetAutonomousDatabaseRegionalWallet API.
     */
    getAutonomousDatabaseRegionalWallet(getAutonomousDatabaseRegionalWalletRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousDatabaseRegionalWallet.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousDatabaseRegionalWalletRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousDatabaseRegionalWalletRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/wallet",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabaseWallet",
                    bodyModel: model.AutonomousDatabaseWallet,
                    type: "model.AutonomousDatabaseWallet",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the wallet details for the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousDatabaseWalletRequest
     * @return GetAutonomousDatabaseWalletResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousDatabaseWallet.ts.html |here} to see how to use GetAutonomousDatabaseWallet API.
     */
    getAutonomousDatabaseWallet(getAutonomousDatabaseWalletRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousDatabaseWallet.");
            const pathParams = {
                "{autonomousDatabaseId}": getAutonomousDatabaseWalletRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousDatabaseWalletRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousDatabaseWalletRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/wallet",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabaseWallet",
                    bodyModel: model.AutonomousDatabaseWallet,
                    type: "model.AutonomousDatabaseWallet",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** Use the {@link #getCloudExadataInfrastructure(GetCloudExadataInfrastructureRequest) getCloudExadataInfrastructure} operation to get details of an Exadata Infrastructure resource and the {@link #getCloudAutonomousVmCluster(GetCloudAutonomousVmClusterRequest) getCloudAutonomousVmCluster} operation to get details of an Autonomous Exadata VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousExadataInfrastructureRequest
     * @return GetAutonomousExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousExadataInfrastructure.ts.html |here} to see how to use GetAutonomousExadataInfrastructure API.
     */
    getAutonomousExadataInfrastructure(getAutonomousExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousExadataInfrastructure.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": getAutonomousExadataInfrastructureRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousExadataInfrastructure",
                    bodyModel: model.AutonomousExadataInfrastructure,
                    type: "model.AutonomousExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specific autonomous patch.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousPatchRequest
     * @return GetAutonomousPatchResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousPatch.ts.html |here} to see how to use GetAutonomousPatch API.
     */
    getAutonomousPatch(getAutonomousPatchRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousPatch.");
            const pathParams = {
                "{autonomousPatchId}": getAutonomousPatchRequest.autonomousPatchId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousPatchRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousPatches/{autonomousPatchId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousPatch",
                    bodyModel: model.AutonomousPatch,
                    type: "model.AutonomousPatch",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Autonomous VM cluster for an Exadata Cloud@Customer system. To get information about an Autonomous VM Cluster in the Oracle cloud, see {@link #getCloudAutonomousVmCluster(GetCloudAutonomousVmClusterRequest) getCloudAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetAutonomousVmClusterRequest
     * @return GetAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetAutonomousVmCluster.ts.html |here} to see how to use GetAutonomousVmCluster API.
     */
    getAutonomousVmCluster(getAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getAutonomousVmCluster.");
            const pathParams = {
                "{autonomousVmClusterId}": getAutonomousVmClusterRequest.autonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters/{autonomousVmClusterId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousVmCluster",
                    bodyModel: model.AutonomousVmCluster,
                    type: "model.AutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified backup.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetBackupRequest
     * @return GetBackupResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetBackup.ts.html |here} to see how to use GetBackup API.
     */
    getBackup(getBackupRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getBackup.");
            const pathParams = {
                "{backupId}": getBackupRequest.backupId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getBackupRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backups/{backupId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "backup",
                    bodyModel: model.Backup,
                    type: "model.Backup",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified backup destination in an Exadata Cloud@Customer system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetBackupDestinationRequest
     * @return GetBackupDestinationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetBackupDestination.ts.html |here} to see how to use GetBackupDestination API.
     */
    getBackupDestination(getBackupDestinationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getBackupDestination.");
            const pathParams = {
                "{backupDestinationId}": getBackupDestinationRequest.backupDestinationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getBackupDestinationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getBackupDestinationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations/{backupDestinationId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "backupDestination",
                    bodyModel: model.BackupDestination,
                    type: "model.BackupDestination",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Autonomous Exadata VM cluster in the Oracle cloud. For Exadata Cloud@Custustomer systems, see {@link #getAutonomousVmCluster(GetAutonomousVmClusterRequest) getAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudAutonomousVmClusterRequest
     * @return GetCloudAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudAutonomousVmCluster.ts.html |here} to see how to use GetCloudAutonomousVmCluster API.
     */
    getCloudAutonomousVmCluster(getCloudAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudAutonomousVmCluster.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": getCloudAutonomousVmClusterRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudAutonomousVmCluster",
                    bodyModel: model.CloudAutonomousVmCluster,
                    type: "model.CloudAutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified cloud Exadata infrastructure resource. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudExadataInfrastructureRequest
     * @return GetCloudExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudExadataInfrastructure.ts.html |here} to see how to use GetCloudExadataInfrastructure API.
     */
    getCloudExadataInfrastructure(getCloudExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudExadataInfrastructure.");
            const pathParams = {
                "{cloudExadataInfrastructureId}": getCloudExadataInfrastructureRequest.cloudExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures/{cloudExadataInfrastructureId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudExadataInfrastructure",
                    bodyModel: model.CloudExadataInfrastructure,
                    type: "model.CloudExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified cloud VM cluster. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudVmClusterRequest
     * @return GetCloudVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudVmCluster.ts.html |here} to see how to use GetCloudVmCluster API.
     */
    getCloudVmCluster(getCloudVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudVmCluster.");
            const pathParams = {
                "{cloudVmClusterId}": getCloudVmClusterRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudVmCluster",
                    bodyModel: model.CloudVmCluster,
                    type: "model.CloudVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the IORM configuration for the specified cloud VM cluster in an Exadata Cloud Service instance.
     * If you have not specified an IORM configuration, the default configuration is returned.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudVmClusterIormConfigRequest
     * @return GetCloudVmClusterIormConfigResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudVmClusterIormConfig.ts.html |here} to see how to use GetCloudVmClusterIormConfig API.
     */
    getCloudVmClusterIormConfig(getCloudVmClusterIormConfigRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudVmClusterIormConfig.");
            const pathParams = {
                "{cloudVmClusterId}": getCloudVmClusterIormConfigRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudVmClusterIormConfigRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudVmClusterIormConfigRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/CloudVmClusterIormConfig",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataIormConfig",
                    bodyModel: model.ExadataIormConfig,
                    type: "model.ExadataIormConfig",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specified maintenance update package for a cloud VM cluster. Applies to Exadata Cloud Service instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudVmClusterUpdateRequest
     * @return GetCloudVmClusterUpdateResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudVmClusterUpdate.ts.html |here} to see how to use GetCloudVmClusterUpdate API.
     */
    getCloudVmClusterUpdate(getCloudVmClusterUpdateRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudVmClusterUpdate.");
            const pathParams = {
                "{cloudVmClusterId}": getCloudVmClusterUpdateRequest.cloudVmClusterId,
                "{updateId}": getCloudVmClusterUpdateRequest.updateId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudVmClusterUpdateRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudVmClusterUpdateRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/updates/{updateId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "update",
                    bodyModel: model.Update,
                    type: "model.Update",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the maintenance update history details for the specified update history entry. Applies to Exadata Cloud Service instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetCloudVmClusterUpdateHistoryEntryRequest
     * @return GetCloudVmClusterUpdateHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetCloudVmClusterUpdateHistoryEntry.ts.html |here} to see how to use GetCloudVmClusterUpdateHistoryEntry API.
     */
    getCloudVmClusterUpdateHistoryEntry(getCloudVmClusterUpdateHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getCloudVmClusterUpdateHistoryEntry.");
            const pathParams = {
                "{cloudVmClusterId}": getCloudVmClusterUpdateHistoryEntryRequest.cloudVmClusterId,
                "{updateHistoryEntryId}": getCloudVmClusterUpdateHistoryEntryRequest.updateHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getCloudVmClusterUpdateHistoryEntryRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getCloudVmClusterUpdateHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/updateHistoryEntries/{updateHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "updateHistoryEntry",
                    bodyModel: model.UpdateHistoryEntry,
                    type: "model.UpdateHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the specified database node console connection's information.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetConsoleConnectionRequest
     * @return GetConsoleConnectionResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetConsoleConnection.ts.html |here} to see how to use GetConsoleConnection API.
     */
    getConsoleConnection(getConsoleConnectionRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getConsoleConnection.");
            const pathParams = {
                "{dbNodeId}": getConsoleConnectionRequest.dbNodeId,
                "{consoleConnectionId}": getConsoleConnectionRequest.consoleConnectionId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getConsoleConnectionRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}/consoleConnections/{consoleConnectionId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "consoleConnection",
                    bodyModel: model.ConsoleConnection,
                    type: "model.ConsoleConnection",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the specified Data Guard association's configuration information.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDataGuardAssociationRequest
     * @return GetDataGuardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDataGuardAssociation.ts.html |here} to see how to use GetDataGuardAssociation API.
     */
    getDataGuardAssociation(getDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": getDataGuardAssociationRequest.databaseId,
                "{dataGuardAssociationId}": getDataGuardAssociationRequest.dataGuardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations/{dataGuardAssociationId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDatabaseRequest
     * @return GetDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDatabase.ts.html |here} to see how to use GetDatabase API.
     */
    getDatabase(getDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDatabase.");
            const pathParams = {
                "{databaseId}": getDatabaseRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified database software image.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDatabaseSoftwareImageRequest
     * @return GetDatabaseSoftwareImageResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDatabaseSoftwareImage.ts.html |here} to see how to use GetDatabaseSoftwareImage API.
     */
    getDatabaseSoftwareImage(getDatabaseSoftwareImageRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDatabaseSoftwareImage.");
            const pathParams = {
                "{databaseSoftwareImageId}": getDatabaseSoftwareImageRequest.databaseSoftwareImageId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDatabaseSoftwareImageRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages/{databaseSoftwareImageId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "databaseSoftwareImage",
                    bodyModel: model.DatabaseSoftwareImage,
                    type: "model.DatabaseSoftwareImage",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * gets the upgrade history for a specified database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDatabaseUpgradeHistoryEntryRequest
     * @return GetDatabaseUpgradeHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDatabaseUpgradeHistoryEntry.ts.html |here} to see how to use GetDatabaseUpgradeHistoryEntry API.
     */
    getDatabaseUpgradeHistoryEntry(getDatabaseUpgradeHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDatabaseUpgradeHistoryEntry.");
            const pathParams = {
                "{databaseId}": getDatabaseUpgradeHistoryEntryRequest.databaseId,
                "{upgradeHistoryEntryId}": getDatabaseUpgradeHistoryEntryRequest.upgradeHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getDatabaseUpgradeHistoryEntryRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDatabaseUpgradeHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/upgradeHistoryEntries/{upgradeHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "databaseUpgradeHistoryEntry",
                    bodyModel: model.DatabaseUpgradeHistoryEntry,
                    type: "model.DatabaseUpgradeHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Database Home.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbHomeRequest
     * @return GetDbHomeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbHome.ts.html |here} to see how to use GetDbHome API.
     */
    getDbHome(getDbHomeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbHome.");
            const pathParams = {
                "{dbHomeId}": getDbHomeRequest.dbHomeId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbHomeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbHome",
                    bodyModel: model.DbHome,
                    type: "model.DbHome",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specified patch package.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbHomePatchRequest
     * @return GetDbHomePatchResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbHomePatch.ts.html |here} to see how to use GetDbHomePatch API.
     */
    getDbHomePatch(getDbHomePatchRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbHomePatch.");
            const pathParams = {
                "{dbHomeId}": getDbHomePatchRequest.dbHomeId,
                "{patchId}": getDbHomePatchRequest.patchId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbHomePatchRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}/patches/{patchId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patch",
                    bodyModel: model.Patch,
                    type: "model.Patch",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the patch history details for the specified patchHistoryEntryId
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbHomePatchHistoryEntryRequest
     * @return GetDbHomePatchHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbHomePatchHistoryEntry.ts.html |here} to see how to use GetDbHomePatchHistoryEntry API.
     */
    getDbHomePatchHistoryEntry(getDbHomePatchHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbHomePatchHistoryEntry.");
            const pathParams = {
                "{dbHomeId}": getDbHomePatchHistoryEntryRequest.dbHomeId,
                "{patchHistoryEntryId}": getDbHomePatchHistoryEntryRequest.patchHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbHomePatchHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}/patchHistoryEntries/{patchHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patchHistoryEntry",
                    bodyModel: model.PatchHistoryEntry,
                    type: "model.PatchHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified database node.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbNodeRequest
     * @return GetDbNodeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbNode.ts.html |here} to see how to use GetDbNode API.
     */
    getDbNode(getDbNodeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbNode.");
            const pathParams = {
                "{dbNodeId}": getDbNodeRequest.dbNodeId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbNodeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbNode",
                    bodyModel: model.DbNode,
                    type: "model.DbNode",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the Exadata Db server.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbServerRequest
     * @return GetDbServerResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbServer.ts.html |here} to see how to use GetDbServer API.
     */
    getDbServer(getDbServerRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbServer.");
            const pathParams = {
                "{dbServerId}": getDbServerRequest.dbServerId
            };
            const queryParams = {
                "exadataInfrastructureId": getDbServerRequest.exadataInfrastructureId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getDbServerRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbServerRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbServers/{dbServerId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbServer",
                    bodyModel: model.DbServer,
                    type: "model.DbServer",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Gets information about the specified DB system.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param GetDbSystemRequest
       * @return GetDbSystemResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbSystem.ts.html |here} to see how to use GetDbSystem API.
       */
    getDbSystem(getDbSystemRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbSystem.");
            const pathParams = {
                "{dbSystemId}": getDbSystemRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbSystemRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbSystem",
                    bodyModel: model.DbSystem,
                    type: "model.DbSystem",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information the specified patch.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbSystemPatchRequest
     * @return GetDbSystemPatchResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbSystemPatch.ts.html |here} to see how to use GetDbSystemPatch API.
     */
    getDbSystemPatch(getDbSystemPatchRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbSystemPatch.");
            const pathParams = {
                "{dbSystemId}": getDbSystemPatchRequest.dbSystemId,
                "{patchId}": getDbSystemPatchRequest.patchId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbSystemPatchRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/patches/{patchId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patch",
                    bodyModel: model.Patch,
                    type: "model.Patch",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the details of the specified patch operation on the specified DB system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetDbSystemPatchHistoryEntryRequest
     * @return GetDbSystemPatchHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetDbSystemPatchHistoryEntry.ts.html |here} to see how to use GetDbSystemPatchHistoryEntry API.
     */
    getDbSystemPatchHistoryEntry(getDbSystemPatchHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getDbSystemPatchHistoryEntry.");
            const pathParams = {
                "{dbSystemId}": getDbSystemPatchHistoryEntryRequest.dbSystemId,
                "{patchHistoryEntryId}": getDbSystemPatchHistoryEntryRequest.patchHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getDbSystemPatchHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/patchHistoryEntries/{patchHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patchHistoryEntry",
                    bodyModel: model.PatchHistoryEntry,
                    type: "model.PatchHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified Exadata infrastructure. Applies to Exadata Cloud@Customer instances only.
     * To get information on an Exadata Cloud Service infrastructure resource, use the  {@link #getCloudExadataInfrastructure(GetCloudExadataInfrastructureRequest) getCloudExadataInfrastructure} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExadataInfrastructureRequest
     * @return GetExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExadataInfrastructure.ts.html |here} to see how to use GetExadataInfrastructure API.
     */
    getExadataInfrastructure(getExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExadataInfrastructure.");
            const pathParams = {
                "{exadataInfrastructureId}": getExadataInfrastructureRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataInfrastructure",
                    bodyModel: model.ExadataInfrastructure,
                    type: "model.ExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets details of the available and consumed OCPUs for the specified Autonomous Exadata Infrastructure resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExadataInfrastructureOcpusRequest
     * @return GetExadataInfrastructureOcpusResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExadataInfrastructureOcpus.ts.html |here} to see how to use GetExadataInfrastructureOcpus API.
     */
    getExadataInfrastructureOcpus(getExadataInfrastructureOcpusRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExadataInfrastructureOcpus.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": getExadataInfrastructureOcpusRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExadataInfrastructureOcpusRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExadataInfrastructureOcpusRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}/ocpus",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "oCPUs",
                    bodyModel: model.OCPUs,
                    type: "model.OCPUs",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Gets the IORM configuration settings for the specified cloud Exadata DB system.
  * All Exadata service instances have default IORM settings.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  * <p>
  The {@link #getCloudVmClusterIormConfig(GetCloudVmClusterIormConfigRequest) getCloudVmClusterIormConfig} API is used for this operation with Exadata systems using the
  * new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param GetExadataIormConfigRequest
       * @return GetExadataIormConfigResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExadataIormConfig.ts.html |here} to see how to use GetExadataIormConfig API.
       */
    getExadataIormConfig(getExadataIormConfigRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExadataIormConfig.");
            const pathParams = {
                "{dbSystemId}": getExadataIormConfigRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExadataIormConfigRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExadataIormConfigRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/ExadataIormConfig",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataIormConfig",
                    bodyModel: model.ExadataIormConfig,
                    type: "model.ExadataIormConfig",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified external backup job.
     * <p>
     **Note:** This API is used by an Oracle Cloud Infrastructure Python script that is packaged with the Oracle Cloud Infrastructure CLI. Oracle recommends that you use the script instead using the API directly. See [Migrating an On-Premises Database to Oracle Cloud Infrastructure by Creating a Backup in the Cloud](https://docs.cloud.oracle.com/Content/Database/Tasks/mig-onprembackup.htm) for more information.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExternalBackupJobRequest
     * @return GetExternalBackupJobResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExternalBackupJob.ts.html |here} to see how to use GetExternalBackupJob API.
     */
    getExternalBackupJob(getExternalBackupJobRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExternalBackupJob.");
            const pathParams = {
                "{backupId}": getExternalBackupJobRequest.backupId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExternalBackupJobRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalBackupJobs/{backupId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalBackupJob",
                    bodyModel: model.ExternalBackupJob,
                    type: "model.ExternalBackupJob",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified external container database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExternalContainerDatabaseRequest
     * @return GetExternalContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExternalContainerDatabase.ts.html |here} to see how to use GetExternalContainerDatabase API.
     */
    getExternalContainerDatabase(getExternalContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExternalContainerDatabase.");
            const pathParams = {
                "{externalContainerDatabaseId}": getExternalContainerDatabaseRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExternalContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExternalContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalContainerDatabase",
                    bodyModel: model.ExternalContainerDatabase,
                    type: "model.ExternalContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified external database connector.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExternalDatabaseConnectorRequest
     * @return GetExternalDatabaseConnectorResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExternalDatabaseConnector.ts.html |here} to see how to use GetExternalDatabaseConnector API.
     */
    getExternalDatabaseConnector(getExternalDatabaseConnectorRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExternalDatabaseConnector.");
            const pathParams = {
                "{externalDatabaseConnectorId}": getExternalDatabaseConnectorRequest.externalDatabaseConnectorId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExternalDatabaseConnectorRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExternalDatabaseConnectorRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors/{externalDatabaseConnectorId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalDatabaseConnector",
                    bodyModel: model.ExternalDatabaseConnector,
                    type: "model.ExternalDatabaseConnector",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specific external non-container database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExternalNonContainerDatabaseRequest
     * @return GetExternalNonContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExternalNonContainerDatabase.ts.html |here} to see how to use GetExternalNonContainerDatabase API.
     */
    getExternalNonContainerDatabase(getExternalNonContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExternalNonContainerDatabase.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": getExternalNonContainerDatabaseRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExternalNonContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExternalNonContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalNonContainerDatabase",
                    bodyModel: model.ExternalNonContainerDatabase,
                    type: "model.ExternalNonContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specific
     * {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails} resource.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetExternalPluggableDatabaseRequest
     * @return GetExternalPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetExternalPluggableDatabase.ts.html |here} to see how to use GetExternalPluggableDatabase API.
     */
    getExternalPluggableDatabase(getExternalPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getExternalPluggableDatabase.");
            const pathParams = {
                "{externalPluggableDatabaseId}": getExternalPluggableDatabaseRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getExternalPluggableDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getExternalPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalPluggableDatabase",
                    bodyModel: model.ExternalPluggableDatabase,
                    type: "model.ExternalPluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified key store.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetKeyStoreRequest
     * @return GetKeyStoreResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetKeyStore.ts.html |here} to see how to use GetKeyStore API.
     */
    getKeyStore(getKeyStoreRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getKeyStore.");
            const pathParams = {
                "{keyStoreId}": getKeyStoreRequest.keyStoreId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getKeyStoreRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getKeyStoreRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores/{keyStoreId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "keyStore",
                    bodyModel: model.KeyStore,
                    type: "model.KeyStore",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified maintenance run.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetMaintenanceRunRequest
     * @return GetMaintenanceRunResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetMaintenanceRun.ts.html |here} to see how to use GetMaintenanceRun API.
     */
    getMaintenanceRun(getMaintenanceRunRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getMaintenanceRun.");
            const pathParams = {
                "{maintenanceRunId}": getMaintenanceRunRequest.maintenanceRunId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getMaintenanceRunRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/maintenanceRuns/{maintenanceRunId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "maintenanceRun",
                    bodyModel: model.MaintenanceRun,
                    type: "model.MaintenanceRun",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the details of operations performed to convert the specified database from non-container (non-CDB) to pluggable (PDB).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetPdbConversionHistoryEntryRequest
     * @return GetPdbConversionHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetPdbConversionHistoryEntry.ts.html |here} to see how to use GetPdbConversionHistoryEntry API.
     */
    getPdbConversionHistoryEntry(getPdbConversionHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getPdbConversionHistoryEntry.");
            const pathParams = {
                "{databaseId}": getPdbConversionHistoryEntryRequest.databaseId,
                "{pdbConversionHistoryEntryId}": getPdbConversionHistoryEntryRequest.pdbConversionHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getPdbConversionHistoryEntryRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getPdbConversionHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/pdbConversionHistoryEntries/{pdbConversionHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pdbConversionHistoryEntry",
                    bodyModel: model.PdbConversionHistoryEntry,
                    type: "model.PdbConversionHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified pluggable database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetPluggableDatabaseRequest
     * @return GetPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetPluggableDatabase.ts.html |here} to see how to use GetPluggableDatabase API.
     */
    getPluggableDatabase(getPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getPluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": getPluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterRequest
     * @return GetVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmCluster.ts.html |here} to see how to use GetVmCluster API.
     */
    getVmCluster(getVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmCluster.");
            const pathParams = {
                "{vmClusterId}": getVmClusterRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmCluster",
                    bodyModel: model.VmCluster,
                    type: "model.VmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     * To get information about a cloud VM cluster in an Exadata Cloud Service instance, use the {@link #getCloudVmCluster(GetCloudVmClusterRequest) getCloudVmCluster} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterNetworkRequest
     * @return GetVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmClusterNetwork.ts.html |here} to see how to use GetVmClusterNetwork API.
     */
    getVmClusterNetwork(getVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": getVmClusterNetworkRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": getVmClusterNetworkRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getVmClusterNetworkRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterNetwork",
                    bodyModel: model.VmClusterNetwork,
                    type: "model.VmClusterNetwork",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specified patch package.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterPatchRequest
     * @return GetVmClusterPatchResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmClusterPatch.ts.html |here} to see how to use GetVmClusterPatch API.
     */
    getVmClusterPatch(getVmClusterPatchRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmClusterPatch.");
            const pathParams = {
                "{vmClusterId}": getVmClusterPatchRequest.vmClusterId,
                "{patchId}": getVmClusterPatchRequest.patchId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterPatchRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/patches/{patchId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patch",
                    bodyModel: model.Patch,
                    type: "model.Patch",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the patch history details for the specified patch history entry.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterPatchHistoryEntryRequest
     * @return GetVmClusterPatchHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmClusterPatchHistoryEntry.ts.html |here} to see how to use GetVmClusterPatchHistoryEntry API.
     */
    getVmClusterPatchHistoryEntry(getVmClusterPatchHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmClusterPatchHistoryEntry.");
            const pathParams = {
                "{vmClusterId}": getVmClusterPatchHistoryEntryRequest.vmClusterId,
                "{patchHistoryEntryId}": getVmClusterPatchHistoryEntryRequest.patchHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterPatchHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/patchHistoryEntries/{patchHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "patchHistoryEntry",
                    bodyModel: model.PatchHistoryEntry,
                    type: "model.PatchHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets information about a specified maintenance update package for a VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterUpdateRequest
     * @return GetVmClusterUpdateResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmClusterUpdate.ts.html |here} to see how to use GetVmClusterUpdate API.
     */
    getVmClusterUpdate(getVmClusterUpdateRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmClusterUpdate.");
            const pathParams = {
                "{vmClusterId}": getVmClusterUpdateRequest.vmClusterId,
                "{updateId}": getVmClusterUpdateRequest.updateId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getVmClusterUpdateRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterUpdateRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/updates/{updateId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterUpdate",
                    bodyModel: model.VmClusterUpdate,
                    type: "model.VmClusterUpdate",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets the maintenance update history details for the specified update history entry. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param GetVmClusterUpdateHistoryEntryRequest
     * @return GetVmClusterUpdateHistoryEntryResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/GetVmClusterUpdateHistoryEntry.ts.html |here} to see how to use GetVmClusterUpdateHistoryEntry API.
     */
    getVmClusterUpdateHistoryEntry(getVmClusterUpdateHistoryEntryRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#getVmClusterUpdateHistoryEntry.");
            const pathParams = {
                "{vmClusterId}": getVmClusterUpdateHistoryEntryRequest.vmClusterId,
                "{updateHistoryEntryId}": getVmClusterUpdateHistoryEntryRequest.updateHistoryEntryId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": getVmClusterUpdateHistoryEntryRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, getVmClusterUpdateHistoryEntryRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/updateHistoryEntries/{updateHistoryEntryId}",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterUpdateHistoryEntry",
                    bodyModel: model.VmClusterUpdateHistoryEntry,
                    type: "model.VmClusterUpdateHistoryEntry",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated** To create a new Autonomous Database system on dedicated Exadata Infrastructure, use the {@link #createCloudExadataInfrastructure(CreateCloudExadataInfrastructureRequest) createCloudExadataInfrastructure} and {@link #createCloudAutonomousVmCluster(CreateCloudAutonomousVmClusterRequest) createCloudAutonomousVmCluster} operations instead. Note that to create an Autonomous VM cluster, you must have an existing Exadata Infrastructure resource to contain the VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param LaunchAutonomousExadataInfrastructureRequest
     * @return LaunchAutonomousExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/LaunchAutonomousExadataInfrastructure.ts.html |here} to see how to use LaunchAutonomousExadataInfrastructure API.
     */
    launchAutonomousExadataInfrastructure(launchAutonomousExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#launchAutonomousExadataInfrastructure.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": launchAutonomousExadataInfrastructureRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, launchAutonomousExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(launchAutonomousExadataInfrastructureRequest.launchAutonomousExadataInfrastructureDetails, "LaunchAutonomousExadataInfrastructureDetails", model.LaunchAutonomousExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousExadataInfrastructure",
                    bodyModel: model.AutonomousExadataInfrastructure,
                    type: "model.AutonomousExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Creates a new DB system in the specified compartment and availability domain. The Oracle
  * Database edition that you specify applies to all the databases on that DB system. The selected edition cannot be changed.
  * <p>
  An initial database is created on the DB system based on the request parameters you provide and some default
  * options. For detailed information about default options, see [Bare metal and virtual machine DB system default options.](https://docs.cloud.oracle.com/Content/Database/Tasks/creatingDBsystem.htm#Default)
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  * <p>
  Use the {@link #createCloudExadataInfrastructure(CreateCloudExadataInfrastructureRequest) createCloudExadataInfrastructure} and {@link #createCloudVmCluster(CreateCloudVmClusterRequest) createCloudVmCluster} APIs to provision a new Exadata Cloud Service instance.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param LaunchDbSystemRequest
       * @return LaunchDbSystemResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/LaunchDbSystem.ts.html |here} to see how to use LaunchDbSystem API.
       */
    launchDbSystem(launchDbSystemRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#launchDbSystem.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": launchDbSystemRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, launchDbSystemRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(launchDbSystemRequest.launchDbSystemDetails, "LaunchDbSystemBase", model.LaunchDbSystemBase.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbSystem",
                    bodyModel: model.DbSystem,
                    type: "model.DbSystem",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets a list of the Autonomous Container Databases with Autonomous Data Guard-enabled associated with the specified Autonomous Container Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousContainerDatabaseDataguardAssociationsRequest
     * @return ListAutonomousContainerDatabaseDataguardAssociationsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousContainerDatabaseDataguardAssociations.ts.html |here} to see how to use ListAutonomousContainerDatabaseDataguardAssociations API.
     */
    listAutonomousContainerDatabaseDataguardAssociations(listAutonomousContainerDatabaseDataguardAssociationsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousContainerDatabaseDataguardAssociations.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": listAutonomousContainerDatabaseDataguardAssociationsRequest.autonomousContainerDatabaseId
            };
            const queryParams = {
                "limit": listAutonomousContainerDatabaseDataguardAssociationsRequest.limit,
                "page": listAutonomousContainerDatabaseDataguardAssociationsRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousContainerDatabaseDataguardAssociationsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "Array<model.AutonomousContainerDatabaseDataguardAssociation>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousContainerDatabaseDataguardAssociationsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousContainerDatabaseDataguardAssociation objects
     * contained in responses from the listAutonomousContainerDatabaseDataguardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousContainerDatabaseDataguardAssociations(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousContainerDatabaseDataguardAssociations(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousContainerDatabaseDataguardAssociationsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousContainerDatabaseDataguardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousContainerDatabaseDataguardAssociationsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousContainerDatabaseDataguardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousContainerDatabaseDataguardAssociation objects
     * contained in responses from the listAutonomousContainerDatabaseDataguardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousContainerDatabaseDataguardAssociationsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousContainerDatabaseDataguardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousContainerDatabaseDataguardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousContainerDatabaseDataguardAssociationsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousContainerDatabaseDataguardAssociations(req));
    }
    /**
     * Gets a list of the Autonomous Container Databases in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousContainerDatabasesRequest
     * @return ListAutonomousContainerDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousContainerDatabases.ts.html |here} to see how to use ListAutonomousContainerDatabases API.
     */
    listAutonomousContainerDatabases(listAutonomousContainerDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousContainerDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousContainerDatabasesRequest.compartmentId,
                "autonomousExadataInfrastructureId": listAutonomousContainerDatabasesRequest.autonomousExadataInfrastructureId,
                "autonomousVmClusterId": listAutonomousContainerDatabasesRequest.autonomousVmClusterId,
                "infrastructureType": listAutonomousContainerDatabasesRequest.infrastructureType,
                "limit": listAutonomousContainerDatabasesRequest.limit,
                "page": listAutonomousContainerDatabasesRequest.page,
                "sortBy": listAutonomousContainerDatabasesRequest.sortBy,
                "sortOrder": listAutonomousContainerDatabasesRequest.sortOrder,
                "lifecycleState": listAutonomousContainerDatabasesRequest.lifecycleState,
                "availabilityDomain": listAutonomousContainerDatabasesRequest.availabilityDomain,
                "displayName": listAutonomousContainerDatabasesRequest.displayName,
                "serviceLevelAgreementType": listAutonomousContainerDatabasesRequest.serviceLevelAgreementType,
                "cloudAutonomousVmClusterId": listAutonomousContainerDatabasesRequest.cloudAutonomousVmClusterId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousContainerDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousContainerDatabaseSummary,
                    type: "Array<model.AutonomousContainerDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousContainerDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousContainerDatabaseSummary objects
     * contained in responses from the listAutonomousContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousContainerDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousContainerDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousContainerDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousContainerDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousContainerDatabaseSummary objects
     * contained in responses from the listAutonomousContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousContainerDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousContainerDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousContainerDatabases(req));
    }
    /**
     * Gets a list of Autonomous Database backups based on either the `autonomousDatabaseId` or `compartmentId` specified as a query parameter.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDatabaseBackupsRequest
     * @return ListAutonomousDatabaseBackupsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDatabaseBackups.ts.html |here} to see how to use ListAutonomousDatabaseBackups API.
     */
    listAutonomousDatabaseBackups(listAutonomousDatabaseBackupsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDatabaseBackups.");
            const pathParams = {};
            const queryParams = {
                "autonomousDatabaseId": listAutonomousDatabaseBackupsRequest.autonomousDatabaseId,
                "compartmentId": listAutonomousDatabaseBackupsRequest.compartmentId,
                "limit": listAutonomousDatabaseBackupsRequest.limit,
                "page": listAutonomousDatabaseBackupsRequest.page,
                "sortBy": listAutonomousDatabaseBackupsRequest.sortBy,
                "sortOrder": listAutonomousDatabaseBackupsRequest.sortOrder,
                "lifecycleState": listAutonomousDatabaseBackupsRequest.lifecycleState,
                "displayName": listAutonomousDatabaseBackupsRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousDatabaseBackupsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDatabaseBackupsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabaseBackups",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDatabaseBackupSummary,
                    type: "Array<model.AutonomousDatabaseBackupSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseBackupsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseBackupSummary objects
     * contained in responses from the listAutonomousDatabaseBackups operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseBackups(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseBackups(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseBackupsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseBackups operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseBackupsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseBackups(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseBackupSummary objects
     * contained in responses from the listAutonomousDatabaseBackups operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseBackupsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseBackups(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseBackups operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseBackupsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseBackups(req));
    }
    /**
     * Lists the Autonomous Database clones for the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDatabaseClonesRequest
     * @return ListAutonomousDatabaseClonesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDatabaseClones.ts.html |here} to see how to use ListAutonomousDatabaseClones API.
     */
    listAutonomousDatabaseClones(listAutonomousDatabaseClonesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDatabaseClones.");
            const pathParams = {
                "{autonomousDatabaseId}": listAutonomousDatabaseClonesRequest.autonomousDatabaseId
            };
            const queryParams = {
                "compartmentId": listAutonomousDatabaseClonesRequest.compartmentId,
                "limit": listAutonomousDatabaseClonesRequest.limit,
                "page": listAutonomousDatabaseClonesRequest.page,
                "sortOrder": listAutonomousDatabaseClonesRequest.sortOrder,
                "displayName": listAutonomousDatabaseClonesRequest.displayName,
                "lifecycleState": listAutonomousDatabaseClonesRequest.lifecycleState,
                "sortBy": listAutonomousDatabaseClonesRequest.sortBy,
                "cloneType": listAutonomousDatabaseClonesRequest.cloneType
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousDatabaseClonesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDatabaseClonesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/clones",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDatabaseSummary,
                    type: "Array<model.AutonomousDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseClonesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseSummary objects
     * contained in responses from the listAutonomousDatabaseClones operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseClones(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseClones(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseClonesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseClones operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseClonesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseClones(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseSummary objects
     * contained in responses from the listAutonomousDatabaseClones operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseClonesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseClones(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseClones operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseClonesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseClones(req));
    }
    /**
     * Gets a list of the Autonomous Data Guard-enabled databases associated with the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDatabaseDataguardAssociationsRequest
     * @return ListAutonomousDatabaseDataguardAssociationsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDatabaseDataguardAssociations.ts.html |here} to see how to use ListAutonomousDatabaseDataguardAssociations API.
     */
    listAutonomousDatabaseDataguardAssociations(listAutonomousDatabaseDataguardAssociationsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDatabaseDataguardAssociations.");
            const pathParams = {
                "{autonomousDatabaseId}": listAutonomousDatabaseDataguardAssociationsRequest.autonomousDatabaseId
            };
            const queryParams = {
                "limit": listAutonomousDatabaseDataguardAssociationsRequest.limit,
                "page": listAutonomousDatabaseDataguardAssociationsRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDatabaseDataguardAssociationsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/autonomousDatabaseDataguardAssociations",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDatabaseDataguardAssociation,
                    type: "Array<model.AutonomousDatabaseDataguardAssociation>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseDataguardAssociationsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseDataguardAssociation objects
     * contained in responses from the listAutonomousDatabaseDataguardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseDataguardAssociations(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseDataguardAssociations(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabaseDataguardAssociationsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseDataguardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabaseDataguardAssociationsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseDataguardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseDataguardAssociation objects
     * contained in responses from the listAutonomousDatabaseDataguardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseDataguardAssociationsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabaseDataguardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabaseDataguardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabaseDataguardAssociationsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabaseDataguardAssociations(req));
    }
    /**
     * Gets a list of Autonomous Databases based on the query parameters specified.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDatabasesRequest
     * @return ListAutonomousDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDatabases.ts.html |here} to see how to use ListAutonomousDatabases API.
     */
    listAutonomousDatabases(listAutonomousDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousDatabasesRequest.compartmentId,
                "autonomousContainerDatabaseId": listAutonomousDatabasesRequest.autonomousContainerDatabaseId,
                "limit": listAutonomousDatabasesRequest.limit,
                "page": listAutonomousDatabasesRequest.page,
                "sortBy": listAutonomousDatabasesRequest.sortBy,
                "sortOrder": listAutonomousDatabasesRequest.sortOrder,
                "infrastructureType": listAutonomousDatabasesRequest.infrastructureType,
                "lifecycleState": listAutonomousDatabasesRequest.lifecycleState,
                "dbWorkload": listAutonomousDatabasesRequest.dbWorkload,
                "dbVersion": listAutonomousDatabasesRequest.dbVersion,
                "isFreeTier": listAutonomousDatabasesRequest.isFreeTier,
                "displayName": listAutonomousDatabasesRequest.displayName,
                "isRefreshableClone": listAutonomousDatabasesRequest.isRefreshableClone,
                "isDataGuardEnabled": listAutonomousDatabasesRequest.isDataGuardEnabled
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousDatabasesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDatabaseSummary,
                    type: "Array<model.AutonomousDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseSummary objects
     * contained in responses from the listAutonomousDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDatabaseSummary objects
     * contained in responses from the listAutonomousDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDatabases(req));
    }
    /**
     * Gets a list of supported Autonomous Database versions. Note that preview version software is only available for
     * databases with [shared Exadata infrastructure](https://docs.oracle.com/en/cloud/paas/autonomous-database/index.html).
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDbPreviewVersionsRequest
     * @return ListAutonomousDbPreviewVersionsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDbPreviewVersions.ts.html |here} to see how to use ListAutonomousDbPreviewVersions API.
     */
    listAutonomousDbPreviewVersions(listAutonomousDbPreviewVersionsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDbPreviewVersions.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousDbPreviewVersionsRequest.compartmentId,
                "limit": listAutonomousDbPreviewVersionsRequest.limit,
                "page": listAutonomousDbPreviewVersionsRequest.page,
                "sortBy": listAutonomousDbPreviewVersionsRequest.sortBy,
                "sortOrder": listAutonomousDbPreviewVersionsRequest.sortOrder
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousDbPreviewVersionsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDbPreviewVersionsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDbPreviewVersions",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDbPreviewVersionSummary,
                    type: "Array<model.AutonomousDbPreviewVersionSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDbPreviewVersionsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDbPreviewVersionSummary objects
     * contained in responses from the listAutonomousDbPreviewVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDbPreviewVersions(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDbPreviewVersions(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDbPreviewVersionsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDbPreviewVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDbPreviewVersionsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDbPreviewVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDbPreviewVersionSummary objects
     * contained in responses from the listAutonomousDbPreviewVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDbPreviewVersionsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDbPreviewVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDbPreviewVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDbPreviewVersionsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDbPreviewVersions(req));
    }
    /**
     * Gets a list of supported Autonomous Database versions.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousDbVersionsRequest
     * @return ListAutonomousDbVersionsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousDbVersions.ts.html |here} to see how to use ListAutonomousDbVersions API.
     */
    listAutonomousDbVersions(listAutonomousDbVersionsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousDbVersions.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousDbVersionsRequest.compartmentId,
                "limit": listAutonomousDbVersionsRequest.limit,
                "page": listAutonomousDbVersionsRequest.page,
                "dbWorkload": listAutonomousDbVersionsRequest.dbWorkload,
                "sortOrder": listAutonomousDbVersionsRequest.sortOrder
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousDbVersionsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousDbVersionsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDbVersions",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousDbVersionSummary,
                    type: "Array<model.AutonomousDbVersionSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDbVersionsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousDbVersionSummary objects
     * contained in responses from the listAutonomousDbVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDbVersions(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDbVersions(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousDbVersionsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDbVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousDbVersionsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDbVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousDbVersionSummary objects
     * contained in responses from the listAutonomousDbVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDbVersionsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousDbVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousDbVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousDbVersionsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousDbVersions(req));
    }
    /**
     * **Deprecated.**
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousExadataInfrastructureShapesRequest
     * @return ListAutonomousExadataInfrastructureShapesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousExadataInfrastructureShapes.ts.html |here} to see how to use ListAutonomousExadataInfrastructureShapes API.
     */
    listAutonomousExadataInfrastructureShapes(listAutonomousExadataInfrastructureShapesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousExadataInfrastructureShapes.");
            const pathParams = {};
            const queryParams = {
                "availabilityDomain": listAutonomousExadataInfrastructureShapesRequest.availabilityDomain,
                "compartmentId": listAutonomousExadataInfrastructureShapesRequest.compartmentId,
                "limit": listAutonomousExadataInfrastructureShapesRequest.limit,
                "page": listAutonomousExadataInfrastructureShapesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousExadataInfrastructureShapesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousExadataInfrastructureShapesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructureShapes",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousExadataInfrastructureShapeSummary,
                    type: "Array<model.AutonomousExadataInfrastructureShapeSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousExadataInfrastructureShapesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousExadataInfrastructureShapeSummary objects
     * contained in responses from the listAutonomousExadataInfrastructureShapes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousExadataInfrastructureShapes(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousExadataInfrastructureShapes(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousExadataInfrastructureShapesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousExadataInfrastructureShapes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousExadataInfrastructureShapesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousExadataInfrastructureShapes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousExadataInfrastructureShapeSummary objects
     * contained in responses from the listAutonomousExadataInfrastructureShapes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousExadataInfrastructureShapesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousExadataInfrastructureShapes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousExadataInfrastructureShapes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousExadataInfrastructureShapesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousExadataInfrastructureShapes(req));
    }
    /**
     * **Deprecated.** Use the {@link #listCloudExadataInfrastructures(ListCloudExadataInfrastructuresRequest) listCloudExadataInfrastructures} operation to list Exadata Infrastructures in the Oracle cloud and the  {@link #listCloudAutonomousVmClusters(ListCloudAutonomousVmClustersRequest) listCloudAutonomousVmClusters} operation to list Autonomous Exadata VM clusters.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousExadataInfrastructuresRequest
     * @return ListAutonomousExadataInfrastructuresResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousExadataInfrastructures.ts.html |here} to see how to use ListAutonomousExadataInfrastructures API.
     */
    listAutonomousExadataInfrastructures(listAutonomousExadataInfrastructuresRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousExadataInfrastructures.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousExadataInfrastructuresRequest.compartmentId,
                "limit": listAutonomousExadataInfrastructuresRequest.limit,
                "page": listAutonomousExadataInfrastructuresRequest.page,
                "sortBy": listAutonomousExadataInfrastructuresRequest.sortBy,
                "sortOrder": listAutonomousExadataInfrastructuresRequest.sortOrder,
                "lifecycleState": listAutonomousExadataInfrastructuresRequest.lifecycleState,
                "availabilityDomain": listAutonomousExadataInfrastructuresRequest.availabilityDomain,
                "displayName": listAutonomousExadataInfrastructuresRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousExadataInfrastructuresRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousExadataInfrastructureSummary,
                    type: "Array<model.AutonomousExadataInfrastructureSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousExadataInfrastructuresRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousExadataInfrastructureSummary objects
     * contained in responses from the listAutonomousExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousExadataInfrastructures(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousExadataInfrastructures(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousExadataInfrastructuresResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousExadataInfrastructuresResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousExadataInfrastructureSummary objects
     * contained in responses from the listAutonomousExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousExadataInfrastructuresRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousExadataInfrastructuresResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousExadataInfrastructures(req));
    }
    /**
     * Gets a list of Exadata Cloud@Customer Autonomous VM clusters in the specified compartment. To list Autonomous VM Clusters in the Oracle Cloud, see {@link #listCloudAutonomousVmClusters(ListCloudAutonomousVmClustersRequest) listCloudAutonomousVmClusters}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListAutonomousVmClustersRequest
     * @return ListAutonomousVmClustersResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListAutonomousVmClusters.ts.html |here} to see how to use ListAutonomousVmClusters API.
     */
    listAutonomousVmClusters(listAutonomousVmClustersRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listAutonomousVmClusters.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listAutonomousVmClustersRequest.compartmentId,
                "exadataInfrastructureId": listAutonomousVmClustersRequest.exadataInfrastructureId,
                "limit": listAutonomousVmClustersRequest.limit,
                "page": listAutonomousVmClustersRequest.page,
                "sortBy": listAutonomousVmClustersRequest.sortBy,
                "sortOrder": listAutonomousVmClustersRequest.sortOrder,
                "lifecycleState": listAutonomousVmClustersRequest.lifecycleState,
                "displayName": listAutonomousVmClustersRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listAutonomousVmClustersRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listAutonomousVmClustersRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousVmClusterSummary,
                    type: "Array<model.AutonomousVmClusterSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousVmClustersRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousVmClusterSummary objects
     * contained in responses from the listAutonomousVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousVmClusters(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousVmClusters(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listAutonomousVmClustersResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllAutonomousVmClustersResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousVmClusterSummary objects
     * contained in responses from the listAutonomousVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousVmClustersRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listAutonomousVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listAutonomousVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAutonomousVmClustersResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listAutonomousVmClusters(req));
    }
    /**
     * Gets a list of backup destinations in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListBackupDestinationRequest
     * @return ListBackupDestinationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListBackupDestination.ts.html |here} to see how to use ListBackupDestination API.
     */
    listBackupDestination(listBackupDestinationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listBackupDestination.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listBackupDestinationRequest.compartmentId,
                "limit": listBackupDestinationRequest.limit,
                "page": listBackupDestinationRequest.page,
                "type": listBackupDestinationRequest.type
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listBackupDestinationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listBackupDestinationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.BackupDestinationSummary,
                    type: "Array<model.BackupDestinationSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listBackupDestinationRecordIterator function.
     * Creates a new async iterator which will iterate over the models.BackupDestinationSummary objects
     * contained in responses from the listBackupDestination operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBackupDestination(request) {
        return oci_common_1.paginateRecords(request, req => this.listBackupDestination(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listBackupDestinationResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listBackupDestination operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBackupDestinationResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listBackupDestination(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.BackupDestinationSummary objects
     * contained in responses from the listBackupDestination operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBackupDestinationRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listBackupDestination(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listBackupDestination operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBackupDestinationResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listBackupDestination(req));
    }
    /**
     * Gets a list of backups based on the `databaseId` or `compartmentId` specified. Either one of these query parameters must be provided.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListBackupsRequest
     * @return ListBackupsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListBackups.ts.html |here} to see how to use ListBackups API.
     */
    listBackups(listBackupsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listBackups.");
            const pathParams = {};
            const queryParams = {
                "databaseId": listBackupsRequest.databaseId,
                "compartmentId": listBackupsRequest.compartmentId,
                "limit": listBackupsRequest.limit,
                "page": listBackupsRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listBackupsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backups",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.BackupSummary,
                    type: "Array<model.BackupSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listBackupsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.BackupSummary objects
     * contained in responses from the listBackups operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBackups(request) {
        return oci_common_1.paginateRecords(request, req => this.listBackups(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listBackupsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listBackups operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllBackupsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listBackups(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.BackupSummary objects
     * contained in responses from the listBackups operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBackupsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listBackups(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listBackups operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listBackupsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listBackups(req));
    }
    /**
     * Lists Autonomous Exadata VM clusters in the Oracle cloud. For Exadata Cloud@Customer systems, see {@link #listAutonomousVmClusters(ListAutonomousVmClustersRequest) listAutonomousVmClusters}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListCloudAutonomousVmClustersRequest
     * @return ListCloudAutonomousVmClustersResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListCloudAutonomousVmClusters.ts.html |here} to see how to use ListCloudAutonomousVmClusters API.
     */
    listCloudAutonomousVmClusters(listCloudAutonomousVmClustersRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listCloudAutonomousVmClusters.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listCloudAutonomousVmClustersRequest.compartmentId,
                "cloudExadataInfrastructureId": listCloudAutonomousVmClustersRequest.cloudExadataInfrastructureId,
                "limit": listCloudAutonomousVmClustersRequest.limit,
                "page": listCloudAutonomousVmClustersRequest.page,
                "sortBy": listCloudAutonomousVmClustersRequest.sortBy,
                "sortOrder": listCloudAutonomousVmClustersRequest.sortOrder,
                "lifecycleState": listCloudAutonomousVmClustersRequest.lifecycleState,
                "availabilityDomain": listCloudAutonomousVmClustersRequest.availabilityDomain,
                "displayName": listCloudAutonomousVmClustersRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listCloudAutonomousVmClustersRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listCloudAutonomousVmClustersRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.CloudAutonomousVmClusterSummary,
                    type: "Array<model.CloudAutonomousVmClusterSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudAutonomousVmClustersRecordIterator function.
     * Creates a new async iterator which will iterate over the models.CloudAutonomousVmClusterSummary objects
     * contained in responses from the listCloudAutonomousVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudAutonomousVmClusters(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudAutonomousVmClusters(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudAutonomousVmClustersResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listCloudAutonomousVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudAutonomousVmClustersResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudAutonomousVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.CloudAutonomousVmClusterSummary objects
     * contained in responses from the listCloudAutonomousVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudAutonomousVmClustersRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudAutonomousVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listCloudAutonomousVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudAutonomousVmClustersResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudAutonomousVmClusters(req));
    }
    /**
     * Gets a list of the cloud Exadata infrastructure resources in the specified compartment. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListCloudExadataInfrastructuresRequest
     * @return ListCloudExadataInfrastructuresResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListCloudExadataInfrastructures.ts.html |here} to see how to use ListCloudExadataInfrastructures API.
     */
    listCloudExadataInfrastructures(listCloudExadataInfrastructuresRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listCloudExadataInfrastructures.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listCloudExadataInfrastructuresRequest.compartmentId,
                "limit": listCloudExadataInfrastructuresRequest.limit,
                "page": listCloudExadataInfrastructuresRequest.page,
                "sortBy": listCloudExadataInfrastructuresRequest.sortBy,
                "sortOrder": listCloudExadataInfrastructuresRequest.sortOrder,
                "lifecycleState": listCloudExadataInfrastructuresRequest.lifecycleState,
                "displayName": listCloudExadataInfrastructuresRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listCloudExadataInfrastructuresRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listCloudExadataInfrastructuresRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.CloudExadataInfrastructureSummary,
                    type: "Array<model.CloudExadataInfrastructureSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudExadataInfrastructuresRecordIterator function.
     * Creates a new async iterator which will iterate over the models.CloudExadataInfrastructureSummary objects
     * contained in responses from the listCloudExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudExadataInfrastructures(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudExadataInfrastructures(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudExadataInfrastructuresResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listCloudExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudExadataInfrastructuresResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.CloudExadataInfrastructureSummary objects
     * contained in responses from the listCloudExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudExadataInfrastructuresRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listCloudExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudExadataInfrastructuresResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudExadataInfrastructures(req));
    }
    /**
     * Gets the history of the maintenance update actions performed on the specified cloud VM cluster. Applies to Exadata Cloud Service instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListCloudVmClusterUpdateHistoryEntriesRequest
     * @return ListCloudVmClusterUpdateHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListCloudVmClusterUpdateHistoryEntries.ts.html |here} to see how to use ListCloudVmClusterUpdateHistoryEntries API.
     */
    listCloudVmClusterUpdateHistoryEntries(listCloudVmClusterUpdateHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listCloudVmClusterUpdateHistoryEntries.");
            const pathParams = {
                "{cloudVmClusterId}": listCloudVmClusterUpdateHistoryEntriesRequest.cloudVmClusterId
            };
            const queryParams = {
                "updateType": listCloudVmClusterUpdateHistoryEntriesRequest.updateType,
                "limit": listCloudVmClusterUpdateHistoryEntriesRequest.limit,
                "page": listCloudVmClusterUpdateHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listCloudVmClusterUpdateHistoryEntriesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listCloudVmClusterUpdateHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/updateHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.UpdateHistoryEntrySummary,
                    type: "Array<model.UpdateHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClusterUpdateHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.UpdateHistoryEntrySummary objects
     * contained in responses from the listCloudVmClusterUpdateHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClusterUpdateHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusterUpdateHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClusterUpdateHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusterUpdateHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClusterUpdateHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.UpdateHistoryEntrySummary objects
     * contained in responses from the listCloudVmClusterUpdateHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClusterUpdateHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusterUpdateHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClusterUpdateHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Lists the maintenance updates that can be applied to the specified cloud VM cluster. Applies to Exadata Cloud Service instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListCloudVmClusterUpdatesRequest
     * @return ListCloudVmClusterUpdatesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListCloudVmClusterUpdates.ts.html |here} to see how to use ListCloudVmClusterUpdates API.
     */
    listCloudVmClusterUpdates(listCloudVmClusterUpdatesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listCloudVmClusterUpdates.");
            const pathParams = {
                "{cloudVmClusterId}": listCloudVmClusterUpdatesRequest.cloudVmClusterId
            };
            const queryParams = {
                "updateType": listCloudVmClusterUpdatesRequest.updateType,
                "limit": listCloudVmClusterUpdatesRequest.limit,
                "page": listCloudVmClusterUpdatesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listCloudVmClusterUpdatesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listCloudVmClusterUpdatesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/updates",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.UpdateSummary,
                    type: "Array<model.UpdateSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClusterUpdatesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.UpdateSummary objects
     * contained in responses from the listCloudVmClusterUpdates operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClusterUpdates(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusterUpdates(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClusterUpdatesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusterUpdates operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClusterUpdatesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusterUpdates(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.UpdateSummary objects
     * contained in responses from the listCloudVmClusterUpdates operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClusterUpdatesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusterUpdates(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusterUpdates operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClusterUpdatesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusterUpdates(req));
    }
    /**
     * Gets a list of the cloud VM clusters in the specified compartment. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListCloudVmClustersRequest
     * @return ListCloudVmClustersResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListCloudVmClusters.ts.html |here} to see how to use ListCloudVmClusters API.
     */
    listCloudVmClusters(listCloudVmClustersRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listCloudVmClusters.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listCloudVmClustersRequest.compartmentId,
                "cloudExadataInfrastructureId": listCloudVmClustersRequest.cloudExadataInfrastructureId,
                "limit": listCloudVmClustersRequest.limit,
                "page": listCloudVmClustersRequest.page,
                "sortBy": listCloudVmClustersRequest.sortBy,
                "sortOrder": listCloudVmClustersRequest.sortOrder,
                "lifecycleState": listCloudVmClustersRequest.lifecycleState,
                "displayName": listCloudVmClustersRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listCloudVmClustersRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listCloudVmClustersRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.CloudVmClusterSummary,
                    type: "Array<model.CloudVmClusterSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClustersRecordIterator function.
     * Creates a new async iterator which will iterate over the models.CloudVmClusterSummary objects
     * contained in responses from the listCloudVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClusters(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusters(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listCloudVmClustersResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllCloudVmClustersResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.CloudVmClusterSummary objects
     * contained in responses from the listCloudVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClustersRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listCloudVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listCloudVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listCloudVmClustersResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listCloudVmClusters(req));
    }
    /**
     * Lists the console connections for the specified database node.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListConsoleConnectionsRequest
     * @return ListConsoleConnectionsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListConsoleConnections.ts.html |here} to see how to use ListConsoleConnections API.
     */
    listConsoleConnections(listConsoleConnectionsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listConsoleConnections.");
            const pathParams = {
                "{dbNodeId}": listConsoleConnectionsRequest.dbNodeId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listConsoleConnectionsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes/{dbNodeId}/consoleConnections",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ConsoleConnectionSummary,
                    type: "Array<model.ConsoleConnectionSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Lists the patches applicable to the requested container database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListContainerDatabasePatchesRequest
     * @return ListContainerDatabasePatchesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListContainerDatabasePatches.ts.html |here} to see how to use ListContainerDatabasePatches API.
     */
    listContainerDatabasePatches(listContainerDatabasePatchesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listContainerDatabasePatches.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": listContainerDatabasePatchesRequest.autonomousContainerDatabaseId
            };
            const queryParams = {
                "limit": listContainerDatabasePatchesRequest.limit,
                "page": listContainerDatabasePatchesRequest.page,
                "compartmentId": listContainerDatabasePatchesRequest.compartmentId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listContainerDatabasePatchesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/patches",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.AutonomousPatchSummary,
                    type: "Array<model.AutonomousPatchSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listContainerDatabasePatchesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.AutonomousPatchSummary objects
     * contained in responses from the listContainerDatabasePatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllContainerDatabasePatches(request) {
        return oci_common_1.paginateRecords(request, req => this.listContainerDatabasePatches(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listContainerDatabasePatchesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listContainerDatabasePatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllContainerDatabasePatchesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listContainerDatabasePatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.AutonomousPatchSummary objects
     * contained in responses from the listContainerDatabasePatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listContainerDatabasePatchesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listContainerDatabasePatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listContainerDatabasePatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listContainerDatabasePatchesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listContainerDatabasePatches(req));
    }
    /**
     * Lists all Data Guard associations for the specified database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDataGuardAssociationsRequest
     * @return ListDataGuardAssociationsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDataGuardAssociations.ts.html |here} to see how to use ListDataGuardAssociations API.
     */
    listDataGuardAssociations(listDataGuardAssociationsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDataGuardAssociations.");
            const pathParams = {
                "{databaseId}": listDataGuardAssociationsRequest.databaseId
            };
            const queryParams = {
                "limit": listDataGuardAssociationsRequest.limit,
                "page": listDataGuardAssociationsRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDataGuardAssociationsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DataGuardAssociationSummary,
                    type: "Array<model.DataGuardAssociationSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDataGuardAssociationsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DataGuardAssociationSummary objects
     * contained in responses from the listDataGuardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDataGuardAssociations(request) {
        return oci_common_1.paginateRecords(request, req => this.listDataGuardAssociations(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDataGuardAssociationsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDataGuardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDataGuardAssociationsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDataGuardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DataGuardAssociationSummary objects
     * contained in responses from the listDataGuardAssociations operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDataGuardAssociationsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDataGuardAssociations(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDataGuardAssociations operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDataGuardAssociationsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDataGuardAssociations(req));
    }
    /**
     * Gets a list of the database software images in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDatabaseSoftwareImagesRequest
     * @return ListDatabaseSoftwareImagesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDatabaseSoftwareImages.ts.html |here} to see how to use ListDatabaseSoftwareImages API.
     */
    listDatabaseSoftwareImages(listDatabaseSoftwareImagesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDatabaseSoftwareImages.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDatabaseSoftwareImagesRequest.compartmentId,
                "limit": listDatabaseSoftwareImagesRequest.limit,
                "page": listDatabaseSoftwareImagesRequest.page,
                "sortBy": listDatabaseSoftwareImagesRequest.sortBy,
                "sortOrder": listDatabaseSoftwareImagesRequest.sortOrder,
                "lifecycleState": listDatabaseSoftwareImagesRequest.lifecycleState,
                "displayName": listDatabaseSoftwareImagesRequest.displayName,
                "imageType": listDatabaseSoftwareImagesRequest.imageType,
                "imageShapeFamily": listDatabaseSoftwareImagesRequest.imageShapeFamily,
                "isUpgradeSupported": listDatabaseSoftwareImagesRequest.isUpgradeSupported
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDatabaseSoftwareImagesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DatabaseSoftwareImageSummary,
                    type: "Array<model.DatabaseSoftwareImageSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabaseSoftwareImagesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DatabaseSoftwareImageSummary objects
     * contained in responses from the listDatabaseSoftwareImages operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabaseSoftwareImages(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabaseSoftwareImages(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabaseSoftwareImagesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDatabaseSoftwareImages operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabaseSoftwareImagesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabaseSoftwareImages(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DatabaseSoftwareImageSummary objects
     * contained in responses from the listDatabaseSoftwareImages operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabaseSoftwareImagesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabaseSoftwareImages(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDatabaseSoftwareImages operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabaseSoftwareImagesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabaseSoftwareImages(req));
    }
    /**
     * Gets the upgrade history for a specified database in a bare metal or virtual machine DB system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDatabaseUpgradeHistoryEntriesRequest
     * @return ListDatabaseUpgradeHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDatabaseUpgradeHistoryEntries.ts.html |here} to see how to use ListDatabaseUpgradeHistoryEntries API.
     */
    listDatabaseUpgradeHistoryEntries(listDatabaseUpgradeHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDatabaseUpgradeHistoryEntries.");
            const pathParams = {
                "{databaseId}": listDatabaseUpgradeHistoryEntriesRequest.databaseId
            };
            const queryParams = {
                "upgradeAction": listDatabaseUpgradeHistoryEntriesRequest.upgradeAction,
                "lifecycleState": listDatabaseUpgradeHistoryEntriesRequest.lifecycleState,
                "sortBy": listDatabaseUpgradeHistoryEntriesRequest.sortBy,
                "sortOrder": listDatabaseUpgradeHistoryEntriesRequest.sortOrder,
                "limit": listDatabaseUpgradeHistoryEntriesRequest.limit,
                "page": listDatabaseUpgradeHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listDatabaseUpgradeHistoryEntriesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDatabaseUpgradeHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/upgradeHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DatabaseUpgradeHistoryEntrySummary,
                    type: "Array<model.DatabaseUpgradeHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabaseUpgradeHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DatabaseUpgradeHistoryEntrySummary objects
     * contained in responses from the listDatabaseUpgradeHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabaseUpgradeHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabaseUpgradeHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabaseUpgradeHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDatabaseUpgradeHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabaseUpgradeHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabaseUpgradeHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DatabaseUpgradeHistoryEntrySummary objects
     * contained in responses from the listDatabaseUpgradeHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabaseUpgradeHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabaseUpgradeHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDatabaseUpgradeHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabaseUpgradeHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabaseUpgradeHistoryEntries(req));
    }
    /**
     * Gets a list of the databases in the specified Database Home.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDatabasesRequest
     * @return ListDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDatabases.ts.html |here} to see how to use ListDatabases API.
     */
    listDatabases(listDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDatabasesRequest.compartmentId,
                "dbHomeId": listDatabasesRequest.dbHomeId,
                "systemId": listDatabasesRequest.systemId,
                "limit": listDatabasesRequest.limit,
                "page": listDatabasesRequest.page,
                "sortBy": listDatabasesRequest.sortBy,
                "sortOrder": listDatabasesRequest.sortOrder,
                "lifecycleState": listDatabasesRequest.lifecycleState,
                "dbName": listDatabasesRequest.dbName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DatabaseSummary,
                    type: "Array<model.DatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DatabaseSummary objects
     * contained in responses from the listDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DatabaseSummary objects
     * contained in responses from the listDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDatabases(req));
    }
    /**
     * Lists the history of patch operations on the specified Database Home.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbHomePatchHistoryEntriesRequest
     * @return ListDbHomePatchHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbHomePatchHistoryEntries.ts.html |here} to see how to use ListDbHomePatchHistoryEntries API.
     */
    listDbHomePatchHistoryEntries(listDbHomePatchHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbHomePatchHistoryEntries.");
            const pathParams = {
                "{dbHomeId}": listDbHomePatchHistoryEntriesRequest.dbHomeId
            };
            const queryParams = {
                "limit": listDbHomePatchHistoryEntriesRequest.limit,
                "page": listDbHomePatchHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbHomePatchHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}/patchHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchHistoryEntrySummary,
                    type: "Array<model.PatchHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomePatchHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listDbHomePatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomePatchHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomePatchHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomePatchHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbHomePatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomePatchHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomePatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listDbHomePatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomePatchHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomePatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbHomePatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomePatchHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomePatchHistoryEntries(req));
    }
    /**
     * Lists patches applicable to the requested Database Home.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbHomePatchesRequest
     * @return ListDbHomePatchesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbHomePatches.ts.html |here} to see how to use ListDbHomePatches API.
     */
    listDbHomePatches(listDbHomePatchesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbHomePatches.");
            const pathParams = {
                "{dbHomeId}": listDbHomePatchesRequest.dbHomeId
            };
            const queryParams = {
                "limit": listDbHomePatchesRequest.limit,
                "page": listDbHomePatchesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbHomePatchesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}/patches",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchSummary,
                    type: "Array<model.PatchSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomePatchesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listDbHomePatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomePatches(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomePatches(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomePatchesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbHomePatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomePatchesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomePatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listDbHomePatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomePatchesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomePatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbHomePatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomePatchesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomePatches(req));
    }
    /**
     * Lists the Database Homes in the specified DB system and compartment. A Database Home is a directory where Oracle Database software is installed.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbHomesRequest
     * @return ListDbHomesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbHomes.ts.html |here} to see how to use ListDbHomes API.
     */
    listDbHomes(listDbHomesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbHomes.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDbHomesRequest.compartmentId,
                "dbSystemId": listDbHomesRequest.dbSystemId,
                "vmClusterId": listDbHomesRequest.vmClusterId,
                "backupId": listDbHomesRequest.backupId,
                "dbVersion": listDbHomesRequest.dbVersion,
                "limit": listDbHomesRequest.limit,
                "page": listDbHomesRequest.page,
                "sortBy": listDbHomesRequest.sortBy,
                "sortOrder": listDbHomesRequest.sortOrder,
                "lifecycleState": listDbHomesRequest.lifecycleState,
                "displayName": listDbHomesRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbHomesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbHomeSummary,
                    type: "Array<model.DbHomeSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbHomeSummary objects
     * contained in responses from the listDbHomes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomes(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomes(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbHomesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbHomes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbHomesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbHomeSummary objects
     * contained in responses from the listDbHomes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbHomes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbHomes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbHomesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbHomes(req));
    }
    /**
     * Lists the database nodes in the specified DB system and compartment. A database node is a server running database software.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbNodesRequest
     * @return ListDbNodesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbNodes.ts.html |here} to see how to use ListDbNodes API.
     */
    listDbNodes(listDbNodesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbNodes.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDbNodesRequest.compartmentId,
                "dbSystemId": listDbNodesRequest.dbSystemId,
                "vmClusterId": listDbNodesRequest.vmClusterId,
                "limit": listDbNodesRequest.limit,
                "page": listDbNodesRequest.page,
                "sortBy": listDbNodesRequest.sortBy,
                "sortOrder": listDbNodesRequest.sortOrder,
                "lifecycleState": listDbNodesRequest.lifecycleState,
                "dbServerId": listDbNodesRequest.dbServerId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbNodesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbNodes",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbNodeSummary,
                    type: "Array<model.DbNodeSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbNodesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbNodeSummary objects
     * contained in responses from the listDbNodes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbNodes(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbNodes(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbNodesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbNodes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbNodesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbNodes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbNodeSummary objects
     * contained in responses from the listDbNodes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbNodesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbNodes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbNodes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbNodesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbNodes(req));
    }
    /**
     * Lists the Exadata DB servers in the ExadataInfrastructureId and specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbServersRequest
     * @return ListDbServersResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbServers.ts.html |here} to see how to use ListDbServers API.
     */
    listDbServers(listDbServersRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbServers.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDbServersRequest.compartmentId,
                "exadataInfrastructureId": listDbServersRequest.exadataInfrastructureId,
                "limit": listDbServersRequest.limit,
                "page": listDbServersRequest.page,
                "sortOrder": listDbServersRequest.sortOrder,
                "sortBy": listDbServersRequest.sortBy,
                "lifecycleState": listDbServersRequest.lifecycleState,
                "displayName": listDbServersRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listDbServersRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbServersRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbServers",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbServerSummary,
                    type: "Array<model.DbServerSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbServersRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbServerSummary objects
     * contained in responses from the listDbServers operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbServers(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbServers(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbServersResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbServers operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbServersResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbServers(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbServerSummary objects
     * contained in responses from the listDbServers operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbServersRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbServers(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbServers operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbServersResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbServers(req));
    }
    /**
     * Gets the history of the patch actions performed on the specified DB system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbSystemPatchHistoryEntriesRequest
     * @return ListDbSystemPatchHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbSystemPatchHistoryEntries.ts.html |here} to see how to use ListDbSystemPatchHistoryEntries API.
     */
    listDbSystemPatchHistoryEntries(listDbSystemPatchHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbSystemPatchHistoryEntries.");
            const pathParams = {
                "{dbSystemId}": listDbSystemPatchHistoryEntriesRequest.dbSystemId
            };
            const queryParams = {
                "limit": listDbSystemPatchHistoryEntriesRequest.limit,
                "page": listDbSystemPatchHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbSystemPatchHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/patchHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchHistoryEntrySummary,
                    type: "Array<model.PatchHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemPatchHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listDbSystemPatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemPatchHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemPatchHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemPatchHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemPatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemPatchHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemPatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listDbSystemPatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemPatchHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemPatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemPatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemPatchHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemPatchHistoryEntries(req));
    }
    /**
     * Lists the patches applicable to the specified DB system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbSystemPatchesRequest
     * @return ListDbSystemPatchesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbSystemPatches.ts.html |here} to see how to use ListDbSystemPatches API.
     */
    listDbSystemPatches(listDbSystemPatchesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbSystemPatches.");
            const pathParams = {
                "{dbSystemId}": listDbSystemPatchesRequest.dbSystemId
            };
            const queryParams = {
                "limit": listDbSystemPatchesRequest.limit,
                "page": listDbSystemPatchesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbSystemPatchesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/patches",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchSummary,
                    type: "Array<model.PatchSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemPatchesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listDbSystemPatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemPatches(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemPatches(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemPatchesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemPatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemPatchesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemPatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listDbSystemPatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemPatchesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemPatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemPatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemPatchesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemPatches(req));
    }
    /**
     * Gets a list of the shapes that can be used to launch a new DB system. The shape determines resources to allocate to the DB system - CPU cores and memory for VM shapes; CPU cores, memory and storage for non-VM (or bare metal) shapes.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbSystemShapesRequest
     * @return ListDbSystemShapesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbSystemShapes.ts.html |here} to see how to use ListDbSystemShapes API.
     */
    listDbSystemShapes(listDbSystemShapesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbSystemShapes.");
            const pathParams = {};
            const queryParams = {
                "availabilityDomain": listDbSystemShapesRequest.availabilityDomain,
                "compartmentId": listDbSystemShapesRequest.compartmentId,
                "limit": listDbSystemShapesRequest.limit,
                "page": listDbSystemShapesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbSystemShapesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystemShapes",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbSystemShapeSummary,
                    type: "Array<model.DbSystemShapeSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemShapesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbSystemShapeSummary objects
     * contained in responses from the listDbSystemShapes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemShapes(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemShapes(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemShapesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemShapes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemShapesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemShapes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbSystemShapeSummary objects
     * contained in responses from the listDbSystemShapes operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemShapesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystemShapes(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbSystemShapes operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemShapesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystemShapes(req));
    }
    /**
       * Lists the DB systems in the specified compartment. You can specify a `backupId` to list only the DB systems that support creating a database using this backup in this compartment.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param ListDbSystemsRequest
       * @return ListDbSystemsResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbSystems.ts.html |here} to see how to use ListDbSystems API.
       */
    listDbSystems(listDbSystemsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbSystems.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDbSystemsRequest.compartmentId,
                "limit": listDbSystemsRequest.limit,
                "page": listDbSystemsRequest.page,
                "backupId": listDbSystemsRequest.backupId,
                "sortBy": listDbSystemsRequest.sortBy,
                "sortOrder": listDbSystemsRequest.sortOrder,
                "lifecycleState": listDbSystemsRequest.lifecycleState,
                "availabilityDomain": listDbSystemsRequest.availabilityDomain,
                "displayName": listDbSystemsRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbSystemsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbSystemSummary,
                    type: "Array<model.DbSystemSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbSystemSummary objects
     * contained in responses from the listDbSystems operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystems(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystems(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbSystemsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbSystems operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbSystemsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystems(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbSystemSummary objects
     * contained in responses from the listDbSystems operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbSystems(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbSystems operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbSystemsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbSystems(req));
    }
    /**
     * Gets a list of supported Oracle Database versions.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListDbVersionsRequest
     * @return ListDbVersionsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListDbVersions.ts.html |here} to see how to use ListDbVersions API.
     */
    listDbVersions(listDbVersionsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listDbVersions.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listDbVersionsRequest.compartmentId,
                "limit": listDbVersionsRequest.limit,
                "page": listDbVersionsRequest.page,
                "dbSystemShape": listDbVersionsRequest.dbSystemShape,
                "dbSystemId": listDbVersionsRequest.dbSystemId,
                "storageManagement": listDbVersionsRequest.storageManagement,
                "isUpgradeSupported": listDbVersionsRequest.isUpgradeSupported,
                "isDatabaseSoftwareImageSupported": listDbVersionsRequest.isDatabaseSoftwareImageSupported
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listDbVersionsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbVersions",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.DbVersionSummary,
                    type: "Array<model.DbVersionSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listDbVersionsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.DbVersionSummary objects
     * contained in responses from the listDbVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbVersions(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbVersions(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listDbVersionsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listDbVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllDbVersionsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.DbVersionSummary objects
     * contained in responses from the listDbVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbVersionsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listDbVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listDbVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listDbVersionsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listDbVersions(req));
    }
    /**
     * Lists the Exadata infrastructure resources in the specified compartment. Applies to Exadata Cloud@Customer instances only.
     * To list the Exadata Cloud Service infrastructure resources in a compartment, use the  {@link #listCloudExadataInfrastructures(ListCloudExadataInfrastructuresRequest) listCloudExadataInfrastructures} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListExadataInfrastructuresRequest
     * @return ListExadataInfrastructuresResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListExadataInfrastructures.ts.html |here} to see how to use ListExadataInfrastructures API.
     */
    listExadataInfrastructures(listExadataInfrastructuresRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listExadataInfrastructures.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listExadataInfrastructuresRequest.compartmentId,
                "limit": listExadataInfrastructuresRequest.limit,
                "page": listExadataInfrastructuresRequest.page,
                "sortBy": listExadataInfrastructuresRequest.sortBy,
                "sortOrder": listExadataInfrastructuresRequest.sortOrder,
                "lifecycleState": listExadataInfrastructuresRequest.lifecycleState,
                "displayName": listExadataInfrastructuresRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listExadataInfrastructuresRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listExadataInfrastructuresRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ExadataInfrastructureSummary,
                    type: "Array<model.ExadataInfrastructureSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listExadataInfrastructuresRecordIterator function.
     * Creates a new async iterator which will iterate over the models.ExadataInfrastructureSummary objects
     * contained in responses from the listExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExadataInfrastructures(request) {
        return oci_common_1.paginateRecords(request, req => this.listExadataInfrastructures(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listExadataInfrastructuresResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExadataInfrastructuresResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.ExadataInfrastructureSummary objects
     * contained in responses from the listExadataInfrastructures operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExadataInfrastructuresRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listExadataInfrastructures(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listExadataInfrastructures operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExadataInfrastructuresResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listExadataInfrastructures(req));
    }
    /**
     * Gets a list of the external container databases in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListExternalContainerDatabasesRequest
     * @return ListExternalContainerDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListExternalContainerDatabases.ts.html |here} to see how to use ListExternalContainerDatabases API.
     */
    listExternalContainerDatabases(listExternalContainerDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listExternalContainerDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listExternalContainerDatabasesRequest.compartmentId,
                "limit": listExternalContainerDatabasesRequest.limit,
                "page": listExternalContainerDatabasesRequest.page,
                "sortBy": listExternalContainerDatabasesRequest.sortBy,
                "sortOrder": listExternalContainerDatabasesRequest.sortOrder,
                "lifecycleState": listExternalContainerDatabasesRequest.lifecycleState,
                "displayName": listExternalContainerDatabasesRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listExternalContainerDatabasesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listExternalContainerDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ExternalContainerDatabaseSummary,
                    type: "Array<model.ExternalContainerDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalContainerDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.ExternalContainerDatabaseSummary objects
     * contained in responses from the listExternalContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalContainerDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalContainerDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalContainerDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listExternalContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalContainerDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.ExternalContainerDatabaseSummary objects
     * contained in responses from the listExternalContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalContainerDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listExternalContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalContainerDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalContainerDatabases(req));
    }
    /**
     * Gets a list of the external database connectors in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListExternalDatabaseConnectorsRequest
     * @return ListExternalDatabaseConnectorsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListExternalDatabaseConnectors.ts.html |here} to see how to use ListExternalDatabaseConnectors API.
     */
    listExternalDatabaseConnectors(listExternalDatabaseConnectorsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listExternalDatabaseConnectors.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listExternalDatabaseConnectorsRequest.compartmentId,
                "externalDatabaseId": listExternalDatabaseConnectorsRequest.externalDatabaseId,
                "limit": listExternalDatabaseConnectorsRequest.limit,
                "page": listExternalDatabaseConnectorsRequest.page,
                "sortBy": listExternalDatabaseConnectorsRequest.sortBy,
                "sortOrder": listExternalDatabaseConnectorsRequest.sortOrder,
                "lifecycleState": listExternalDatabaseConnectorsRequest.lifecycleState,
                "displayName": listExternalDatabaseConnectorsRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listExternalDatabaseConnectorsRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listExternalDatabaseConnectorsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ExternalDatabaseConnectorSummary,
                    type: "Array<model.ExternalDatabaseConnectorSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalDatabaseConnectorsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.ExternalDatabaseConnectorSummary objects
     * contained in responses from the listExternalDatabaseConnectors operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalDatabaseConnectors(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalDatabaseConnectors(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalDatabaseConnectorsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listExternalDatabaseConnectors operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalDatabaseConnectorsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalDatabaseConnectors(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.ExternalDatabaseConnectorSummary objects
     * contained in responses from the listExternalDatabaseConnectors operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalDatabaseConnectorsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalDatabaseConnectors(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listExternalDatabaseConnectors operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalDatabaseConnectorsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalDatabaseConnectors(req));
    }
    /**
     * Gets a list of the ExternalNonContainerDatabases in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListExternalNonContainerDatabasesRequest
     * @return ListExternalNonContainerDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListExternalNonContainerDatabases.ts.html |here} to see how to use ListExternalNonContainerDatabases API.
     */
    listExternalNonContainerDatabases(listExternalNonContainerDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listExternalNonContainerDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listExternalNonContainerDatabasesRequest.compartmentId,
                "limit": listExternalNonContainerDatabasesRequest.limit,
                "page": listExternalNonContainerDatabasesRequest.page,
                "sortBy": listExternalNonContainerDatabasesRequest.sortBy,
                "sortOrder": listExternalNonContainerDatabasesRequest.sortOrder,
                "lifecycleState": listExternalNonContainerDatabasesRequest.lifecycleState,
                "displayName": listExternalNonContainerDatabasesRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listExternalNonContainerDatabasesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listExternalNonContainerDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ExternalNonContainerDatabaseSummary,
                    type: "Array<model.ExternalNonContainerDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalNonContainerDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.ExternalNonContainerDatabaseSummary objects
     * contained in responses from the listExternalNonContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalNonContainerDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalNonContainerDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalNonContainerDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listExternalNonContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalNonContainerDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalNonContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.ExternalNonContainerDatabaseSummary objects
     * contained in responses from the listExternalNonContainerDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalNonContainerDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalNonContainerDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listExternalNonContainerDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalNonContainerDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalNonContainerDatabases(req));
    }
    /**
     * Gets a list of the {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails}
     * resources in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListExternalPluggableDatabasesRequest
     * @return ListExternalPluggableDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListExternalPluggableDatabases.ts.html |here} to see how to use ListExternalPluggableDatabases API.
     */
    listExternalPluggableDatabases(listExternalPluggableDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listExternalPluggableDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listExternalPluggableDatabasesRequest.compartmentId,
                "externalContainerDatabaseId": listExternalPluggableDatabasesRequest.externalContainerDatabaseId,
                "limit": listExternalPluggableDatabasesRequest.limit,
                "page": listExternalPluggableDatabasesRequest.page,
                "sortBy": listExternalPluggableDatabasesRequest.sortBy,
                "sortOrder": listExternalPluggableDatabasesRequest.sortOrder,
                "lifecycleState": listExternalPluggableDatabasesRequest.lifecycleState,
                "displayName": listExternalPluggableDatabasesRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listExternalPluggableDatabasesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listExternalPluggableDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.ExternalPluggableDatabaseSummary,
                    type: "Array<model.ExternalPluggableDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalPluggableDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.ExternalPluggableDatabaseSummary objects
     * contained in responses from the listExternalPluggableDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalPluggableDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalPluggableDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listExternalPluggableDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listExternalPluggableDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllExternalPluggableDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalPluggableDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.ExternalPluggableDatabaseSummary objects
     * contained in responses from the listExternalPluggableDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalPluggableDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listExternalPluggableDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listExternalPluggableDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listExternalPluggableDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listExternalPluggableDatabases(req));
    }
    /**
     * Gets a list of the flex components that can be used to launch a new DB system. The flex component determines resources to allocate to the DB system - Database Servers and Storage Servers.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListFlexComponentsRequest
     * @return ListFlexComponentsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListFlexComponents.ts.html |here} to see how to use ListFlexComponents API.
     */
    listFlexComponents(listFlexComponentsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listFlexComponents.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listFlexComponentsRequest.compartmentId,
                "name": listFlexComponentsRequest.name,
                "sortOrder": listFlexComponentsRequest.sortOrder,
                "sortBy": listFlexComponentsRequest.sortBy,
                "limit": listFlexComponentsRequest.limit,
                "page": listFlexComponentsRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listFlexComponentsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystemShapes/flexComponents",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "flexComponentCollection",
                    bodyModel: model.FlexComponentCollection,
                    type: "model.FlexComponentCollection",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Gets a list of supported GI versions for the Exadata Cloud@Customer VM cluster.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListGiVersionsRequest
     * @return ListGiVersionsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListGiVersions.ts.html |here} to see how to use ListGiVersions API.
     */
    listGiVersions(listGiVersionsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listGiVersions.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listGiVersionsRequest.compartmentId,
                "limit": listGiVersionsRequest.limit,
                "page": listGiVersionsRequest.page,
                "sortOrder": listGiVersionsRequest.sortOrder,
                "shape": listGiVersionsRequest.shape
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listGiVersionsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/giVersions",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.GiVersionSummary,
                    type: "Array<model.GiVersionSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listGiVersionsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.GiVersionSummary objects
     * contained in responses from the listGiVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllGiVersions(request) {
        return oci_common_1.paginateRecords(request, req => this.listGiVersions(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listGiVersionsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listGiVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllGiVersionsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listGiVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.GiVersionSummary objects
     * contained in responses from the listGiVersions operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listGiVersionsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listGiVersions(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listGiVersions operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listGiVersionsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listGiVersions(req));
    }
    /**
     * Gets a list of key stores in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListKeyStoresRequest
     * @return ListKeyStoresResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListKeyStores.ts.html |here} to see how to use ListKeyStores API.
     */
    listKeyStores(listKeyStoresRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listKeyStores.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listKeyStoresRequest.compartmentId,
                "limit": listKeyStoresRequest.limit,
                "page": listKeyStoresRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listKeyStoresRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listKeyStoresRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.KeyStoreSummary,
                    type: "Array<model.KeyStoreSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listKeyStoresRecordIterator function.
     * Creates a new async iterator which will iterate over the models.KeyStoreSummary objects
     * contained in responses from the listKeyStores operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllKeyStores(request) {
        return oci_common_1.paginateRecords(request, req => this.listKeyStores(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listKeyStoresResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listKeyStores operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllKeyStoresResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listKeyStores(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.KeyStoreSummary objects
     * contained in responses from the listKeyStores operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listKeyStoresRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listKeyStores(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listKeyStores operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listKeyStoresResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listKeyStores(req));
    }
    /**
     * Gets a list of the maintenance runs in the specified compartment.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListMaintenanceRunsRequest
     * @return ListMaintenanceRunsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListMaintenanceRuns.ts.html |here} to see how to use ListMaintenanceRuns API.
     */
    listMaintenanceRuns(listMaintenanceRunsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listMaintenanceRuns.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listMaintenanceRunsRequest.compartmentId,
                "targetResourceId": listMaintenanceRunsRequest.targetResourceId,
                "targetResourceType": listMaintenanceRunsRequest.targetResourceType,
                "maintenanceType": listMaintenanceRunsRequest.maintenanceType,
                "limit": listMaintenanceRunsRequest.limit,
                "page": listMaintenanceRunsRequest.page,
                "sortBy": listMaintenanceRunsRequest.sortBy,
                "sortOrder": listMaintenanceRunsRequest.sortOrder,
                "lifecycleState": listMaintenanceRunsRequest.lifecycleState,
                "availabilityDomain": listMaintenanceRunsRequest.availabilityDomain
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listMaintenanceRunsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/maintenanceRuns",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.MaintenanceRunSummary,
                    type: "Array<model.MaintenanceRunSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listMaintenanceRunsRecordIterator function.
     * Creates a new async iterator which will iterate over the models.MaintenanceRunSummary objects
     * contained in responses from the listMaintenanceRuns operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllMaintenanceRuns(request) {
        return oci_common_1.paginateRecords(request, req => this.listMaintenanceRuns(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listMaintenanceRunsResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listMaintenanceRuns operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllMaintenanceRunsResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listMaintenanceRuns(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.MaintenanceRunSummary objects
     * contained in responses from the listMaintenanceRuns operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listMaintenanceRunsRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listMaintenanceRuns(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listMaintenanceRuns operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listMaintenanceRunsResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listMaintenanceRuns(req));
    }
    /**
     * Gets the pluggable database conversion history for a specified database in a bare metal or virtual machine DB system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListPdbConversionHistoryEntriesRequest
     * @return ListPdbConversionHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListPdbConversionHistoryEntries.ts.html |here} to see how to use ListPdbConversionHistoryEntries API.
     */
    listPdbConversionHistoryEntries(listPdbConversionHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listPdbConversionHistoryEntries.");
            const pathParams = {
                "{databaseId}": listPdbConversionHistoryEntriesRequest.databaseId
            };
            const queryParams = {
                "pdbConversionAction": listPdbConversionHistoryEntriesRequest.pdbConversionAction,
                "lifecycleState": listPdbConversionHistoryEntriesRequest.lifecycleState,
                "sortBy": listPdbConversionHistoryEntriesRequest.sortBy,
                "sortOrder": listPdbConversionHistoryEntriesRequest.sortOrder,
                "limit": listPdbConversionHistoryEntriesRequest.limit,
                "page": listPdbConversionHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listPdbConversionHistoryEntriesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listPdbConversionHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/pdbConversionHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PdbConversionHistoryEntrySummary,
                    type: "Array<model.PdbConversionHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listPdbConversionHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PdbConversionHistoryEntrySummary objects
     * contained in responses from the listPdbConversionHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllPdbConversionHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listPdbConversionHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listPdbConversionHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listPdbConversionHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllPdbConversionHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listPdbConversionHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PdbConversionHistoryEntrySummary objects
     * contained in responses from the listPdbConversionHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listPdbConversionHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listPdbConversionHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listPdbConversionHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listPdbConversionHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listPdbConversionHistoryEntries(req));
    }
    /**
     * Gets a list of the pluggable databases in a database or compartment. You must provide either a `databaseId` or `compartmentId` value.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListPluggableDatabasesRequest
     * @return ListPluggableDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListPluggableDatabases.ts.html |here} to see how to use ListPluggableDatabases API.
     */
    listPluggableDatabases(listPluggableDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listPluggableDatabases.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listPluggableDatabasesRequest.compartmentId,
                "databaseId": listPluggableDatabasesRequest.databaseId,
                "limit": listPluggableDatabasesRequest.limit,
                "page": listPluggableDatabasesRequest.page,
                "sortBy": listPluggableDatabasesRequest.sortBy,
                "sortOrder": listPluggableDatabasesRequest.sortOrder,
                "lifecycleState": listPluggableDatabasesRequest.lifecycleState,
                "pdbName": listPluggableDatabasesRequest.pdbName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listPluggableDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PluggableDatabaseSummary,
                    type: "Array<model.PluggableDatabaseSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listPluggableDatabasesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PluggableDatabaseSummary objects
     * contained in responses from the listPluggableDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllPluggableDatabases(request) {
        return oci_common_1.paginateRecords(request, req => this.listPluggableDatabases(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listPluggableDatabasesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listPluggableDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllPluggableDatabasesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listPluggableDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PluggableDatabaseSummary objects
     * contained in responses from the listPluggableDatabases operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listPluggableDatabasesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listPluggableDatabases(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listPluggableDatabases operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listPluggableDatabasesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listPluggableDatabases(req));
    }
    /**
     * Gets a list of the VM cluster networks in the specified compartment. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClusterNetworksRequest
     * @return ListVmClusterNetworksResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusterNetworks.ts.html |here} to see how to use ListVmClusterNetworks API.
     */
    listVmClusterNetworks(listVmClusterNetworksRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusterNetworks.");
            const pathParams = {
                "{exadataInfrastructureId}": listVmClusterNetworksRequest.exadataInfrastructureId
            };
            const queryParams = {
                "compartmentId": listVmClusterNetworksRequest.compartmentId,
                "limit": listVmClusterNetworksRequest.limit,
                "page": listVmClusterNetworksRequest.page,
                "sortBy": listVmClusterNetworksRequest.sortBy,
                "sortOrder": listVmClusterNetworksRequest.sortOrder,
                "lifecycleState": listVmClusterNetworksRequest.lifecycleState,
                "displayName": listVmClusterNetworksRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listVmClusterNetworksRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClusterNetworksRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.VmClusterNetworkSummary,
                    type: "Array<model.VmClusterNetworkSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterNetworksRecordIterator function.
     * Creates a new async iterator which will iterate over the models.VmClusterNetworkSummary objects
     * contained in responses from the listVmClusterNetworks operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterNetworks(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterNetworks(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterNetworksResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterNetworks operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterNetworksResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterNetworks(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.VmClusterNetworkSummary objects
     * contained in responses from the listVmClusterNetworks operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterNetworksRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterNetworks(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterNetworks operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterNetworksResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterNetworks(req));
    }
    /**
     * Gets the history of the patch actions performed on the specified VM cluster in an Exadata Cloud@Customer system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClusterPatchHistoryEntriesRequest
     * @return ListVmClusterPatchHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusterPatchHistoryEntries.ts.html |here} to see how to use ListVmClusterPatchHistoryEntries API.
     */
    listVmClusterPatchHistoryEntries(listVmClusterPatchHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusterPatchHistoryEntries.");
            const pathParams = {
                "{vmClusterId}": listVmClusterPatchHistoryEntriesRequest.vmClusterId
            };
            const queryParams = {
                "limit": listVmClusterPatchHistoryEntriesRequest.limit,
                "page": listVmClusterPatchHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClusterPatchHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/patchHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchHistoryEntrySummary,
                    type: "Array<model.PatchHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterPatchHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listVmClusterPatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterPatchHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterPatchHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterPatchHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterPatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterPatchHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterPatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchHistoryEntrySummary objects
     * contained in responses from the listVmClusterPatchHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterPatchHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterPatchHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterPatchHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterPatchHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterPatchHistoryEntries(req));
    }
    /**
     * Lists the patches applicable to the specified VM cluster in an Exadata Cloud@Customer system.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClusterPatchesRequest
     * @return ListVmClusterPatchesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusterPatches.ts.html |here} to see how to use ListVmClusterPatches API.
     */
    listVmClusterPatches(listVmClusterPatchesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusterPatches.");
            const pathParams = {
                "{vmClusterId}": listVmClusterPatchesRequest.vmClusterId
            };
            const queryParams = {
                "limit": listVmClusterPatchesRequest.limit,
                "page": listVmClusterPatchesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClusterPatchesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/patches",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.PatchSummary,
                    type: "Array<model.PatchSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterPatchesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listVmClusterPatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterPatches(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterPatches(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterPatchesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterPatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterPatchesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterPatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.PatchSummary objects
     * contained in responses from the listVmClusterPatches operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterPatchesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterPatches(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterPatches operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterPatchesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterPatches(req));
    }
    /**
     * Gets the history of the maintenance update actions performed on the specified VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClusterUpdateHistoryEntriesRequest
     * @return ListVmClusterUpdateHistoryEntriesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusterUpdateHistoryEntries.ts.html |here} to see how to use ListVmClusterUpdateHistoryEntries API.
     */
    listVmClusterUpdateHistoryEntries(listVmClusterUpdateHistoryEntriesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusterUpdateHistoryEntries.");
            const pathParams = {
                "{vmClusterId}": listVmClusterUpdateHistoryEntriesRequest.vmClusterId
            };
            const queryParams = {
                "updateType": listVmClusterUpdateHistoryEntriesRequest.updateType,
                "lifecycleState": listVmClusterUpdateHistoryEntriesRequest.lifecycleState,
                "limit": listVmClusterUpdateHistoryEntriesRequest.limit,
                "page": listVmClusterUpdateHistoryEntriesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listVmClusterUpdateHistoryEntriesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClusterUpdateHistoryEntriesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/updateHistoryEntries",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.VmClusterUpdateHistoryEntrySummary,
                    type: "Array<model.VmClusterUpdateHistoryEntrySummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterUpdateHistoryEntriesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.VmClusterUpdateHistoryEntrySummary objects
     * contained in responses from the listVmClusterUpdateHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterUpdateHistoryEntries(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterUpdateHistoryEntries(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterUpdateHistoryEntriesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterUpdateHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterUpdateHistoryEntriesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.VmClusterUpdateHistoryEntrySummary objects
     * contained in responses from the listVmClusterUpdateHistoryEntries operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterUpdateHistoryEntriesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterUpdateHistoryEntries operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterUpdateHistoryEntriesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterUpdateHistoryEntries(req));
    }
    /**
     * Lists the maintenance updates that can be applied to the specified VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClusterUpdatesRequest
     * @return ListVmClusterUpdatesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusterUpdates.ts.html |here} to see how to use ListVmClusterUpdates API.
     */
    listVmClusterUpdates(listVmClusterUpdatesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusterUpdates.");
            const pathParams = {
                "{vmClusterId}": listVmClusterUpdatesRequest.vmClusterId
            };
            const queryParams = {
                "updateType": listVmClusterUpdatesRequest.updateType,
                "lifecycleState": listVmClusterUpdatesRequest.lifecycleState,
                "limit": listVmClusterUpdatesRequest.limit,
                "page": listVmClusterUpdatesRequest.page
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listVmClusterUpdatesRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClusterUpdatesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/updates",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.VmClusterUpdateSummary,
                    type: "Array<model.VmClusterUpdateSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterUpdatesRecordIterator function.
     * Creates a new async iterator which will iterate over the models.VmClusterUpdateSummary objects
     * contained in responses from the listVmClusterUpdates operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterUpdates(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterUpdates(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClusterUpdatesResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterUpdates operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusterUpdatesResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterUpdates(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.VmClusterUpdateSummary objects
     * contained in responses from the listVmClusterUpdates operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterUpdatesRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusterUpdates(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusterUpdates operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClusterUpdatesResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusterUpdates(req));
    }
    /**
     * Lists the VM clusters in the specified compartment. Applies to Exadata Cloud@Customer instances only.
     * To list the cloud VM clusters in an Exadata Cloud Service instance, use the {@link #listCloudVmClusters(ListCloudVmClustersRequest) listCloudVmClusters} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ListVmClustersRequest
     * @return ListVmClustersResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ListVmClusters.ts.html |here} to see how to use ListVmClusters API.
     */
    listVmClusters(listVmClustersRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#listVmClusters.");
            const pathParams = {};
            const queryParams = {
                "compartmentId": listVmClustersRequest.compartmentId,
                "exadataInfrastructureId": listVmClustersRequest.exadataInfrastructureId,
                "limit": listVmClustersRequest.limit,
                "page": listVmClustersRequest.page,
                "sortBy": listVmClustersRequest.sortBy,
                "sortOrder": listVmClustersRequest.sortOrder,
                "lifecycleState": listVmClustersRequest.lifecycleState,
                "displayName": listVmClustersRequest.displayName
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": listVmClustersRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, listVmClustersRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters",
                method: "GET",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "items",
                    bodyModel: model.VmClusterSummary,
                    type: "Array<model.VmClusterSummary>",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-next-page"),
                            key: "opcNextPage",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClustersRecordIterator function.
     * Creates a new async iterator which will iterate over the models.VmClusterSummary objects
     * contained in responses from the listVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClusters(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusters(req));
    }
    /**
     * NOTE: This function is deprecated in favor of listVmClustersResponseIterator function.
     * Creates a new async iterator which will iterate over the responses received from the listVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listAllVmClustersResponses(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the models.VmClusterSummary objects
     * contained in responses from the listVmClusters operation. This iterator will fetch more data from the
     * server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClustersRecordIterator(request) {
        return oci_common_1.paginateRecords(request, req => this.listVmClusters(req));
    }
    /**
     * Creates a new async iterator which will iterate over the responses received from the listVmClusters operation. This iterator
     * will fetch more data from the server as needed.
     *
     * @param request a request which can be sent to the service operation
     */
    listVmClustersResponseIterator(request) {
        return oci_common_1.paginateResponses(request, req => this.listVmClusters(req));
    }
    /**
     * Clones and starts a pluggable database (PDB) in the same database (CDB) as the source PDB. The source PDB must be in the `READ_WRITE` openMode to perform the clone operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param LocalClonePluggableDatabaseRequest
     * @return LocalClonePluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/LocalClonePluggableDatabase.ts.html |here} to see how to use LocalClonePluggableDatabase API.
     */
    localClonePluggableDatabase(localClonePluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#localClonePluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": localClonePluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": localClonePluggableDatabaseRequest.ifMatch,
                "opc-request-id": localClonePluggableDatabaseRequest.opcRequestId,
                "opc-retry-token": localClonePluggableDatabaseRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, localClonePluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}/actions/localClone",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(localClonePluggableDatabaseRequest.localClonePluggableDatabaseDetails, "LocalClonePluggableDatabaseDetails", model.LocalClonePluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Migrates the Exadata DB system to the new [Exadata resource model](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model).
     * All related resources will be migrated.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param MigrateExadataDbSystemResourceModelRequest
     * @return MigrateExadataDbSystemResourceModelResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/MigrateExadataDbSystemResourceModel.ts.html |here} to see how to use MigrateExadataDbSystemResourceModel API.
     */
    migrateExadataDbSystemResourceModel(migrateExadataDbSystemResourceModelRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#migrateExadataDbSystemResourceModel.");
            const pathParams = {
                "{dbSystemId}": migrateExadataDbSystemResourceModelRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": migrateExadataDbSystemResourceModelRequest.opcRequestId,
                "if-match": migrateExadataDbSystemResourceModelRequest.ifMatch,
                "opc-retry-token": migrateExadataDbSystemResourceModelRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, migrateExadataDbSystemResourceModelRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/actions/migration",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataDbSystemMigration",
                    bodyModel: model.ExadataDbSystemMigration,
                    type: "model.ExadataDbSystemMigration",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Changes encryption key management from customer-managed, using the [Vault service](https://docs.cloud.oracle.com/iaas/Content/KeyManagement/Concepts/keyoverview.htm), to Oracle-managed.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param MigrateVaultKeyRequest
     * @return MigrateVaultKeyResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/MigrateVaultKey.ts.html |here} to see how to use MigrateVaultKey API.
     */
    migrateVaultKey(migrateVaultKeyRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#migrateVaultKey.");
            const pathParams = {
                "{databaseId}": migrateVaultKeyRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": migrateVaultKeyRequest.ifMatch,
                "opc-retry-token": migrateVaultKeyRequest.opcRetryToken,
                "opc-request-id": migrateVaultKeyRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, migrateVaultKeyRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/migrateKey",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(migrateVaultKeyRequest.migrateVaultKeyDetails, "MigrateVaultKeyDetails", model.MigrateVaultKeyDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates one or more attributes of the Database Management service for the database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ModifyDatabaseManagementRequest
     * @return ModifyDatabaseManagementResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ModifyDatabaseManagement.ts.html |here} to see how to use ModifyDatabaseManagement API.
     */
    modifyDatabaseManagement(modifyDatabaseManagementRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#modifyDatabaseManagement.");
            const pathParams = {
                "{databaseId}": modifyDatabaseManagementRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": modifyDatabaseManagementRequest.opcRetryToken,
                "opc-request-id": modifyDatabaseManagementRequest.opcRequestId,
                "if-match": modifyDatabaseManagementRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, modifyDatabaseManagementRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/modifyDatabaseManagement",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(modifyDatabaseManagementRequest.modifyDatabaseManagementDetails, "ModifyDatabaseManagementDetails", model.ModifyDatabaseManagementDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Asynchronously registers this Autonomous Database with Data Safe.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RegisterAutonomousDatabaseDataSafeRequest
     * @return RegisterAutonomousDatabaseDataSafeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RegisterAutonomousDatabaseDataSafe.ts.html |here} to see how to use RegisterAutonomousDatabaseDataSafe API.
     */
    registerAutonomousDatabaseDataSafe(registerAutonomousDatabaseDataSafeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#registerAutonomousDatabaseDataSafe.");
            const pathParams = {
                "{autonomousDatabaseId}": registerAutonomousDatabaseDataSafeRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": registerAutonomousDatabaseDataSafeRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, registerAutonomousDatabaseDataSafeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/registerDataSafe",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(registerAutonomousDatabaseDataSafeRequest.registerAutonomousDatabaseDataSafeDetails, "RegisterAutonomousDatabaseDataSafeDetails", model.RegisterAutonomousDatabaseDataSafeDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Reinstates a disabled standby Autonomous Container Database, identified by the autonomousContainerDatabaseId parameter, to an active standby Autonomous Container Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ReinstateAutonomousContainerDatabaseDataguardAssociationRequest
     * @return ReinstateAutonomousContainerDatabaseDataguardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ReinstateAutonomousContainerDatabaseDataguardAssociation.ts.html |here} to see how to use ReinstateAutonomousContainerDatabaseDataguardAssociation API.
     */
    reinstateAutonomousContainerDatabaseDataguardAssociation(reinstateAutonomousContainerDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#reinstateAutonomousContainerDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": reinstateAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseId,
                "{autonomousContainerDatabaseDataguardAssociationId}": reinstateAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": reinstateAutonomousContainerDatabaseDataguardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, reinstateAutonomousContainerDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations/{autonomousContainerDatabaseDataguardAssociationId}/actions/reinstate",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "model.AutonomousContainerDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Reinstates the database identified by the `databaseId` parameter into the standby role in a Data Guard association.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ReinstateDataGuardAssociationRequest
     * @return ReinstateDataGuardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ReinstateDataGuardAssociation.ts.html |here} to see how to use ReinstateDataGuardAssociation API.
     */
    reinstateDataGuardAssociation(reinstateDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#reinstateDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": reinstateDataGuardAssociationRequest.databaseId,
                "{dataGuardAssociationId}": reinstateDataGuardAssociationRequest.dataGuardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": reinstateDataGuardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, reinstateDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations/{dataGuardAssociationId}/actions/reinstate",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(reinstateDataGuardAssociationRequest.reinstateDataGuardAssociationDetails, "ReinstateDataGuardAssociationDetails", model.ReinstateDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Clones a pluggable database (PDB) to a different database from the source PDB. The cloned PDB will be started upon completion of the clone operation. The source PDB must be in the `READ_WRITE` openMode when performing the clone.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RemoteClonePluggableDatabaseRequest
     * @return RemoteClonePluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RemoteClonePluggableDatabase.ts.html |here} to see how to use RemoteClonePluggableDatabase API.
     */
    remoteClonePluggableDatabase(remoteClonePluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#remoteClonePluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": remoteClonePluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": remoteClonePluggableDatabaseRequest.ifMatch,
                "opc-request-id": remoteClonePluggableDatabaseRequest.opcRequestId,
                "opc-retry-token": remoteClonePluggableDatabaseRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, remoteClonePluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}/actions/remoteClone",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(remoteClonePluggableDatabaseRequest.remoteClonePluggableDatabaseDetails, "RemoteClonePluggableDatabaseDetails", model.RemoteClonePluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Remove Virtual Machines from the VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RemoveVirtualMachineFromVmClusterRequest
     * @return RemoveVirtualMachineFromVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RemoveVirtualMachineFromVmCluster.ts.html |here} to see how to use RemoveVirtualMachineFromVmCluster API.
     */
    removeVirtualMachineFromVmCluster(removeVirtualMachineFromVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#removeVirtualMachineFromVmCluster.");
            const pathParams = {
                "{vmClusterId}": removeVirtualMachineFromVmClusterRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": removeVirtualMachineFromVmClusterRequest.opcRetryToken,
                "opc-request-id": removeVirtualMachineFromVmClusterRequest.opcRequestId,
                "if-match": removeVirtualMachineFromVmClusterRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, removeVirtualMachineFromVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}/actions/removeVirtualMachine",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(removeVirtualMachineFromVmClusterRequest.removeVirtualMachineFromVmClusterDetails, "RemoveVirtualMachineFromVmClusterDetails", model.RemoveVirtualMachineFromVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmCluster",
                    bodyModel: model.VmCluster,
                    type: "model.VmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Rolling restarts the specified Autonomous Container Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RestartAutonomousContainerDatabaseRequest
     * @return RestartAutonomousContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RestartAutonomousContainerDatabase.ts.html |here} to see how to use RestartAutonomousContainerDatabase API.
     */
    restartAutonomousContainerDatabase(restartAutonomousContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#restartAutonomousContainerDatabase.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": restartAutonomousContainerDatabaseRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": restartAutonomousContainerDatabaseRequest.ifMatch,
                "opc-request-id": restartAutonomousContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, restartAutonomousContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/actions/restart",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabase",
                    bodyModel: model.AutonomousContainerDatabase,
                    type: "model.AutonomousContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Restarts the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RestartAutonomousDatabaseRequest
     * @return RestartAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RestartAutonomousDatabase.ts.html |here} to see how to use RestartAutonomousDatabase API.
     */
    restartAutonomousDatabase(restartAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#restartAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": restartAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": restartAutonomousDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, restartAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/restart",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Restores an Autonomous Database based on the provided request parameters.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RestoreAutonomousDatabaseRequest
     * @return RestoreAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RestoreAutonomousDatabase.ts.html |here} to see how to use RestoreAutonomousDatabase API.
     */
    restoreAutonomousDatabase(restoreAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#restoreAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": restoreAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": restoreAutonomousDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, restoreAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/restore",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(restoreAutonomousDatabaseRequest.restoreAutonomousDatabaseDetails, "RestoreAutonomousDatabaseDetails", model.RestoreAutonomousDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Restore a Database based on the request parameters you provide.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RestoreDatabaseRequest
     * @return RestoreDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RestoreDatabase.ts.html |here} to see how to use RestoreDatabase API.
     */
    restoreDatabase(restoreDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#restoreDatabase.");
            const pathParams = {
                "{databaseId}": restoreDatabaseRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": restoreDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, restoreDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/restore",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(restoreDatabaseRequest.restoreDatabaseDetails, "RestoreDatabaseDetails", model.RestoreDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new version of an existing [Vault service](https://docs.cloud.oracle.com/iaas/Content/KeyManagement/Concepts/keyoverview.htm) key.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateAutonomousContainerDatabaseEncryptionKeyRequest
     * @return RotateAutonomousContainerDatabaseEncryptionKeyResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateAutonomousContainerDatabaseEncryptionKey.ts.html |here} to see how to use RotateAutonomousContainerDatabaseEncryptionKey API.
     */
    rotateAutonomousContainerDatabaseEncryptionKey(rotateAutonomousContainerDatabaseEncryptionKeyRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateAutonomousContainerDatabaseEncryptionKey.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": rotateAutonomousContainerDatabaseEncryptionKeyRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": rotateAutonomousContainerDatabaseEncryptionKeyRequest.ifMatch,
                "opc-retry-token": rotateAutonomousContainerDatabaseEncryptionKeyRequest.opcRetryToken,
                "opc-request-id": rotateAutonomousContainerDatabaseEncryptionKeyRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateAutonomousContainerDatabaseEncryptionKeyRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/actions/rotateKey",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabase",
                    bodyModel: model.AutonomousContainerDatabase,
                    type: "model.AutonomousContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Rotate existing AutonomousDatabase [Vault service](https://docs.cloud.oracle.com/iaas/Content/KeyManagement/Concepts/keyoverview.htm) key.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateAutonomousDatabaseEncryptionKeyRequest
     * @return RotateAutonomousDatabaseEncryptionKeyResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateAutonomousDatabaseEncryptionKey.ts.html |here} to see how to use RotateAutonomousDatabaseEncryptionKey API.
     */
    rotateAutonomousDatabaseEncryptionKey(rotateAutonomousDatabaseEncryptionKeyRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateAutonomousDatabaseEncryptionKey.");
            const pathParams = {
                "{autonomousDatabaseId}": rotateAutonomousDatabaseEncryptionKeyRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": rotateAutonomousDatabaseEncryptionKeyRequest.ifMatch,
                "opc-retry-token": rotateAutonomousDatabaseEncryptionKeyRequest.opcRetryToken,
                "opc-request-id": rotateAutonomousDatabaseEncryptionKeyRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateAutonomousDatabaseEncryptionKeyRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/rotateKey",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Rotates the Oracle REST Data Services (ORDS) certificates for a cloud Autonomous Exadata VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateCloudAutonomousVmClusterOrdsCertsRequest
     * @return RotateCloudAutonomousVmClusterOrdsCertsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateCloudAutonomousVmClusterOrdsCerts.ts.html |here} to see how to use RotateCloudAutonomousVmClusterOrdsCerts API.
     */
    rotateCloudAutonomousVmClusterOrdsCerts(rotateCloudAutonomousVmClusterOrdsCertsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateCloudAutonomousVmClusterOrdsCerts.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": rotateCloudAutonomousVmClusterOrdsCertsRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": rotateCloudAutonomousVmClusterOrdsCertsRequest.opcRetryToken,
                "opc-request-id": rotateCloudAutonomousVmClusterOrdsCertsRequest.opcRequestId,
                "if-match": rotateCloudAutonomousVmClusterOrdsCertsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateCloudAutonomousVmClusterOrdsCertsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}/actions/rotateOrdsCerts",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Rotates the SSL certficates for a cloud Autonomous Exadata VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateCloudAutonomousVmClusterSslCertsRequest
     * @return RotateCloudAutonomousVmClusterSslCertsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateCloudAutonomousVmClusterSslCerts.ts.html |here} to see how to use RotateCloudAutonomousVmClusterSslCerts API.
     */
    rotateCloudAutonomousVmClusterSslCerts(rotateCloudAutonomousVmClusterSslCertsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateCloudAutonomousVmClusterSslCerts.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": rotateCloudAutonomousVmClusterSslCertsRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-retry-token": rotateCloudAutonomousVmClusterSslCertsRequest.opcRetryToken,
                "opc-request-id": rotateCloudAutonomousVmClusterSslCertsRequest.opcRequestId,
                "if-match": rotateCloudAutonomousVmClusterSslCertsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateCloudAutonomousVmClusterSslCertsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}/actions/rotateSslCerts",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** Use the {@link #rotateCloudAutonomousVmClusterOrdsCerts(RotateCloudAutonomousVmClusterOrdsCertsRequest) rotateCloudAutonomousVmClusterOrdsCerts} to rotate Oracle REST Data Services (ORDS) certs for an Autonomous Exadata VM cluster instead.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateOrdsCertsRequest
     * @return RotateOrdsCertsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateOrdsCerts.ts.html |here} to see how to use RotateOrdsCerts API.
     */
    rotateOrdsCerts(rotateOrdsCertsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateOrdsCerts.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": rotateOrdsCertsRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": rotateOrdsCertsRequest.opcRequestId,
                "opc-retry-token": rotateOrdsCertsRequest.opcRetryToken,
                "if-match": rotateOrdsCertsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateOrdsCertsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}/actions/rotateOrdsCerts",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** Use the {@link #rotateCloudAutonomousVmClusterSslCerts(RotateCloudAutonomousVmClusterSslCertsRequest) rotateCloudAutonomousVmClusterSslCerts} to rotate SSL certs for an Autonomous Exadata VM cluster instead.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateSslCertsRequest
     * @return RotateSslCertsResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateSslCerts.ts.html |here} to see how to use RotateSslCerts API.
     */
    rotateSslCerts(rotateSslCertsRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateSslCerts.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": rotateSslCertsRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": rotateSslCertsRequest.opcRequestId,
                "opc-retry-token": rotateSslCertsRequest.opcRetryToken,
                "if-match": rotateSslCertsRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateSslCertsRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}/actions/rotateSslCerts",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Creates a new version of an existing [Vault service](https://docs.cloud.oracle.com/iaas/Content/KeyManagement/Concepts/keyoverview.htm) key.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param RotateVaultKeyRequest
     * @return RotateVaultKeyResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/RotateVaultKey.ts.html |here} to see how to use RotateVaultKey API.
     */
    rotateVaultKey(rotateVaultKeyRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#rotateVaultKey.");
            const pathParams = {
                "{databaseId}": rotateVaultKeyRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": rotateVaultKeyRequest.ifMatch,
                "opc-retry-token": rotateVaultKeyRequest.opcRetryToken,
                "opc-request-id": rotateVaultKeyRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, rotateVaultKeyRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/rotateKey",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Scans for pluggable databases in the specified external container database.
     * This operation will return un-registered pluggable databases in the `GetWorkRequest` operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ScanExternalContainerDatabasePluggableDatabasesRequest
     * @return ScanExternalContainerDatabasePluggableDatabasesResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ScanExternalContainerDatabasePluggableDatabases.ts.html |here} to see how to use ScanExternalContainerDatabasePluggableDatabases API.
     */
    scanExternalContainerDatabasePluggableDatabases(scanExternalContainerDatabasePluggableDatabasesRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#scanExternalContainerDatabasePluggableDatabases.");
            const pathParams = {
                "{externalContainerDatabaseId}": scanExternalContainerDatabasePluggableDatabasesRequest.externalContainerDatabaseId
            };
            const queryParams = {
                "externalDatabaseConnectorId": scanExternalContainerDatabasePluggableDatabasesRequest.externalDatabaseConnectorId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": scanExternalContainerDatabasePluggableDatabasesRequest.opcRequestId,
                "opc-retry-token": scanExternalContainerDatabasePluggableDatabasesRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, scanExternalContainerDatabasePluggableDatabasesRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}/actions/scanPluggableDatabases",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * This operation shrinks the current allocated storage down to the current actual used data storage (actualUsedDataStorageSizeInTBs). The if the base storage value for the database (dataStorageSizeInTBs) is larger than the actualUsedDataStorageSizeInTBs value, you are billed for the base storage value.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ShrinkAutonomousDatabaseRequest
     * @return ShrinkAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ShrinkAutonomousDatabase.ts.html |here} to see how to use ShrinkAutonomousDatabase API.
     */
    shrinkAutonomousDatabase(shrinkAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#shrinkAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": shrinkAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": shrinkAutonomousDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, shrinkAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/shrink",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Starts the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param StartAutonomousDatabaseRequest
     * @return StartAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/StartAutonomousDatabase.ts.html |here} to see how to use StartAutonomousDatabase API.
     */
    startAutonomousDatabase(startAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#startAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": startAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": startAutonomousDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, startAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/start",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Starts a stopped pluggable database. The `openMode` value of the pluggable database will be `READ_WRITE` upon completion.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param StartPluggableDatabaseRequest
     * @return StartPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/StartPluggableDatabase.ts.html |here} to see how to use StartPluggableDatabase API.
     */
    startPluggableDatabase(startPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#startPluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": startPluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": startPluggableDatabaseRequest.ifMatch,
                "opc-request-id": startPluggableDatabaseRequest.opcRequestId,
                "opc-retry-token": startPluggableDatabaseRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, startPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}/actions/start",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Stops the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param StopAutonomousDatabaseRequest
     * @return StopAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/StopAutonomousDatabase.ts.html |here} to see how to use StopAutonomousDatabase API.
     */
    stopAutonomousDatabase(stopAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#stopAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": stopAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": stopAutonomousDatabaseRequest.ifMatch,
                "opc-request-id": stopAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, stopAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/stop",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Stops a pluggable database. The `openMode` value of the pluggable database will be `MOUNTED` upon completion.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param StopPluggableDatabaseRequest
     * @return StopPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/StopPluggableDatabase.ts.html |here} to see how to use StopPluggableDatabase API.
     */
    stopPluggableDatabase(stopPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#stopPluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": stopPluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": stopPluggableDatabaseRequest.ifMatch,
                "opc-request-id": stopPluggableDatabaseRequest.opcRequestId,
                "opc-retry-token": stopPluggableDatabaseRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, stopPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}/actions/stop",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Switches over the primary Autonomous Container Database of an Autonomous Data Guard peer association to standby role. The standby Autonomous Container Database associated with autonomousContainerDatabaseDataguardAssociationId assumes the primary Autonomous Container Database role.
  * <p>
  A switchover incurs no data loss.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param SwitchoverAutonomousContainerDatabaseDataguardAssociationRequest
       * @return SwitchoverAutonomousContainerDatabaseDataguardAssociationResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/SwitchoverAutonomousContainerDatabaseDataguardAssociation.ts.html |here} to see how to use SwitchoverAutonomousContainerDatabaseDataguardAssociation API.
       */
    switchoverAutonomousContainerDatabaseDataguardAssociation(switchoverAutonomousContainerDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#switchoverAutonomousContainerDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": switchoverAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseId,
                "{autonomousContainerDatabaseDataguardAssociationId}": switchoverAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": switchoverAutonomousContainerDatabaseDataguardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, switchoverAutonomousContainerDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations/{autonomousContainerDatabaseDataguardAssociationId}/actions/switchover",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "model.AutonomousContainerDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Initiates a switchover of the specified Autonomous Database to the associated standby database. Applicable only to databases with Autonomous Data Guard enabled. To perform a switchover to a standby located in a remote region, specify the [OCID](https://docs.cloud.oracle.com/Content/General/Concepts/identifiers.htm) of the remote standby using the `peerDbId` parameter.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param SwitchoverAutonomousDatabaseRequest
     * @return SwitchoverAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/SwitchoverAutonomousDatabase.ts.html |here} to see how to use SwitchoverAutonomousDatabase API.
     */
    switchoverAutonomousDatabase(switchoverAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#switchoverAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": switchoverAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {
                "peerDbId": switchoverAutonomousDatabaseRequest.peerDbId
            };
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": switchoverAutonomousDatabaseRequest.ifMatch,
                "opc-retry-token": switchoverAutonomousDatabaseRequest.opcRetryToken,
                "opc-request-id": switchoverAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, switchoverAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/actions/switchover",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Performs a switchover to transition the primary database of a Data Guard association into a standby role. The
  * standby database associated with the `dataGuardAssociationId` assumes the primary database role.
  * <p>
  A switchover guarantees no data loss.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param SwitchoverDataGuardAssociationRequest
       * @return SwitchoverDataGuardAssociationResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/SwitchoverDataGuardAssociation.ts.html |here} to see how to use SwitchoverDataGuardAssociation API.
       */
    switchoverDataGuardAssociation(switchoverDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#switchoverDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": switchoverDataGuardAssociationRequest.databaseId,
                "{dataGuardAssociationId}": switchoverDataGuardAssociationRequest.dataGuardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": switchoverDataGuardAssociationRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, switchoverDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations/{dataGuardAssociationId}/actions/switchover",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(switchoverDataGuardAssociationRequest.switchoverDataGuardAssociationDetails, "SwitchoverDataGuardAssociationDetails", model.SwitchoverDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Terminates an Autonomous Container Database, which permanently deletes the container database and any databases within the container database. The database data is local to the Autonomous Exadata Infrastructure and will be lost when the container database is terminated. Oracle recommends that you back up any data in the Autonomous Container Database prior to terminating it.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param TerminateAutonomousContainerDatabaseRequest
     * @return TerminateAutonomousContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/TerminateAutonomousContainerDatabase.ts.html |here} to see how to use TerminateAutonomousContainerDatabase API.
     */
    terminateAutonomousContainerDatabase(terminateAutonomousContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#terminateAutonomousContainerDatabase.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": terminateAutonomousContainerDatabaseRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": terminateAutonomousContainerDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, terminateAutonomousContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** To terminate an Exadata Infrastructure resource in the Oracle cloud, use the {@link #deleteCloudExadataInfrastructure(DeleteCloudExadataInfrastructureRequest) deleteCloudExadataInfrastructure} operation. To delete an Autonomous Exadata VM cluster in the Oracle cloud, use the {@link #deleteCloudAutonomousVmCluster(DeleteCloudAutonomousVmClusterRequest) deleteCloudAutonomousVmCluster} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param TerminateAutonomousExadataInfrastructureRequest
     * @return TerminateAutonomousExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/TerminateAutonomousExadataInfrastructure.ts.html |here} to see how to use TerminateAutonomousExadataInfrastructure API.
     */
    terminateAutonomousExadataInfrastructure(terminateAutonomousExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#terminateAutonomousExadataInfrastructure.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": terminateAutonomousExadataInfrastructureRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": terminateAutonomousExadataInfrastructureRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, terminateAutonomousExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Terminates a DB system and permanently deletes it and any databases running on it, and any storage volumes attached to it. The database data is local to the DB system and will be lost when the system is terminated. Oracle recommends that you back up any data in the DB system prior to terminating it.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param TerminateDbSystemRequest
       * @return TerminateDbSystemResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/TerminateDbSystem.ts.html |here} to see how to use TerminateDbSystem API.
       */
    terminateDbSystem(terminateDbSystemRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#terminateDbSystem.");
            const pathParams = {
                "{dbSystemId}": terminateDbSystemRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": terminateDbSystemRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, terminateDbSystemRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}",
                method: "DELETE",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of an Autonomous Container Database, such as the OCPU core count and storage size.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousContainerDatabaseRequest
     * @return UpdateAutonomousContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousContainerDatabase.ts.html |here} to see how to use UpdateAutonomousContainerDatabase API.
     */
    updateAutonomousContainerDatabase(updateAutonomousContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousContainerDatabase.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": updateAutonomousContainerDatabaseRequest.autonomousContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateAutonomousContainerDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousContainerDatabaseRequest.updateAutonomousContainerDatabaseDetails, "UpdateAutonomousContainerDatabaseDetails", model.UpdateAutonomousContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabase",
                    bodyModel: model.AutonomousContainerDatabase,
                    type: "model.AutonomousContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Update Autonomous Data Guard association.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousContainerDatabaseDataguardAssociationRequest
     * @return UpdateAutonomousContainerDatabaseDataguardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousContainerDatabaseDataguardAssociation.ts.html |here} to see how to use UpdateAutonomousContainerDatabaseDataguardAssociation API.
     */
    updateAutonomousContainerDatabaseDataguardAssociation(updateAutonomousContainerDatabaseDataguardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousContainerDatabaseDataguardAssociation.");
            const pathParams = {
                "{autonomousContainerDatabaseId}": updateAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseId,
                "{autonomousContainerDatabaseDataguardAssociationId}": updateAutonomousContainerDatabaseDataguardAssociationRequest.autonomousContainerDatabaseDataguardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateAutonomousContainerDatabaseDataguardAssociationRequest.ifMatch,
                "opc-request-id": updateAutonomousContainerDatabaseDataguardAssociationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousContainerDatabaseDataguardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousContainerDatabases/{autonomousContainerDatabaseId}/autonomousContainerDatabaseDataguardAssociations/{autonomousContainerDatabaseDataguardAssociationId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousContainerDatabaseDataguardAssociationRequest.updateAutonomousContainerDatabaseDataGuardAssociationDetails, "UpdateAutonomousContainerDatabaseDataGuardAssociationDetails", model.UpdateAutonomousContainerDatabaseDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousContainerDatabaseDataguardAssociation",
                    bodyModel: model.AutonomousContainerDatabaseDataguardAssociation,
                    type: "model.AutonomousContainerDatabaseDataguardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates one or more attributes of the specified Autonomous Database. See the UpdateAutonomousDatabaseDetails resource for a full list of attributes that can be updated.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousDatabaseRequest
     * @return UpdateAutonomousDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousDatabase.ts.html |here} to see how to use UpdateAutonomousDatabase API.
     */
    updateAutonomousDatabase(updateAutonomousDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousDatabase.");
            const pathParams = {
                "{autonomousDatabaseId}": updateAutonomousDatabaseRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateAutonomousDatabaseRequest.ifMatch,
                "opc-request-id": updateAutonomousDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousDatabaseRequest.updateAutonomousDatabaseDetails, "UpdateAutonomousDatabaseDetails", model.UpdateAutonomousDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousDatabase",
                    bodyModel: model.AutonomousDatabase,
                    type: "model.AutonomousDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the Autonomous Database regional wallet.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousDatabaseRegionalWalletRequest
     * @return UpdateAutonomousDatabaseRegionalWalletResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousDatabaseRegionalWallet.ts.html |here} to see how to use UpdateAutonomousDatabaseRegionalWallet API.
     */
    updateAutonomousDatabaseRegionalWallet(updateAutonomousDatabaseRegionalWalletRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousDatabaseRegionalWallet.");
            const pathParams = {};
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": updateAutonomousDatabaseRegionalWalletRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousDatabaseRegionalWalletRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/wallet",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousDatabaseRegionalWalletRequest.updateAutonomousDatabaseWalletDetails, "UpdateAutonomousDatabaseWalletDetails", model.UpdateAutonomousDatabaseWalletDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the wallet for the specified Autonomous Database.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousDatabaseWalletRequest
     * @return UpdateAutonomousDatabaseWalletResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousDatabaseWallet.ts.html |here} to see how to use UpdateAutonomousDatabaseWallet API.
     */
    updateAutonomousDatabaseWallet(updateAutonomousDatabaseWalletRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousDatabaseWallet.");
            const pathParams = {
                "{autonomousDatabaseId}": updateAutonomousDatabaseWalletRequest.autonomousDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": updateAutonomousDatabaseWalletRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousDatabaseWalletRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousDatabases/{autonomousDatabaseId}/wallet",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousDatabaseWalletRequest.updateAutonomousDatabaseWalletDetails, "UpdateAutonomousDatabaseWalletDetails", model.UpdateAutonomousDatabaseWalletDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * **Deprecated.** Use the {@link #updateCloudExadataInfrastructure(UpdateCloudExadataInfrastructureRequest) updateCloudExadataInfrastructure} operation to update an Exadata Infrastructure resource and  {@link #updateCloudAutonomousVmCluster(UpdateCloudAutonomousVmClusterRequest) updateCloudAutonomousVmCluster} operation to update an Autonomous Exadata VM cluster.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousExadataInfrastructureRequest
     * @return UpdateAutonomousExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousExadataInfrastructure.ts.html |here} to see how to use UpdateAutonomousExadataInfrastructure API.
     */
    updateAutonomousExadataInfrastructure(updateAutonomousExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousExadataInfrastructure.");
            const pathParams = {
                "{autonomousExadataInfrastructureId}": updateAutonomousExadataInfrastructureRequest.autonomousExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateAutonomousExadataInfrastructureRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousExadataInfrastructures/{autonomousExadataInfrastructureId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousExadataInfrastructureRequest.updateAutonomousExadataInfrastructuresDetails, "UpdateAutonomousExadataInfrastructureDetails", model.UpdateAutonomousExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousExadataInfrastructure",
                    bodyModel: model.AutonomousExadataInfrastructure,
                    type: "model.AutonomousExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified Autonomous VM cluster for the Exadata Cloud@Customer system.To update an Autonomous VM Cluster in the Oracle cloud, see {@link #updateCloudAutonomousVmCluster(UpdateCloudAutonomousVmClusterRequest) updateCloudAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateAutonomousVmClusterRequest
     * @return UpdateAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateAutonomousVmCluster.ts.html |here} to see how to use UpdateAutonomousVmCluster API.
     */
    updateAutonomousVmCluster(updateAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateAutonomousVmCluster.");
            const pathParams = {
                "{autonomousVmClusterId}": updateAutonomousVmClusterRequest.autonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateAutonomousVmClusterRequest.ifMatch,
                "opc-request-id": updateAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/autonomousVmClusters/{autonomousVmClusterId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateAutonomousVmClusterRequest.updateAutonomousVmClusterDetails, "UpdateAutonomousVmClusterDetails", model.UpdateAutonomousVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "autonomousVmCluster",
                    bodyModel: model.AutonomousVmCluster,
                    type: "model.AutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * If no database is associated with the backup destination:
     * - For a RECOVERY_APPLIANCE backup destination, updates the connection string and/or the list of VPC users.
     * - For an NFS backup destination, updates the NFS location.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateBackupDestinationRequest
     * @return UpdateBackupDestinationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateBackupDestination.ts.html |here} to see how to use UpdateBackupDestination API.
     */
    updateBackupDestination(updateBackupDestinationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateBackupDestination.");
            const pathParams = {
                "{backupDestinationId}": updateBackupDestinationRequest.backupDestinationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateBackupDestinationRequest.ifMatch,
                "opc-request-id": updateBackupDestinationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateBackupDestinationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/backupDestinations/{backupDestinationId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateBackupDestinationRequest.updateBackupDestinationDetails, "UpdateBackupDestinationDetails", model.UpdateBackupDestinationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "backupDestination",
                    bodyModel: model.BackupDestination,
                    type: "model.BackupDestination",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified Autonomous Exadata VM cluster in the Oracle cloud. For Exadata Cloud@Customer systems, see {@link #updateAutonomousVmCluster(UpdateAutonomousVmClusterRequest) updateAutonomousVmCluster}.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateCloudAutonomousVmClusterRequest
     * @return UpdateCloudAutonomousVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateCloudAutonomousVmCluster.ts.html |here} to see how to use UpdateCloudAutonomousVmCluster API.
     */
    updateCloudAutonomousVmCluster(updateCloudAutonomousVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateCloudAutonomousVmCluster.");
            const pathParams = {
                "{cloudAutonomousVmClusterId}": updateCloudAutonomousVmClusterRequest.cloudAutonomousVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateCloudAutonomousVmClusterRequest.ifMatch,
                "opc-request-id": updateCloudAutonomousVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateCloudAutonomousVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudAutonomousVmClusters/{cloudAutonomousVmClusterId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateCloudAutonomousVmClusterRequest.updateCloudAutonomousVmClusterDetails, "UpdateCloudAutonomousVmClusterDetails", model.UpdateCloudAutonomousVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudAutonomousVmCluster",
                    bodyModel: model.CloudAutonomousVmCluster,
                    type: "model.CloudAutonomousVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the Cloud Exadata infrastructure resource. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateCloudExadataInfrastructureRequest
     * @return UpdateCloudExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateCloudExadataInfrastructure.ts.html |here} to see how to use UpdateCloudExadataInfrastructure API.
     */
    updateCloudExadataInfrastructure(updateCloudExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateCloudExadataInfrastructure.");
            const pathParams = {
                "{cloudExadataInfrastructureId}": updateCloudExadataInfrastructureRequest.cloudExadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateCloudExadataInfrastructureRequest.ifMatch,
                "opc-request-id": updateCloudExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateCloudExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudExadataInfrastructures/{cloudExadataInfrastructureId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateCloudExadataInfrastructureRequest.updateCloudExadataInfrastructureDetails, "UpdateCloudExadataInfrastructureDetails", model.UpdateCloudExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudExadataInfrastructure",
                    bodyModel: model.CloudExadataInfrastructure,
                    type: "model.CloudExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified cloud VM cluster. Applies to Exadata Cloud Service instances and Autonomous Database on dedicated Exadata infrastructure only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateCloudVmClusterRequest
     * @return UpdateCloudVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateCloudVmCluster.ts.html |here} to see how to use UpdateCloudVmCluster API.
     */
    updateCloudVmCluster(updateCloudVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateCloudVmCluster.");
            const pathParams = {
                "{cloudVmClusterId}": updateCloudVmClusterRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateCloudVmClusterRequest.ifMatch,
                "opc-request-id": updateCloudVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateCloudVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateCloudVmClusterRequest.updateCloudVmClusterDetails, "UpdateCloudVmClusterDetails", model.UpdateCloudVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "cloudVmCluster",
                    bodyModel: model.CloudVmCluster,
                    type: "model.CloudVmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the IORM settings for the specified cloud VM cluster in an Exadata Cloud Service instance.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateCloudVmClusterIormConfigRequest
     * @return UpdateCloudVmClusterIormConfigResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateCloudVmClusterIormConfig.ts.html |here} to see how to use UpdateCloudVmClusterIormConfig API.
     */
    updateCloudVmClusterIormConfig(updateCloudVmClusterIormConfigRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateCloudVmClusterIormConfig.");
            const pathParams = {
                "{cloudVmClusterId}": updateCloudVmClusterIormConfigRequest.cloudVmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": updateCloudVmClusterIormConfigRequest.opcRequestId,
                "if-match": updateCloudVmClusterIormConfigRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateCloudVmClusterIormConfigRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/cloudVmClusters/{cloudVmClusterId}/CloudVmClusterIormConfig",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateCloudVmClusterIormConfigRequest.cloudVmClusterIormConfigUpdateDetails, "ExadataIormConfigUpdateDetails", model.ExadataIormConfigUpdateDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataIormConfig",
                    bodyModel: model.ExadataIormConfig,
                    type: "model.ExadataIormConfig",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the Data Guard association the specified database. This API can be used to change the `protectionMode` and `transportType` of the Data Guard association.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateDataGuardAssociationRequest
     * @return UpdateDataGuardAssociationResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateDataGuardAssociation.ts.html |here} to see how to use UpdateDataGuardAssociation API.
     */
    updateDataGuardAssociation(updateDataGuardAssociationRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateDataGuardAssociation.");
            const pathParams = {
                "{databaseId}": updateDataGuardAssociationRequest.databaseId,
                "{dataGuardAssociationId}": updateDataGuardAssociationRequest.dataGuardAssociationId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateDataGuardAssociationRequest.ifMatch,
                "opc-request-id": updateDataGuardAssociationRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateDataGuardAssociationRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/dataGuardAssociations/{dataGuardAssociationId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateDataGuardAssociationRequest.updateDataGuardAssociationDetails, "UpdateDataGuardAssociationDetails", model.UpdateDataGuardAssociationDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dataGuardAssociation",
                    bodyModel: model.DataGuardAssociation,
                    type: "model.DataGuardAssociation",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Update the specified database based on the request parameters provided.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateDatabaseRequest
     * @return UpdateDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateDatabase.ts.html |here} to see how to use UpdateDatabase API.
     */
    updateDatabase(updateDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateDatabase.");
            const pathParams = {
                "{databaseId}": updateDatabaseRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateDatabaseRequest.updateDatabaseDetails, "UpdateDatabaseDetails", model.UpdateDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of a Database Software Image, like Display Nmae
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateDatabaseSoftwareImageRequest
     * @return UpdateDatabaseSoftwareImageResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateDatabaseSoftwareImage.ts.html |here} to see how to use UpdateDatabaseSoftwareImage API.
     */
    updateDatabaseSoftwareImage(updateDatabaseSoftwareImageRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateDatabaseSoftwareImage.");
            const pathParams = {
                "{databaseSoftwareImageId}": updateDatabaseSoftwareImageRequest.databaseSoftwareImageId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateDatabaseSoftwareImageRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateDatabaseSoftwareImageRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databaseSoftwareImages/{databaseSoftwareImageId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateDatabaseSoftwareImageRequest.updateDatabaseSoftwareImageDetails, "UpdateDatabaseSoftwareImageDetails", model.UpdateDatabaseSoftwareImageDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "databaseSoftwareImage",
                    bodyModel: model.DatabaseSoftwareImage,
                    type: "model.DatabaseSoftwareImage",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Patches the specified Database Home.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateDbHomeRequest
     * @return UpdateDbHomeResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateDbHome.ts.html |here} to see how to use UpdateDbHome API.
     */
    updateDbHome(updateDbHomeRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateDbHome.");
            const pathParams = {
                "{dbHomeId}": updateDbHomeRequest.dbHomeId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateDbHomeRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateDbHomeRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbHomes/{dbHomeId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateDbHomeRequest.updateDbHomeDetails, "UpdateDbHomeDetails", model.UpdateDbHomeDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbHome",
                    bodyModel: model.DbHome,
                    type: "model.DbHome",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Updates the properties of the specified DB system.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param UpdateDbSystemRequest
       * @return UpdateDbSystemResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateDbSystem.ts.html |here} to see how to use UpdateDbSystem API.
       */
    updateDbSystem(updateDbSystemRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateDbSystem.");
            const pathParams = {
                "{dbSystemId}": updateDbSystemRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateDbSystemRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateDbSystemRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateDbSystemRequest.updateDbSystemDetails, "UpdateDbSystemDetails", model.UpdateDbSystemDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "dbSystem",
                    bodyModel: model.DbSystem,
                    type: "model.DbSystem",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the Exadata infrastructure resource. Applies to Exadata Cloud@Customer instances only.
     * To update an Exadata Cloud Service infrastructure resource, use the  {@link #updateCloudExadataInfrastructure(UpdateCloudExadataInfrastructureRequest) updateCloudExadataInfrastructure} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateExadataInfrastructureRequest
     * @return UpdateExadataInfrastructureResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExadataInfrastructure.ts.html |here} to see how to use UpdateExadataInfrastructure API.
     */
    updateExadataInfrastructure(updateExadataInfrastructureRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExadataInfrastructure.");
            const pathParams = {
                "{exadataInfrastructureId}": updateExadataInfrastructureRequest.exadataInfrastructureId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateExadataInfrastructureRequest.ifMatch,
                "opc-request-id": updateExadataInfrastructureRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExadataInfrastructureRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExadataInfrastructureRequest.updateExadataInfrastructureDetails, "UpdateExadataInfrastructureDetails", model.UpdateExadataInfrastructureDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataInfrastructure",
                    bodyModel: model.ExadataInfrastructure,
                    type: "model.ExadataInfrastructure",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
       * Updates IORM settings for the specified Exadata DB system.
  * <p>
  **Note:** Deprecated for Exadata Cloud Service systems. Use the [new resource model APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem.htm#exaflexsystem_topic-resource_model) instead.
  * <p>
  For Exadata Cloud Service instances, support for this API will end on May 15th, 2021. See [Switching an Exadata DB System to the New Resource Model and APIs](https://docs.cloud.oracle.com/iaas/Content/Database/Concepts/exaflexsystem_topic-resource_model_conversion.htm) for details on converting existing Exadata DB systems to the new resource model.
  * <p>
  The {@link #updateCloudVmClusterIormConfig(UpdateCloudVmClusterIormConfigRequest) updateCloudVmClusterIormConfig} API is used for Exadata systems using the
  * new resource model.
  *
       * This operation does not retry by default if the user has not defined a retry configuration.
       * @param UpdateExadataIormConfigRequest
       * @return UpdateExadataIormConfigResponse
       * @throws OciError when an error occurs
       * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExadataIormConfig.ts.html |here} to see how to use UpdateExadataIormConfig API.
       */
    updateExadataIormConfig(updateExadataIormConfigRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExadataIormConfig.");
            const pathParams = {
                "{dbSystemId}": updateExadataIormConfigRequest.dbSystemId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": updateExadataIormConfigRequest.opcRequestId,
                "if-match": updateExadataIormConfigRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExadataIormConfigRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/dbSystems/{dbSystemId}/ExadataIormConfig",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExadataIormConfigRequest.exadataIormConfigUpdateDetails, "ExadataIormConfigUpdateDetails", model.ExadataIormConfigUpdateDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "exadataIormConfig",
                    bodyModel: model.ExadataIormConfig,
                    type: "model.ExadataIormConfig",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of
     * an {@link #createExternalContainerDatabaseDetails(CreateExternalContainerDatabaseDetailsRequest) createExternalContainerDatabaseDetails} resource,
     * such as the display name.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateExternalContainerDatabaseRequest
     * @return UpdateExternalContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExternalContainerDatabase.ts.html |here} to see how to use UpdateExternalContainerDatabase API.
     */
    updateExternalContainerDatabase(updateExternalContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExternalContainerDatabase.");
            const pathParams = {
                "{externalContainerDatabaseId}": updateExternalContainerDatabaseRequest.externalContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateExternalContainerDatabaseRequest.ifMatch,
                "opc-request-id": updateExternalContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExternalContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalcontainerdatabases/{externalContainerDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExternalContainerDatabaseRequest.updateExternalContainerDatabaseDetails, "UpdateExternalContainerDatabaseDetails", model.UpdateExternalContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalContainerDatabase",
                    bodyModel: model.ExternalContainerDatabase,
                    type: "model.ExternalContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of an external database connector, such as the display name.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateExternalDatabaseConnectorRequest
     * @return UpdateExternalDatabaseConnectorResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExternalDatabaseConnector.ts.html |here} to see how to use UpdateExternalDatabaseConnector API.
     */
    updateExternalDatabaseConnector(updateExternalDatabaseConnectorRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExternalDatabaseConnector.");
            const pathParams = {
                "{externalDatabaseConnectorId}": updateExternalDatabaseConnectorRequest.externalDatabaseConnectorId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateExternalDatabaseConnectorRequest.ifMatch,
                "opc-request-id": updateExternalDatabaseConnectorRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExternalDatabaseConnectorRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externaldatabaseconnectors/{externalDatabaseConnectorId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExternalDatabaseConnectorRequest.updateExternalDatabaseConnectorDetails, "UpdateExternalDatabaseConnectorDetails", model.UpdateExternalDatabaseConnectorDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalDatabaseConnector",
                    bodyModel: model.ExternalDatabaseConnector,
                    type: "model.ExternalDatabaseConnector",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of an external non-container database, such as the display name.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateExternalNonContainerDatabaseRequest
     * @return UpdateExternalNonContainerDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExternalNonContainerDatabase.ts.html |here} to see how to use UpdateExternalNonContainerDatabase API.
     */
    updateExternalNonContainerDatabase(updateExternalNonContainerDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExternalNonContainerDatabase.");
            const pathParams = {
                "{externalNonContainerDatabaseId}": updateExternalNonContainerDatabaseRequest.externalNonContainerDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateExternalNonContainerDatabaseRequest.ifMatch,
                "opc-request-id": updateExternalNonContainerDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExternalNonContainerDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalnoncontainerdatabases/{externalNonContainerDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExternalNonContainerDatabaseRequest.updateExternalNonContainerDatabaseDetails, "UpdateExternalNonContainerDatabaseDetails", model.UpdateExternalNonContainerDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalNonContainerDatabase",
                    bodyModel: model.ExternalNonContainerDatabase,
                    type: "model.ExternalNonContainerDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of an
     * {@link #createExternalPluggableDatabaseDetails(CreateExternalPluggableDatabaseDetailsRequest) createExternalPluggableDatabaseDetails} resource,
     * such as the display name.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateExternalPluggableDatabaseRequest
     * @return UpdateExternalPluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateExternalPluggableDatabase.ts.html |here} to see how to use UpdateExternalPluggableDatabase API.
     */
    updateExternalPluggableDatabase(updateExternalPluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateExternalPluggableDatabase.");
            const pathParams = {
                "{externalPluggableDatabaseId}": updateExternalPluggableDatabaseRequest.externalPluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateExternalPluggableDatabaseRequest.ifMatch,
                "opc-request-id": updateExternalPluggableDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateExternalPluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/externalpluggabledatabases/{externalPluggableDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateExternalPluggableDatabaseRequest.updateExternalPluggableDatabaseDetails, "UpdateExternalPluggableDatabaseDetails", model.UpdateExternalPluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "externalPluggableDatabase",
                    bodyModel: model.ExternalPluggableDatabase,
                    type: "model.ExternalPluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * If no database is associated with the key store, edit the key store.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateKeyStoreRequest
     * @return UpdateKeyStoreResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateKeyStore.ts.html |here} to see how to use UpdateKeyStore API.
     */
    updateKeyStore(updateKeyStoreRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateKeyStore.");
            const pathParams = {
                "{keyStoreId}": updateKeyStoreRequest.keyStoreId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateKeyStoreRequest.ifMatch,
                "opc-request-id": updateKeyStoreRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateKeyStoreRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/keyStores/{keyStoreId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateKeyStoreRequest.updateKeyStoreDetails, "UpdateKeyStoreDetails", model.UpdateKeyStoreDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "keyStore",
                    bodyModel: model.KeyStore,
                    type: "model.KeyStore",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the properties of a maintenance run, such as the state of a maintenance run.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateMaintenanceRunRequest
     * @return UpdateMaintenanceRunResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateMaintenanceRun.ts.html |here} to see how to use UpdateMaintenanceRun API.
     */
    updateMaintenanceRun(updateMaintenanceRunRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateMaintenanceRun.");
            const pathParams = {
                "{maintenanceRunId}": updateMaintenanceRunRequest.maintenanceRunId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateMaintenanceRunRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateMaintenanceRunRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/maintenanceRuns/{maintenanceRunId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateMaintenanceRunRequest.updateMaintenanceRunDetails, "UpdateMaintenanceRunDetails", model.UpdateMaintenanceRunDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "maintenanceRun",
                    bodyModel: model.MaintenanceRun,
                    type: "model.MaintenanceRun",
                    responseHeaders: [
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified pluggable database.
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdatePluggableDatabaseRequest
     * @return UpdatePluggableDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdatePluggableDatabase.ts.html |here} to see how to use UpdatePluggableDatabase API.
     */
    updatePluggableDatabase(updatePluggableDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updatePluggableDatabase.");
            const pathParams = {
                "{pluggableDatabaseId}": updatePluggableDatabaseRequest.pluggableDatabaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updatePluggableDatabaseRequest.ifMatch
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updatePluggableDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/pluggableDatabases/{pluggableDatabaseId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updatePluggableDatabaseRequest.updatePluggableDatabaseDetails, "UpdatePluggableDatabaseDetails", model.UpdatePluggableDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "pluggableDatabase",
                    bodyModel: model.PluggableDatabase,
                    type: "model.PluggableDatabase",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified VM cluster. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateVmClusterRequest
     * @return UpdateVmClusterResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateVmCluster.ts.html |here} to see how to use UpdateVmCluster API.
     */
    updateVmCluster(updateVmClusterRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateVmCluster.");
            const pathParams = {
                "{vmClusterId}": updateVmClusterRequest.vmClusterId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateVmClusterRequest.ifMatch,
                "opc-request-id": updateVmClusterRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateVmClusterRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/vmClusters/{vmClusterId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateVmClusterRequest.updateVmClusterDetails, "UpdateVmClusterDetails", model.UpdateVmClusterDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmCluster",
                    bodyModel: model.VmCluster,
                    type: "model.VmCluster",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Updates the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     * To update a cloud VM cluster in an Exadata Cloud Service instance, use the {@link #updateCloudVmCluster(UpdateCloudVmClusterRequest) updateCloudVmCluster} operation.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpdateVmClusterNetworkRequest
     * @return UpdateVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpdateVmClusterNetwork.ts.html |here} to see how to use UpdateVmClusterNetwork API.
     */
    updateVmClusterNetwork(updateVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#updateVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": updateVmClusterNetworkRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": updateVmClusterNetworkRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": updateVmClusterNetworkRequest.ifMatch,
                "opc-request-id": updateVmClusterNetworkRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, updateVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}",
                method: "PUT",
                bodyContent: common.ObjectSerializer.serialize(updateVmClusterNetworkRequest.updateVmClusterNetworkDetails, "UpdateVmClusterNetworkDetails", model.UpdateVmClusterNetworkDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterNetwork",
                    bodyModel: model.VmClusterNetwork,
                    type: "model.VmClusterNetwork",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Upgrades the specified Oracle Database instance.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param UpgradeDatabaseRequest
     * @return UpgradeDatabaseResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/UpgradeDatabase.ts.html |here} to see how to use UpgradeDatabase API.
     */
    upgradeDatabase(upgradeDatabaseRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#upgradeDatabase.");
            const pathParams = {
                "{databaseId}": upgradeDatabaseRequest.databaseId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "if-match": upgradeDatabaseRequest.ifMatch,
                "opc-request-id": upgradeDatabaseRequest.opcRequestId
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, upgradeDatabaseRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/databases/{databaseId}/actions/upgrade",
                method: "POST",
                bodyContent: common.ObjectSerializer.serialize(upgradeDatabaseRequest.upgradeDatabaseDetails, "UpgradeDatabaseDetails", model.UpgradeDatabaseDetails.getJsonObj),
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "database",
                    bodyModel: model.Database,
                    type: "model.Database",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
    /**
     * Validates the specified VM cluster network. Applies to Exadata Cloud@Customer instances only.
     *
     * This operation does not retry by default if the user has not defined a retry configuration.
     * @param ValidateVmClusterNetworkRequest
     * @return ValidateVmClusterNetworkResponse
     * @throws OciError when an error occurs
     * @example Click {@link https://docs.cloud.oracle.com/en-us/iaas/tools/typescript-sdk-examples/2.18.0/database/ValidateVmClusterNetwork.ts.html |here} to see how to use ValidateVmClusterNetwork API.
     */
    validateVmClusterNetwork(validateVmClusterNetworkRequest) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logger)
                this.logger.debug("Calling operation DatabaseClient#validateVmClusterNetwork.");
            const pathParams = {
                "{exadataInfrastructureId}": validateVmClusterNetworkRequest.exadataInfrastructureId,
                "{vmClusterNetworkId}": validateVmClusterNetworkRequest.vmClusterNetworkId
            };
            const queryParams = {};
            let headerParams = {
                "Content-Type": common.Constants.APPLICATION_JSON,
                "opc-request-id": validateVmClusterNetworkRequest.opcRequestId,
                "opc-retry-token": validateVmClusterNetworkRequest.opcRetryToken
            };
            const specRetryConfiguration = common.NoRetryConfigurationDetails;
            const retrier = oci_common_2.GenericRetrier.createPreferredRetrier(this._clientConfiguration ? this._clientConfiguration.retryConfiguration : undefined, validateVmClusterNetworkRequest.retryConfiguration, specRetryConfiguration);
            if (this.logger)
                retrier.logger = this.logger;
            const request = yield oci_common_2.composeRequest({
                baseEndpoint: this._endpoint,
                defaultHeaders: this._defaultHeaders,
                path: "/exadataInfrastructures/{exadataInfrastructureId}/vmClusterNetworks/{vmClusterNetworkId}/actions/validate",
                method: "POST",
                pathParams: pathParams,
                headerParams: headerParams,
                queryParams: queryParams
            });
            try {
                const response = yield retrier.makeServiceCall(this._httpClient, request);
                const sdkResponse = oci_common_2.composeResponse({
                    responseObject: {},
                    body: yield response.json(),
                    bodyKey: "vmClusterNetwork",
                    bodyModel: model.VmClusterNetwork,
                    type: "model.VmClusterNetwork",
                    responseHeaders: [
                        {
                            value: response.headers.get("opc-work-request-id"),
                            key: "opcWorkRequestId",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("etag"),
                            key: "etag",
                            dataType: "string"
                        },
                        {
                            value: response.headers.get("opc-request-id"),
                            key: "opcRequestId",
                            dataType: "string"
                        }
                    ]
                });
                return sdkResponse;
            }
            catch (err) {
                throw err;
            }
        });
    }
}
exports.DatabaseClient = DatabaseClient;
DatabaseClient.serviceEndpointTemplate = "https://database.{region}.{secondLevelDomain}";
DatabaseClient.endpointServiceName = "";
//# sourceMappingURL=client.js.map